/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2003 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include "tms.h"

/* This file has the source code to generate items. */

long random_adjust(long n)

/* Intuitively, n, give or take a little bit.  */

    {
    return 1 + (n * (100 + oner() + 2 * oner() + 3 * oner() + 4 * oner())) /
      100;
    }

struct small_item *prepare(struct level *this_level, struct small_item *i, long
  quality)
    {
    long temp;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) this_level);
    check_pointer((struct pointer_struct *) i);
#endif
    if (!(flag_check(i->flags, I_ALWAYS_NORMAL_QUALITY)))
        {
        if (trandom()%CHANCE_FINE == 0)
            small_item_make_fine(i);
        else
            if (trandom()%CHANCE_POOR == 0)
                small_item_make_poor(i);
        }
    if (i->number > 1)
        i->number = random_adjust(i->number);
    if (i->weight > 0)  /* should always be true, check there in */
                /* case I create dummy weightless items. */
        i->weight = random_adjust(i->weight);
    if (flag_check(i->flags, MAY_HAVE_COMPARTMENT))
        {
        if (trandom()%CHANCE_COMPARTMENT == 0)
            {
            flag_set(&i->flags, CONTAINER|CAN_OPEN);
            generate_contents(this_level, i);
            }
        }
    else if (flag_check(i->flags, CONTAINER))
        generate_contents(this_level, i);
    if ((flag_check(i->flags, LIQUID)) || (i->identity == INCENSE))
        {
        i = generate_container(this_level, i, quality);
        /* When we are done, i will point to the container, not the
        liquid.  This part should be last.  */
        }
    switch(i->identity)
        {
        case BOOK:
            i->writing = (struct text_struct *) calloc(1, sizeof(struct
              text_struct));
            i->writing->me = i->writing;
            i->writing->next = NULL;
            flag_set(&i->flags2, WRITING_IS_FILENAME);
            switch(trandom()%10)
                {
                case 0:
                    i->name = ST_BLUE_LEATHER_BOUND_BOOK;
                    strncpy(i->writing->text, FILE_BOOK_THE_WAY_OF_THE_WAY, 117);
                break;
                case 1:
                    i->name = ST_SMALL_BLACK_LEATHER_BOOK;
                    strncpy(i->writing->text, FILE_BOOK_KOANS, 117);
                break;
                case 2:
                    i->name = ST_ILLUMINATED_MANUSCRIPT;
                    strncpy(i->writing->text, FILE_BOOK_A_DREAM_OF_LIGHT, 117);
                break;
                case 3:
                    i->name = ST_LEATHERBOUND_BIBLE;
                    strncpy(i->writing->text, FILE_BOOK_BIBLE, 117);
                break;
                case 4:
                    i->name = ST_THIN_BOOK_WITH_A_DECORATED_SPINE;
                    strncpy(i->writing->text, FILE_BOOK_A_PICTURE_OF_EVIL, 117);
                break;
                case 5:
                    i->name = ST_BOOK_WITH_RAINBOW_CLOTH_COVER;
                    strncpy(i->writing->text, FILE_BOOK_CULTURES, 117);
                break;
                case 6:
                    i->name = ST_OLD_ROTTED_TOME;
                    strncpy(i->writing->text, FILE_BOOK_RIDDLES, 117);
                break;
                case 7:
                    i->name = ST_SMALL_JOURNAL;
                    free_text_struct(i->writing);
                    i->writing = NULL;
                    flag_set(&i->flags, CAN_WRITE_ON);
                    flag_reset(&i->flags2, WRITING_IS_FILENAME);
                break;
                case 8:
                    i->name = ST_SMALL_WHITE_BOOK;
                    strncpy(i->writing->text, FILE_BOOK_THE_NATURE_OF_A_SAINT, 117);
                break;
                case 9:
                    i->name = ST_A_LARGE_AND_WELL_WORN_BOOK;
                    strncpy(i->writing->text,
                      FILE_BOOK_THE_WRITINGS_OF_THE_ADVENTURERS, 117);
                    flag_set(&i->flags, CAN_WRITE_ON);
                    flag_set(&i->flags2, I_WRITE_ON_LOG);
                break;
                }
            if (i->writing != NULL)
                i->writing->text[117] = '\0';
        break;
        case FOOD:
            if (i->tname == NULL)
                {
                flag_reset(&i->flags2, SOME);
                switch(trandom() % 10)
                    {
                    case 0:
                        i->name = ST_BISCUITS;
                        flag_set(&i->flags2, SOME);
                    break;
                    case 1:
                        i->name = ST_BREAD;
                        flag_set(&i->flags2, SOME);
                    break;
                    case 2:
                        i->name = ST_CRAM;
                    break;
                    case 3:
                        i->name = ST_DRIED_BERRIES;
                        flag_set(&i->flags2, SOME);
                    break;
                    case 4:
                        i->name = ST_DRIED_FISH;
                        flag_set(&i->flags2, SOME);
                    break;
                    case 5:
                        i->name = ST_FIGS;
                        flag_set(&i->flags2, SOME);
                    break;
                    case 6:
                        i->name = ST_GUAVA;
                    break;
                    case 7:
                        i->name = ST_JERKY;
                        flag_set(&i->flags2, SOME);
                    break;
                    case 8:
                        i->name = ST_RAISINS;
                        flag_set(&i->flags2, SOME);
                    break;
                    case 9:
                        i->name = ST_SMOKED_BEEF;
                        flag_set(&i->flags2, SOME);
                    break;
                    }
                }
        break;
        case GEM:
            switch(trandom()%6)
                {
                case 0: i->name = ST_DIAMOND; i->value *= 10; break;
                case 1: i->name = ST_RUBY; break;
                case 2: i->name = ST_EMERALD; break;
                case 3: i->name = ST_STAR_SAPPHIRE; break;
                case 4: i->name = ST_TIGERS_EYE; break;
                case 5: i->name = ST_LAPIS_LAZULI; break;
                }
        break;
        case JEWELRY:
            switch(trandom()%6)
                {
                case 0: i->name = ST_FINELY_CRAFTED_SILVER_RING; break;
                case 1: i->name = ST_ANKLE_BRACELET; break;
                case 2: i->name = ST_GOLD_RING_WITH_A_LARGE_EMERALD; break;
                case 3: i->name = ST_IVORY_BRACELET; break;
                case 4: i->name = ST_GOLDEN_BROOCH; break;
                case 5: i->name = ST_PAIR_OF_RUBY_EARRINGS; break;
                }
        break;
        case MANUAL_OF_SKILL:
            temp = trandom() % NUM_SKILLS;
            i->other = temp;
            i->tname = (struct text_struct *) calloc(1, sizeof(struct
              text_struct));
            i->tname->me = i->tname;
#ifdef HAS_SNPRINTF
            snprintf(i->tname->text, 117, "manual of skill (%s)",
              skill_info[temp].name);
#else
            sprintf(i->tname->text, "manual of skill (%s)",
              skill_info[temp].name);
#endif
            i->tname->text[117] = '\0';
            flag_set(&i->flags2, DONT_PRINT_NAME_UNLESS_IDENTIFIED);
        break;
        case TREE_FRUIT:
            switch(trandom() % 6)
                {
                case 0:
                    i->name = ST_APPLE;
                break;
                case 1:
                    i->name = ST_FIGS;
                    flag_set(&i->flags2, SOME);
                break;
                case 2:
                    i->name = ST_GUAVA;
                break;
                case 3:
                    i->name = ST_ORANGE;
                break;
                case 4:
                    i->name = ST_PEACH;
                break;
                case 5:
                    i->name = ST_PEAR;
                break;
                }
        break;
        case WINE:
            switch(trandom() % 3)
                {
                case 0: case 1:
                    i->name = ST_RED_WINE;
                break;
                case 2:
                    i->name = ST_WHITE_WINE;
                break;
                }
        break;
        }
    return i;
    }

/* A nice feature, but apparently buggy; disabled by Jonathan Hayward 21 Mar 03
 * in order to prevent crashing. */
struct small_item *generate_contents(struct level *this_level, struct
  small_item *i)
    {
    struct small_item *contents;
    long addend, factor;
    return NULL;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) this_level);
    check_pointer((struct pointer_struct *) i);
#endif
    addend = DIST_NORMAL - DIST_FINE;
    if ((!(flag_check(i->flags, CONTAINER))) ||
      (!(orig_items[i->identity].space > 0)))
        /*perror("Error: attempted to put contents in object which couldn't hold them.")*/;
    else
        {
        if (trandom()%CHANCE_CONTENTS > 0)
            {
            if (!(flag_check(i->flags, HOLD_LIQUID)))
                {

/* We use a much smaller list of items in the case that the storage space of
the item is itself small.  We keep looking until we find an item small enough
to fit.*/

                if (orig_items[i->identity].space <= 5)
                    for(contents=generate_item(this_level,
                      TINY_ITEM_NORMAL+addend);(contents == NULL); contents =
                      generate_item(this_level, TINY_ITEM_NORMAL+addend))
                        {
                        if (!(contents == NULL))
                            if (orig_items[contents->identity].size >
                              orig_items[i->identity].space)
                                {
                                remove_item(this_level, contents);
                                contents = NULL;
                                }
                        }
                else
                    for(contents=generate_item(this_level,
                      BUILDING_ITEM_NORMAL+addend);(contents == NULL); contents
                      = generate_item(this_level, BUILDING_ITEM_NORMAL+addend))
                        {
                        if (!(contents == NULL))
                            if (orig_items[contents->identity].size >
                              orig_items[i->identity].space)
                                {
                                remove_item(this_level, contents);
                                contents = NULL;
                                }
                        }
                }
            else /* it's a liquid */
                {
                for(contents=generate_item(this_level, LIQUID_NORMAL+addend);
                  (contents==NULL); contents = generate_item(this_level,
                  LIQUID_NORMAL+addend))
                    {
                    if (!(contents==0))
                        if (orig_items[contents->identity].size > orig_items[i->identity].space)
                            {
                            remove_item(this_level, contents);
                            contents=NULL;
                            }
                    }
                if (orig_items[i->identity].space >= 2*
                  orig_items[contents->identity].size)
                    /* We can fit more of it in. */
                    {
                    factor = (orig_items[i->identity].space /
                      orig_items[contents->identity].size);
                    contents->number *= factor;
                    contents->uses *= factor;
                    contents->weight *= factor;
                    contents->value *= factor;
                    }
                }
            insert_internal(this_level, contents, i);
            }
        }
    return i;
    }

struct small_item *generate_container(struct level *this_level, struct
  small_item *i, long quality)
    {
    struct small_item *container;
    long addend, factor;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) this_level);
    check_pointer((struct pointer_struct *) i);
#endif
    addend=quality - DIST_NORMAL;

/* We choose a container appropriate to the item.  */

    switch (i->identity)
        {
        case COFFEE:
        case COFISA_TEA:
        case HELSRIANA_TEA:
        case POISON_WEAK: case POISON_MODERATE: case POISON_STRONG: case
          POISON_VERY_STRONG: case POISON_EXTREMELY_STRONG:
            /* High quality materials are always in a glass bottle.  */
            switch(trandom()%2 + addend)
                {
                case 0:
                    container = generate_item(this_level, FLASK);
                    break;
                default:
                    container = generate_item(this_level, BOTTLE);
                    break;
                }
        break;
        case ADRENALINE:
            container = generate_item(this_level, SYRINGE);
        break;
        case ANTIDOTE:
            container = generate_item(this_level, FLASK);
        break;
        case BEER:
        case CORDIAL:
        case PERFUME:
            container = generate_item(this_level, BOTTLE);
        break;
        case INCENSE:
        case SPICES:
            container = generate_item(this_level, POUCH);
        break;
        case JUICE:
            switch(trandom()%3 + 2 * addend)
                {
                case 0:
                    container = generate_item(this_level, SKIN);
                break;
                case 1:
                    container = generate_item(this_level, FLASK);
                break;
                default:
                    container = generate_item(this_level, BOTTLE);
                break;
                }
        break;
        case KHOOR:
        case OIL:
            container = generate_item(this_level, FLASK);
        break;
        case WATER:
            container = generate_item(this_level, SKIN);
        break;
        case WINE:
            switch(trandom()%2 + addend)
                {
                case 0:
                    container = generate_item(this_level, SKIN);
                break;
                default:
                    container = generate_item(this_level, BOTTLE);
                break;
                }
        break;
        default:
            perror("Error: container requested for inappropriate item.");
            container = generate_item(this_level, BACKPACK);
        break;
        }

/* If the container is too small, we enlarge it to contain the liquid.  Then we
insert it. */
    if (2*orig_items[i->identity].size < orig_items[container->identity].space)
    /* We can fit more of it in. */
        {
        factor = orig_items[container->identity].space /
          orig_items[i->identity].size;
        i->number *= factor;
        i->uses *= factor;
        i->weight *= factor;
        i->value *= factor;
        }
    insert_internal(this_level, i, container);
    return container;
    }

long my_insert(struct level *this_level, struct small_item *new_contents,
  struct small_item *container)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) this_level);
    check_pointer((struct pointer_struct *) new_contents);
    check_pointer((struct pointer_struct *) container);
#endif
    if (flag_check(container->flags, CONTAINER))
        {
        if (orig_items[container->identity].space - container->space_filled >=
          orig_items[new_contents->identity].size * new_contents->number)
            {
            insert_internal(this_level, new_contents, container);
            return 1;
            }
        else
            {
            return 0;
            }
        }
    else
        {
        return 0;
        }
    }

void insert_internal(struct level *this_level, struct small_item *new_contents,
  struct small_item *container)
    {
    struct ilist *current;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) this_level);
    check_pointer((struct pointer_struct *) new_contents);
    check_pointer((struct pointer_struct *) container);
#endif
    current=(struct ilist *) calloc(1, sizeof(struct ilist));
    current->me = current;
    current->next=container->contents;
    current->current=new_contents;
    container->contents=current;
    calc_item_stats(container);
    }

void remove_item(struct level *this_level, struct small_item *to_remove)
    {
    long i, j;
    struct clist *holder;
    struct ilist *previous, *current;

/* Remove the item from any level and creature inventory lists of items, before
   putting the item on the container's contents list, and updating its space
   and weight. */

    for(holder=this_level->creatures; (!(holder==NULL)); holder=holder->next)
#ifdef DEBUG
    check_pointer((struct pointer_struct *) this_level);
    check_pointer((struct pointer_struct *) to_remove);
#endif
        {
        if (!(holder->current->extended == NULL))
            {
            if (!(holder->current->extended->wear_wield==NULL))
                for(previous=current=holder->current->extended->wear_wield;
                  (!(current==NULL));current=current->next)
                    {
                    if (current->current==to_remove)
                        {
                        if (!(previous==current))
                            previous->next=current->next;
                        else
                            holder->current->extended->wear_wield=current->next;
                        previous=current->next;
                        free(current);
                        calc_ready(holder->current);
                        current=previous;
                        }
                    else
                        previous=current;
                    }
            if (!(holder->current->extended->pack==NULL))
                for(previous=current=holder->current->extended->pack;
                  (!(current==NULL));current=current->next)
                    {
                    if (current->current==to_remove)
                        {
                        if (!(previous==current))
                            previous->next=current->next;
                        else
                            holder->current->extended->pack=current->next;
                        previous=current->next;
                        free(current);
                        calc_ready(holder->current);
                        current=previous;
                        }
                    else
                        previous=current;
                    }
            }
        }
    for(i=0;i<MAX_X;++i)
        for(j=0;j<MAX_Y;++j)
            {
            if (!(this_level->space[i][j].items==NULL))
                for(previous=current=this_level->space[i][j].items;
                  (!(current==NULL));current=current->next)
                    {
                    if (current->current==to_remove)
                        {
                        if (!(previous==current))
                            previous->next=current->next;
                        else
                            this_level->space[i][j].items=current->next;
                        previous=current->next;
                        free(current);
                        current=previous;
                        }
                    else
                        previous=current;
                    }
            }
    free(to_remove);
    }

void calc_item_stats(struct small_item *i)
    {
    struct ilist *current;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) i);
#endif
    i->space_filled=i->weight_contained=0;
    if (!(i->contents==NULL))
        for(current=i->contents; (!(current==NULL)); current=current->next)
            {
            i->space_filled += orig_items[current->current->identity].size;
            i->weight_contained +=
              current->current->weight +
              current->current->weight_contained;
            }
    }


void make_poor(struct master_item *i)
    {
    flag_set(&i->flags, POOR_QUALITY);
    flag_reset(&i->flags, FINE_QUALITY);
    i->uses -= i->uses/2;
    i->maxuses -= i->maxuses/2;
    i->time *= 2;
    i->wa -= 5;
    if (i->po > 0)
        i->po -= 10;
    i->penalty *= 2;
    i->skill_adjust[0][0]-=5;
    i->skill_adjust[0][1]-=5;
    i->value /= 4;
    i->sharp /= 2;
    i->range /= 2;
    i->space /= 2;
    }

void make_fine(struct master_item *i)
    {
    flag_set(&i->flags, FINE_QUALITY);
    flag_reset(&i->flags, POOR_QUALITY);
    i->uses *= 2;
    i->maxuses *= 2;
    i->time /= 2;
    i->wa += 5;
    if (i->po > 0)
        i->po += 10;
    i->penalty /= 2;
    i->skill_adjust[0][0]+=5;
    i->skill_adjust[0][1]+=5;
    i->value *= 10;
    i->sharp *= 2;
    i->range *= 2;
    i->weight *=3;
    i->weight /= 4;
    }

void small_item_make_fine(struct small_item *i)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) i);
#endif
    if (flag_check(i->flags, POOR_QUALITY))
        small_item_make_normal(i);
    i->name = ST_DEFAULT;
    i->number = master_items[i->identity][MATRIX_FINE]->number;
    i->uses = master_items[i->identity][MATRIX_FINE]->uses;
    i->value = master_items[i->identity][MATRIX_FINE]->value;
    i->price = master_items[i->identity][MATRIX_FINE]->price;
    flag_set(&i->flags, FINE_QUALITY);
    i->other = master_items[i->identity][MATRIX_FINE]->other;
    }

void small_item_make_poor(struct small_item *i)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) i);
#endif
    i->name = ST_DEFAULT;
    i->number = master_items[i->identity][MATRIX_POOR]->number;
    i->uses = master_items[i->identity][MATRIX_POOR]->uses;
    i->value = master_items[i->identity][MATRIX_POOR]->value;
    i->price = master_items[i->identity][MATRIX_POOR]->price;
    flag_set(&i->flags, POOR_QUALITY);
    i->other = master_items[i->identity][MATRIX_POOR]->other;
    }

void small_item_make_normal(struct small_item *i)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) i);
#endif
    i->name = ST_DEFAULT;
    i->number = master_items[i->identity][MATRIX_NORMAL]->number;
    i->uses = master_items[i->identity][MATRIX_NORMAL]->uses;
    i->value = master_items[i->identity][MATRIX_NORMAL]->value;
    i->price = master_items[i->identity][MATRIX_NORMAL]->price;
    flag_reset(&i->flags, FINE_QUALITY);
    flag_set(&i->flags, POOR_QUALITY);
    i->other = master_items[i->identity][MATRIX_NORMAL]->other;
    }

void make_normal(struct master_item *i)
    {
    if (flag_check(i->flags, POOR_QUALITY))
        {
        flag_reset(&i->flags, POOR_QUALITY);
        /* Poor quality doesn't remove an item's single use */
        if (i->uses > 1)
            i->uses *= 2;
        if (i->maxuses > 1)
            i->maxuses *= 2;
        i->time /= 2;
        i->wa += 5;
        if (i->po > 0)
            i->po += 10;
        i->penalty /= 2;
        i->skill_adjust[0][0]+=5;
        i->skill_adjust[0][1]+=5;
        i->value *= 4;
        i->sharp *= 2;
        i->range *= 2;
        i->space *= 2;
        }
    if (flag_check(i->flags, FINE_QUALITY))
        {
        flag_reset(&i->flags, FINE_QUALITY);
        i->uses /= 2;
        i->maxuses /= 2;
        i->time *= 2;
        i->wa -= 5;
        if (i->po > 0)
            i->po -= 10;
        i->penalty *= 2;
        i->skill_adjust[0][0]-=5;
        i->skill_adjust[0][1]-=5;
        i->value /= 10;
        i->sharp /= 2;
        i->range /= 2;
        i->weight /=3;
        i->weight *= 4;
        }
    }

struct small_item *generate_item(struct level *this_level, long identity)
    {
    long id1, id2;
    struct small_item *result;
    struct ilist *this_ilist;
    long base, addend;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) this_level);
#endif
    result=NULL;
    if ((identity < 0) || (identity > MAX_ITEM_TYPE))
        {
        perror("Error: Attempt at creating out of range item!");
        }
    else
        {
        if (identity <= MAX_ITEM)
            {
            result=(struct small_item *) calloc(1, sizeof(struct small_item));
            result->me = result;
            result->identity = identity;
            result->name = ST_DEFAULT;
            result->tname = NULL;
            result->number = orig_items[identity].number;
            result->uses = orig_items[identity].uses;
            result->value = orig_items[identity].value;
            result->price = orig_items[identity].price;
            result->space_filled = 0;
            result->weight_contained = 0;
            result->weight = orig_items[identity].weight;
            result->flags = orig_items[identity].flags;
            result->flags2 = orig_items[identity].flags2;
            result->other = orig_items[identity].other;
            if (flag_check(result->flags2, IS_WEAPON))
                result->other = orig_items[identity].po;
            result->contents = NULL;
            result->writing = NULL;
            result->creatures = NULL;
            prepare(this_level, result, DIST_NORMAL);
            }
        else
            {

/* One of the item tables.  We keep track of what base table of item, and what
adjusts that base (_FINE, _NORMAL, etc.) */

            base = ARMOR_FINE + 3 * ((identity - ARMOR_FINE) / 3);
            addend = identity - base;
            switch(base)
                {
                case ARMOR_FINE: 
                    two_random_select(armor, &id1, &id2);
                break;
                case ART_FINE:
                    two_random_select(art, &id1, &id2);
                break;
                case DEVICE_FINE:
                    two_random_select(device, &id1, &id2);
                break;
                case FURNITURE_FINE:
                    two_random_select(furniture, &id1, &id2);
                break;
                case LIQUID_FINE:
                    two_random_select(liquid, &id1, &id2);
                break;
                case MUSICAL_INSTRUMENT_FINE:
                    two_random_select(musical_instrument, &id1, &id2);
                break;
                case NATURAL_FINE:
                    two_random_select(natural, &id1, &id2);
                break;
                case NON_DEVICE_EQUIPMENT_FINE:
                    two_random_select(non_device_equipment, &id1, &id2);
                break;
                case NON_EQUIPMENT_TREASURE_FINE:
                    two_random_select(non_equipment_treasure, &id1, &id2);
                break;
                case SUPPLIES_FINE:
                    two_random_select(supplies, &id1, &id2);
                break;
                case WEAPON_FINE:
                    two_random_select(weapon, &id1, &id2);
                break;
                case BUILDING_ITEM_FINE:
                    two_random_select(building_item, &id1, &id2);
                break;
                case DUNGEON_ITEM_FINE:
                    two_random_select(dungeon_item, &id1, &id2);
                break;
                case OUTDOORS_ITEM_FINE:
                    two_random_select(outdoors_item, &id1, &id2);
                break;
                case TINY_ITEM_FINE:
                    two_random_select(tiny_item, &id1, &id2);
                break;
                case BOOKSTORE_ITEM_FINE:
                    two_random_select(bookstore_item, &id1, &id2);
                break;
                case HERBALIST_ITEM_FINE:
                    two_random_select(herbalist_item, &id1, &id2);
                break;
                case JEWELLER_ITEM_FINE:
                    two_random_select(jeweller_item, &id1, &id2);
                break;
                case BOAT_FINE:
                    two_random_select(boat, &id1, &id2);
                break;
                default:
                    perror("Error: out of range calculated identity for probability distribution table.");
                break;
                }
            switch(addend)
                {
                case 0:
                    result=generate_item(this_level, id2);
                break;
                case 1:
                    result=generate_item(this_level, id1);
                break;
                case 2:
                    result=generate_item(this_level, id1);
                    small_item_make_normal(result);
                    small_item_make_fine(result);
                break;
                }
            }
        }
    this_ilist = (struct ilist *) calloc(1, sizeof(struct ilist));
    this_ilist->me = this_ilist;
    this_ilist->current = result;
    this_ilist->next = master_ilist;
    master_ilist = this_ilist;
    return result;
    }

void place_item(struct level *this_level, struct small_item *i, long x, long y)
    {
    struct ilist *item_slot;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) this_level);
    check_pointer((struct pointer_struct *) i);
#endif
    item_slot = (struct ilist *) calloc(1, sizeof(struct ilist));
    item_slot->me = item_slot;
    item_slot->current=i;
    item_slot->next=this_level->space[x][y].items;
    this_level->space[x][y].items=item_slot;
    }
