/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2003 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include <string.h>
#include "tms.h"

long board_game(long game_id)
    {
    struct puzzle_space_struct spaces[MAX_PUZZLE_X][MAX_PUZZLE_Y];
    long i, j, k, l, curr_x, curr_y, command, my_continue, win, opp_x, opp_y,
      num_player_spaces, num_opponent_spaces, strategic_value,
      best_strategic_value;
    curr_x = curr_y = win = 0;
    opp_x = opp_y = strategic_value = 0;
    clear();
    refresh();
    pmsg("You are now attempting to solve a puzzle; hit \'?\' for help...");
    /* initialize the puzzle.  */
    for(i=0;i<MAX_PUZZLE_X;++i)
        for(j=0;j<MAX_PUZZLE_Y;++j)
            {
            spaces[i][j].image = C_PUZZLE_AVAILABLE;
            spaces[i][j].flags = BOARD_AVAILABLE;
            spaces[i][j].strategic_value = 0;
            }
    /* Make a maze of unmarked squares if appropriate.  */
    if (game_id == PUZZLE_BOARD_HIDDEN_MAZE)
        {
        for(i=0;i<MAX_PUZZLE_X;++i)
            for(j=0;j<MAX_PUZZLE_Y;++j)
                flag_reset(&spaces[i][j].flags, BOARD_AVAILABLE);
        i = 1 + 2 * (trandom() % ((MAX_PUZZLE_X/2) - 1));
        j = 1 + 2 * (trandom() % ((MAX_PUZZLE_Y/2) - 1));
        flag_set(&spaces[i][j].flags, BOARD_MARKED);
        my_continue = 1;
        while (my_continue == 1)
            {
            for (i = 1; i <= 1 + (2 * ((MAX_PUZZLE_X/2) - 1) ); i += 2)
                for (j = 1; j < 1 + (2 * ((MAX_PUZZLE_Y/2) - 1) ); j += 2)
                    if (((flag_check(spaces[i][j].flags, BOARD_MARKED)) ^
                    (flag_check(spaces[i][j + 2].flags, BOARD_MARKED))) &&
                    (trandom() % 2 == 0))
                        {
                        flag_set(&spaces[i][j].flags, BOARD_MARKED);
                        flag_set(&spaces[i][j + 1].flags, BOARD_MARKED);
                        flag_set(&spaces[i][j + 2].flags, BOARD_MARKED);
                        }
            for (i = 1; i < 1 + (2 * ((MAX_PUZZLE_X/2) - 1) ); i += 2)
                for (j = 1; j <= 1 + (2 * ((MAX_PUZZLE_Y/2) - 1) ); j += 2)
                    if (((flag_check(spaces[i][j].flags, BOARD_MARKED)) ^
                      (flag_check(spaces[i + 2][j].flags, BOARD_MARKED))) &&
                      (trandom() % 2 == 0))
                        {
                        flag_set(&spaces[i][j].flags, BOARD_MARKED);
                        flag_set(&spaces[i + 1][j].flags, BOARD_MARKED);
                        flag_set(&spaces[i + 2][j].flags, BOARD_MARKED);
                        }
            my_continue = 0;
            for (i = 1; i <= (2 * ((MAX_PUZZLE_X/2) - 1) ); i += 2)
                for (j = 1; j <= (2 * ((MAX_PUZZLE_Y/2) - 1) ); j += 2)
                    if (!(flag_check(spaces[i][j].flags, BOARD_MARKED)))
                        my_continue = 1;
              }
        flag_set(&spaces[1][1 + (2 * ((MAX_PUZZLE_Y/2) - 1))].flags,
          BOARD_AVAILABLE);
        }
    curr_x = 0;
    curr_y = MAX_Y - 1;
    /* The main loop.  */
    for(my_continue=1;(my_continue);)
        {
        /* Draw the puzzle.  */
        for(i=0;i<MAX_PUZZLE_X;++i)
            for(j=0;j<MAX_PUZZLE_Y;++j)
                mvwaddch(puzzle, j, i, spaces[i][j].image);
        wmove(puzzle, curr_y, curr_x);
        wrefresh(puzzle);
        for(command=tgetc();(!((command=='.') || (command == ESCAPE)));
          command=tgetc())
            {
            switch(command)
                {
                case LEFT: case SECOND_LEFT: --curr_x; break;
                case DOWN: case SECOND_DOWN: ++curr_y; break;
                case UP: case SECOND_UP: --curr_y; break;
                case RIGHT: case SECOND_RIGHT: ++curr_x; break;
                case UP_LEFT: case SECOND_UP_LEFT: --curr_x; --curr_y; break;
                case UP_RIGHT: case SECOND_UP_RIGHT: ++curr_x; --curr_y; break;
                case DOWN_LEFT: case SECOND_DOWN_LEFT: --curr_x; ++curr_y;
                  break;
                case DOWN_RIGHT: case SECOND_DOWN_RIGHT: ++curr_x; ++curr_y;
                  break;
                case '?':
                    read_file(FILE_BOARD_PUZZLE_HELP);
                break;
                case ESCAPE: pmsg("Aborted."); break;
                }
            curr_x = max(curr_x, 0);
            curr_x = min(curr_x, MAX_PUZZLE_X - 1);
            curr_y = max(curr_y, 0);
            curr_y = min(curr_y, MAX_PUZZLE_Y - 1);
            wmove(puzzle, curr_y, curr_x);
            wrefresh(puzzle);
            }
        if (command == ESCAPE)
            my_continue = 0;
        else
            {
            if (!(flag_check(spaces[curr_x][curr_y].flags, BOARD_AVAILABLE)))
                pmsg("The machine will not let you move there.");
            else
                {
                spaces[curr_x][curr_y].image = C_PUZZLE_PLAYER;
                flag_reset(&spaces[curr_x][curr_y].flags, BOARD_AVAILABLE);
                flag_set(&spaces[curr_x][curr_y].flags, BOARD_JUST_ADDED);
                switch(game_id)
                    {
                    case PUZZLE_BOARD_HIDDEN_MAZE:
                        if ((curr_x == MAX_PUZZLE_X - 2) && (curr_y == 1))
                            {
                            my_continue = 0;
                            win = 1;
                            }
                    break;
                    case PUZZLE_BOARD_CONVERT_ADJACENT:
                        for(i = 0; i < MAX_PUZZLE_X; ++i)
                            for(j = 0; j < MAX_PUZZLE_Y; ++j)
                                if (flag_check(spaces[i][j].flags,
                                  BOARD_JUST_ADDED))
                                    {
                                    flag_reset(&spaces[i][j].flags,
                                      BOARD_JUST_ADDED);
                                    flag_set(&spaces[i][j].flags,
                                      BOARD_MARKED);
                                    }
                        for(i = max(0, curr_x - 1); i < min(MAX_PUZZLE_X,
                          curr_x + 2); ++i)
                            for(j = max(0, curr_y - 1); j < min(MAX_PUZZLE_Y,
                              curr_y + 2); ++j)
                                if (flag_check(spaces[i][j].flags,
                                  BOARD_MARKED))
                                    {
                                    flag_set(&spaces[i][j].flags,
                                      BOARD_JUST_ADDED);
                                    spaces[i][j].image = C_PUZZLE_PLAYER;
                                    }
                        for(i = 0; i < MAX_PUZZLE_X; ++i)
                            for(j = 0; j < MAX_PUZZLE_Y; ++j)
                                flag_reset(&spaces[i][j].flags, BOARD_MARKED);
                    break;
                    }
                /* Set the strategic value of each space to zero.  */
                for(i = 0; i < MAX_PUZZLE_X; ++i)
                    for (j = 0; j < MAX_PUZZLE_Y; ++j)
                        spaces[i][j].strategic_value = 0;
/*
 *
 * Pick next moves according to the puzzle.  This is, in general, a variant
 * on the theme of a sweeping 
 * of the board and looking at adjacent spaces.
 *
 */
                switch(game_id)
                    {
                    case PUZZLE_BOARD_COMPLETE_SQUARE:
                        for(i = 0; i < MAX_PUZZLE_X - 1; ++i)
                            for(j = 0; j < MAX_PUZZLE_Y - 1; ++j)
                                {
                                num_player_spaces = 0;
                                num_opponent_spaces = 0;
                                for(k = i; k < i + 2; ++k)
                                    for(l = j; l < j + 2; ++l)
                                        {
                                        if (spaces[k][l].image ==
                                          C_PUZZLE_PLAYER)
                                            ++num_player_spaces;
                                        if (spaces[k][l].image ==
                                          C_PUZZLE_OPPONENT)
                                            ++num_opponent_spaces;
                                        }
                                switch(num_opponent_spaces * 4 +
                                  num_player_spaces)
                                    {
                                    case 16:
                                        win = TRUE;
                                        my_continue = FALSE;
                                    break;
                                    case 12:
                                        strategic_value = 100;
                                    break;
                                    case 8:
                                        strategic_value = 10;
                                    break;
                                    case 4:
                                        strategic_value = 4;
                                    break;
                                    case 3:
                                        strategic_value = 20;
                                    break;
                                    case 2:
                                        strategic_value = 4;
                                    break;
                                    case 1:
                                        strategic_value = 2;
                                    break;
                                    case 0:
                                        strategic_value = 1;
                                    break;
                                    case 9: case 6: case 5:
                                    case 13: case 10: case 7:
                                        strategic_value = 0;
                                    break;
                                    }
                                for(k = i; k < i + 2; ++k)
                                    for(l = j; l < j + 2; ++l)
                                        spaces[k][l].strategic_value +=
                                          strategic_value;
                                }
                    break;
                    case PUZZLE_BOARD_CONVERT_ADJACENT:
                        for(i = 0; i < MAX_PUZZLE_X; ++i)
                            for(j = 0; j < MAX_PUZZLE_Y; ++j)
                                if (flag_check(spaces[i][j].flags, BOARD_AVAILABLE))
                                    for(k = max(0, i - 1); k <
                                      min(MAX_PUZZLE_X, i + 2); ++k)
                                        for(l = max(0, j - 1); l <
                                          min(MAX_PUZZLE_X, j + 2); ++l)
                                            if (((k != i) || (l != j)) &&
                                              (flag_check(spaces[k][l].flags,
                                              BOARD_JUST_ADDED)) &&
                                              (spaces[k][l].image ==
                                              C_PUZZLE_PLAYER))
                                                ++spaces[i][j].strategic_value;
                    break;
                    case PUZZLE_BOARD_HIDDEN_MAZE:
                        for(i=0;i<MAX_PUZZLE_X;++i)
                            for(j=0;j<MAX_PUZZLE_Y;++j)
                                for (k=i - 1; k < i + 2; ++k)
                                    for(l = j - 1; l < j + 2; ++l)
                                        if ((k >= 0) && (k <= MAX_PUZZLE_X - 1)
                                          && (l >= 0) &&
                                          (l <= MAX_PUZZLE_Y - 1) && (!((i ==
                                          k) && (j == l))))
                                            {
                                            if (spaces[k][l].image ==
                                              C_PUZZLE_PLAYER)
                                                {
                                                if (!(flag_check(
                                                  spaces[i][j].flags,
                                                  BOARD_MARKED)))
                                                    spaces[i][j].image =
                                                      C_PUZZLE_OPPONENT;
                                                else
                                                    flag_set(
                                                      &spaces[i][j].flags,
                                                      BOARD_AVAILABLE);
                                                }
                                            }
                    break;
                    case PUZZLE_BOARD_RANDOM:
                        opp_x = trandom() % MAX_PUZZLE_X;
                        opp_y = trandom() % MAX_PUZZLE_Y;
                        if (flag_check(spaces[opp_x][opp_y].flags,
                          BOARD_AVAILABLE))
                            {
                            spaces[opp_x][opp_y].image = C_PUZZLE_OPPONENT;
                            flag_reset(&spaces[opp_x][opp_y].flags,
                              BOARD_AVAILABLE);
                            }
                        else if (spaces[opp_x][opp_y].image == C_PUZZLE_PLAYER)
                            {
                            my_continue = FALSE;
                            win = TRUE;
                            }
                        else if (spaces[opp_x][opp_y].image ==
                          C_PUZZLE_OPPONENT)
                            {
                            my_continue = FALSE;
                            win = FALSE;
                            }
                        else
                            pmsg("Error in board_game");
                    break;
                    case PUZZLE_BOARD_SURROUND_OPPONENT:
                        for(i = 1; i < MAX_PUZZLE_X - 1; ++i)
                            for(j = 1; j < MAX_PUZZLE_Y - 1; ++j)
                                if (spaces[i][j].image == C_PUZZLE_PLAYER)
                                    {
                                    num_player_spaces = 0;
                                    num_opponent_spaces = 0;
                                    if (spaces[i+1][j].image == C_PUZZLE_PLAYER)
                                        ++num_player_spaces;
                                    if (spaces[i-1][j].image == C_PUZZLE_PLAYER)
                                        ++num_player_spaces;
                                    if (spaces[i][j+1].image == C_PUZZLE_PLAYER)
                                        ++num_player_spaces;
                                    if (spaces[i][j-1].image == C_PUZZLE_PLAYER)
                                        ++num_player_spaces;
                                    if (spaces[i+1][j].image ==
                                      C_PUZZLE_OPPONENT)
                                        ++num_opponent_spaces;
                                    if (spaces[i-1][j].image ==
                                      C_PUZZLE_OPPONENT)
                                        ++num_opponent_spaces;
                                    if (spaces[i][j+1].image ==
                                      C_PUZZLE_OPPONENT)
                                        ++num_opponent_spaces;
                                    if (spaces[i][j-1].image ==
                                      C_PUZZLE_OPPONENT)
                                        ++num_opponent_spaces;
                                    if (num_player_spaces == 0)
                                        {
                                        strategic_value = 1 +
                                          (num_opponent_spaces *
                                          num_opponent_spaces);
                                        spaces[i + 1][j].strategic_value +=
                                          strategic_value;
                                        spaces[i - 1][j].strategic_value +=
                                          strategic_value;
                                        spaces[i][j + 1].strategic_value +=
                                          strategic_value;
                                        spaces[i][j - 1].strategic_value +=
                                          strategic_value;
                                        }
                                    }
                    break;
                    }
                for(i = 0; i < MAX_PUZZLE_X; ++i)
                    for(j = 0; j < MAX_PUZZLE_Y; ++j)
                        if (!(flag_check(spaces[i][j].flags, BOARD_AVAILABLE)))
                            spaces[i][j].strategic_value = -1;
                switch(game_id)
                    {
                    case PUZZLE_BOARD_COMPLETE_SQUARE: case
                    PUZZLE_BOARD_CONVERT_ADJACENT: case
                    PUZZLE_BOARD_SURROUND_OPPONENT:
                        best_strategic_value = -1;
                        for(i = 0; i < MAX_PUZZLE_X; ++i)
                            for(j = 0; j < MAX_PUZZLE_Y; ++j)
                                if (spaces[i][j].strategic_value >
                                  best_strategic_value)
                                    {
                                    best_strategic_value =
                                      spaces[i][j].strategic_value;
                                    opp_x = i;
                                    opp_y = j;
                                    }
                        if (flag_check(spaces[opp_x][opp_y].flags,
                        BOARD_AVAILABLE))
                            {
                            flag_reset(&spaces[opp_x][opp_y].flags,
                              BOARD_AVAILABLE);
                            flag_set(&spaces[opp_x][opp_y].flags,
                              BOARD_JUST_ADDED);
                            spaces[opp_x][opp_y].image = C_PUZZLE_OPPONENT;
                            for(i = 0; i < MAX_PUZZLE_X; ++i)
                                for(j = 0; j < MAX_PUZZLE_Y; ++j)
                                    if (flag_check(spaces[i][j].flags,
                                      BOARD_JUST_ADDED))
                                        {
                                        flag_reset(&spaces[i][j].flags,
                                          BOARD_JUST_ADDED);
                                        flag_set(&spaces[i][j].flags,
                                          BOARD_MARKED);
                                        }
                            if (game_id == PUZZLE_BOARD_CONVERT_ADJACENT)
                                for(i = max(0, opp_x - 1); i < min(MAX_PUZZLE_X,
                                  opp_x + 2); ++i)
                                    for(j = max(0, opp_y - 1); j < min(MAX_PUZZLE_Y,
                                      opp_y + 2); ++j)
                                        if (flag_check(spaces[i][j].flags,
                                          BOARD_MARKED))
                                            {
                                            flag_set(&spaces[i][j].flags,
                                              BOARD_JUST_ADDED);
                                            spaces[i][j].image = C_PUZZLE_OPPONENT;
                                            }
                            for(i = 0; i < MAX_PUZZLE_X; ++i)
                                for(j = 0; j < MAX_PUZZLE_Y; ++j)
                                    flag_reset(&spaces[i][j].flags, BOARD_MARKED);
                            }
                        else /* All spaces are occupied, so we tally up.  */
                            {
                            num_player_spaces = 0;
                            num_opponent_spaces = 0;
                            for(i = 0; i < MAX_PUZZLE_X; ++i)
                                for(j = 0; j < MAX_PUZZLE_Y; ++j)
                                    {
                                    if (spaces[i][j].image == C_PUZZLE_PLAYER)
                                        ++num_player_spaces;
                                    if (spaces[i][j].image ==
                                      C_PUZZLE_OPPONENT)
                                        ++num_opponent_spaces;
                                    }
                            win = (num_player_spaces > num_opponent_spaces);
                            my_continue = FALSE;
                            }
                    break;
                    }
                }
            }
        switch(game_id)
            {
            case PUZZLE_BOARD_COMPLETE_SQUARE:
                for(i = 0; i < MAX_PUZZLE_X - 1; ++i)
                    for(j = 0; j < MAX_PUZZLE_Y - 1; ++j)
                        {
                        num_player_spaces = 0;
                        num_opponent_spaces = 0;
                        for(k = i; k < i + 2; ++k)
                            for(l = j; l < j + 2; ++l)
                                {
                                if (spaces[k][l].image ==
                                  C_PUZZLE_PLAYER)
                                    ++num_player_spaces;
                                if (spaces[k][l].image ==
                                  C_PUZZLE_OPPONENT)
                                    ++num_opponent_spaces;
                                }
                        if (num_player_spaces == 4)
                            {
                            win = TRUE;
                            my_continue = FALSE;
                            }
                        if (num_opponent_spaces == 4)
                            {
                            win = FALSE;
                            my_continue = FALSE;
                            }
                        }
            break;
            case PUZZLE_BOARD_SURROUND_OPPONENT:
                for(i = 1; i < MAX_PUZZLE_X - 1; ++i)
                    for(j = 1; j < MAX_PUZZLE_Y - 1; ++j)
                        if ((spaces[i][j].image == C_PUZZLE_PLAYER) ||
                          (spaces[i][j].image == C_PUZZLE_OPPONENT))
                            {
                            num_player_spaces = 0;
                            num_opponent_spaces = 0;
                            if (spaces[i+1][j].image == C_PUZZLE_PLAYER)
                                ++num_player_spaces;
                            if (spaces[i-1][j].image == C_PUZZLE_PLAYER)
                                ++num_player_spaces;
                            if (spaces[i][j+1].image == C_PUZZLE_PLAYER)
                                ++num_player_spaces;
                            if (spaces[i][j-1].image == C_PUZZLE_PLAYER)
                                ++num_player_spaces;
                            if (spaces[i+1][j].image ==
                              C_PUZZLE_OPPONENT)
                                ++num_opponent_spaces;
                            if (spaces[i-1][j].image ==
                              C_PUZZLE_OPPONENT)
                                ++num_opponent_spaces;
                            if (spaces[i][j+1].image ==
                              C_PUZZLE_OPPONENT)
                                ++num_opponent_spaces;
                            if (spaces[i][j-1].image ==
                              C_PUZZLE_OPPONENT)
                                ++num_opponent_spaces;
                            if ((spaces[i][j].image == C_PUZZLE_PLAYER) &&
                              (num_opponent_spaces == 4))
                                {
                                win = FALSE;
                                my_continue = FALSE;
                                }
                            if ((spaces[i][j].image == C_PUZZLE_OPPONENT) &&
                              (num_player_spaces == 4))
                                {
                                win = TRUE;
                                my_continue = FALSE;
                                }
                            }
            }
        }
    return win;
    }

long peg_game(long game_id)
    {
    char command;
    long pegs[NUM_PEGS];
    long i, j, k, my_continue, win, curr_peg, success;
    win = FALSE;
    for(i=0; i<NUM_PEGS;++i)
        pegs[i] = PEG_DOWN;
    clear();
    refresh();
    nocap_pmsg("You are trying to solve a puzzle; hit '?' for help...");
    my_continue = TRUE;
    while (my_continue)
        {
        for(i = 0; i < NUM_PEGS; ++i)
            {
            for(j = 0; j < PEG_GAME_IMAGE_Y; ++j)
                for(k = 0; k < PEG_GAME_IMAGE_X; ++k)
                    if (pegs[i] == PEG_UP)
                        mvwprintw(puzzle, j, i * (PEG_GAME_IMAGE_X - 1) + k,
                          "%c", up_peg_image[j][k]);
                    else
                        mvwprintw(puzzle, j, i * (PEG_GAME_IMAGE_X - 1) + k,
                          "%c", down_peg_image[j][k]);
            mvwprintw(puzzle, PEG_GAME_IMAGE_Y, ((1 + 2 * i) *
              (PEG_GAME_IMAGE_X - 1)) / 2, "%ld", i + 1);
            }
        wrefresh(puzzle);
        command = tgetc();
        if (command == '?')
            read_file(FILE_PEG_PUZZLE_HELP);
        else if ((0 <= command - '1') && (command - '1' < NUM_PEGS))
            {
            curr_peg = command - '1';
            success = TRUE;
            if (curr_peg > 0)
                switch(game_id)
                    {
                    case PUZZLE_PEG_ALL_BUT_LAST_DOWN:
                        for(i = 0; i < curr_peg; ++i)
                            if (i == curr_peg - 1)
                                success &= (pegs[i] == PEG_UP);
                            else
                                success &= (pegs[i] == PEG_DOWN);
                    break;
                    case PUZZLE_PEG_ALTERNATING:
                        for(i = 0; i < curr_peg; ++i)
                            success &= (pegs[i] != pegs[i + 1]);
                    break;
                    case PUZZLE_PEG_CHECKSUM:
                        if (curr_peg >= 2)
                            {
                            j = 0;
                            for(i = 0; i < curr_peg - 1; ++i)
                                if (pegs[i] == PEG_UP)
                                    ++j;
                            k = (pegs[curr_peg - 1] == PEG_UP);
                            success &= ((j % 2) == (k % 2));
                            }
                        else if (curr_peg == 1)
                            success &= (pegs[curr_peg - 1] == PEG_DOWN);
                    break;
                    case PUZZLE_PEG_RANDOM:
                        success = trandom() % 2;
                    break;
                    case PUZZLE_PEG_SYMMETRY:
                        for(i = 0; i < curr_peg; ++i)
                            success &= (pegs[i] == pegs[NUM_PEGS - i - 1]);
                    break;
                    }
            if (success)
                {
                if (pegs[curr_peg] == PEG_DOWN)
                    {
                    pmsg("The peg slides up.");
                    pegs[curr_peg] = PEG_UP;
                    }
                else
                    {
                    pmsg("The peg slides down.");
                    pegs[curr_peg] = PEG_DOWN;
                    }
                }
            else
                pmsg("The peg does not move.");
            win = TRUE;
            for(i = 0; i < NUM_PEGS; ++i)
                win &= (pegs[i] == PEG_UP);
            if (win)
                my_continue = FALSE;
            }
        else if (command == ESCAPE)
            my_continue = FALSE;
        else
            pmsg("Hit '?' for help...");
        }
    clear();
    return win;
    }

void char_riddle(char solution, char *result)
    {
    switch(solution)
        {
        case 'a': case 'A':
            switch(trandom()%2)
                {
                case 0:
                    strncpy(result, "WITH WHAT BEGINS APPLE", 255);
                break;
                case 1:
                    strncpy(result, "WITH WHAT ENDS THE SEA", 255);
                break;
                }
        break;
        case 'b': case 'B':
            strncpy(result, "WHAT BRINGS HONEY", 255);
        break;
        case 'c': case 'C':
            strncpy(result, "WHERE CAN YOU FIND ME WELL COUNT ONE TWO THREE", 255);
        break;
        case 'd': case 'D':
            strncpy(result, "NOT A BLIND BUMBLE BEE BUT RIGHT NEXT TO C", 255);
        break;
        case 'e': case 'E':
            strncpy(result, "WHERE IS MY HEAD SNUGGLED UP ALL COZY IN BED", 255);
        break;
        case 'f': case 'F':
            strncpy(result, "NOT A VOWEL BUT IN OF", 255);
        break;
        case 'g': case 'G':
            strncpy(result, "MAKE ONE WHERE AM I GONE", 255);
        break;
        case 'h': case 'H':
            strncpy(result, "TIS FOUND IN HEAR BUT NARY AN EAR", 255);
        break;
        case 'i': case 'I':
            strncpy(result, "IT RHYMES WITH AN EYE", 255);
        break;
        case 'j': case 'J':
            strncpy(result, "I OPEN JUST JARS", 255);
        break;
        case 'k': case 'K':
            strncpy(result, "I END EACH ATTACK", 255);
        break;
        case 'l': case 'L':
            strncpy(result, "IM FOUND IN A LAKE BUT NARY A SNAKE", 255);
        break;
        case 'm': case 'M':
            strncpy(result, "LETS START WITH THE DIFFERENCE BETWEEN ME AND YOU", 255);
        break;
        case 'n': case 'N':
            strncpy(result, "FIND ME INSIDE EVERY ANT", 255);
        break;
        case 'o': case 'O':
            strncpy(result, "I SCARE WITH A BOO YET SOOTHE THE DOVES COO", 255);
        break;
        case 'p': case 'P':
            strncpy(result, "WHEN I LOOK IN THE MIRROR TIS THE BEGINNING OF QUEER", 255);
        break;
        case 'q': case 'Q':
            strncpy(result, "AS QUITE QUEER I AM KNOWN", 255);
        break;
        case 'r': case 'R':
            strncpy(result, "I ROLL WITH EVERYONE WHO IS DROLL", 255);
        break;
        case 's': case 'S':
            strncpy(result, "WITH WHAT BEGINS SNAKE", 255);
        break;
        case 't': case 'T':
            strncpy(result, "I BEGIN TO TICKLE", 255);
        break;
        case 'u': case 'U':
            strncpy(result, "IM FOUND IN THE MIDDLE OF YOUTH", 255);
        break;
        case 'v': case 'V':
            strncpy(result, "IM NOT IN A HAT BUT IN EACH GREAT BIG VAT", 255);
        break;
        case 'w': case 'W':
            strncpy(result, "WHERE WILL YOU LOOK FOR ME AND WITH WHOM", 255);
        break;
        case 'x': case 'X':
            strncpy(result, "I AM THE CROSS WHICH DOES REPRESENT CHRIST", 255);
        break;
        case 'y': case 'Y':
            strncpy(result, "IM FOUND IN THE FRONT OF YOUR HAT", 255);
        break;
        case 'z': case 'Z':
            strncpy(result, "THE LAST LETTER OF ALL", 255);
        break;
        case '0':
            strncpy(result, "THE LEAST NUMBER OF PEARS YOU MAY HAVE", 255);
        break;
        case '1':
            strncpy(result, "NOT SOME NOT NONE", 255);
        break;
        case '2':
            strncpy(result, "TWICE THREE LESS FOUR", 255);
        break;
        case '3':
            strncpy(result, "IM ALMOST A TREE IM A NUMBER IM", 255);
        break;
        case '4':
            strncpy(result, "I AM ONE HALF OF EIGHT", 255);
        break;
        case '5':
            strncpy(result, "HOW MANY LIMBS HAS A HORSE", 255);
        break;
        case '6':
            strncpy(result, "HALF TWICE A DOZEN HALVED", 255);
        break;
        case '7':
            strncpy(result, "I AM OFT CALLED THE NUMBER OF HEAVEN", 255);
        break;
        case '8':
            strncpy(result, "I RHYME WITH A SKATE", 255);
        break;
        case '9':
            strncpy(result, "I AM FOUND JUST BEFORE TEN AND ELEVEN", 255);
        break;
        default:
            strncpy(result, "Error: char_riddle called on inappropriate \
character.", 255);
        break;
        }
    result[255] = '\0';
    }

void cryptogram(char *text, long cryptogram_id)
    {
    char tchar, tstring[256];
    long i, increase;
    switch(cryptogram_id)
        {
        case 0:
            increase = 1 + trandom() % 25;
            if (strlen(text) > 0)
                {
                    for(i = 0; i < strlen(text); ++i)
                    if ((('a' <= text[i]) && (text[i] + increase <= 'z')) ||
                      (('A' <= text[i]) && (text[i] + increase <= 'Z')))
                        text[i] += increase;
                    else
                        text[i] += (increase - 26);
                }
        break;
        case 1:
            if (strlen(text) > 1)
                    for(i=0;i<(strlen(text) - 1); ++i)
                    if (trandom() % 2 == 0)
                        {
                        tchar = text[i];
                        text[i] = text[i + 1];
                        text[i + 1] = tchar;
                        }
        break;
        case 2:
            for(i=0;i<strlen(text); ++i)
                tstring[strlen(text) - 1 - i] = text[i];
            for(i=0;i<strlen(text); ++i)
                text[i] = tstring[i];
        break;
        case 3:
            cryptogram(text, trandom() % 3);
        break;
        case 4:
            /* Do nothing.  */
        break;
        default:
            pmsg("Error; cryptogram called with inappropriate ID");
        break;
        }
    }

struct text_struct *new_cryptogram(void)
    {
    struct text_struct *curr_text_struct, *new_text_struct, *result;
    long i, password_length, cryptogram_type;
    curr_text_struct = (struct text_struct *) calloc(1, sizeof(struct
      text_struct));
    curr_text_struct->me = curr_text_struct;
    curr_text_struct->next = NULL;
    password_length = 2;
    while (trandom() % 2)
        ++password_length;
    for(i=0;i<password_length; ++i)
        if (trandom() % 4)
            curr_text_struct->text[i] = 'A' + trandom() % 26;
        else
            curr_text_struct->text[i] = '0' + trandom() % 10;
    curr_text_struct->text[password_length] = 0;
    result = curr_text_struct;
    cryptogram_type = trandom() % 5;
    for(i=0; i < password_length; ++i)
        {
        new_text_struct = (struct text_struct *) calloc(1, sizeof(struct
          text_struct));
        new_text_struct->me = new_text_struct;
        curr_text_struct->next = new_text_struct;
        new_text_struct->next = NULL;
        char_riddle(result->text[i], new_text_struct->text);
        cryptogram(new_text_struct->text, cryptogram_type);
        curr_text_struct = new_text_struct;
        }
    return result;
    }

long cryptogram_machine(struct text_struct *cryptogram)
    {
    char guess[256];
    pmsg("You are at a machine with a keyboard, and a sign above the keyboard.");
    pmsg("The sign reads:");
    pmsg("");
    top_text_read_text_struct(cryptogram->next);
    pmsg("");
    pmsg("Do you wish to type anything into the keyboard?");
    if (confirm_silent())
        {
        pmsg("What do you wish to type in?");
        tgets(guess);
        if (!(strcasecmp(guess, cryptogram->text)))
            return TRUE;
        else
            return FALSE;
        }
    else
        {
        pmsg("You back away.");
        return FALSE;
        }
    }
