/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2003 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include "tms.h"
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

void save(char *save_filename)
    {
    char message[256];
    long my_continue;
    struct clist *ctraverse;
    struct ilist *itraverse;
    struct llist *ltraverse;
    /* Eventually have it prompt user for savefile name.  */
    /* Eventually do error checking.  */
    char new_save_filename[256];
    int save_file;
    my_continue = 0;
#ifdef HAS_SNPRINTF
    snprintf(message, 255, "Save as file %s?", save_filename);
#else
    sprintf(message, "Save as file %s?", save_filename);
#endif
    message[255] = '\0';
    pmsg(message);
    if (confirm_silent())
        {
        pmsg("Saving...");
        strncpy(new_save_filename, save_filename, 255);
        new_save_filename[255] = '\0';
        my_continue = 1;
        }
    else
        {
        pmsg("Save as different file?");
        if (confirm_silent())
            {
            pmsg("Please type the name of the file you would like to save as.");
            tgets(new_save_filename);
            pmsg("Saving...");
            my_continue = 1;
            }
        else
            pmsg("Continuing with game play...");
        }
#ifdef MSDOS
    unlink(new_save_filename);
#endif
    save_file=open(new_save_filename, O_WRONLY | O_CREAT | O_TRUNC, 0600);
    if (save_file == -1)
        pmsg("Error: could not open save file.");
    else if (my_continue)
        {
        /* First we write special pointers.  */
        write(save_file, &player, sizeof(player));
        write(save_file, &current_level, sizeof(current_level));
        write(save_file, &countryside, sizeof(countryside));
        write(save_file, &main_city, sizeof(main_city));
        write(save_file, &game_variables, sizeof(game_variables));
        write(save_file, &master_llist, sizeof(master_llist));
        write(save_file, &master_clist, sizeof(master_clist));
        write(save_file, &master_ilist, sizeof(master_ilist));
        /* Then we write down the data: first a long telling us what kind of */
        /* data we have, then the pointer to the data structure, then the raw */
        /* contents of the data_structure itself */
        if (!(master_llist == NULL))
            {
            for(ltraverse = master_llist; (!(ltraverse == NULL)); ltraverse =
              ltraverse->next)
                write_level(save_file, ltraverse->current);
            write_llist(save_file, master_llist);
            }
        if (!(master_clist == NULL))
            {
            for(ctraverse = master_clist; (!(ctraverse == NULL)); ctraverse =
              ctraverse->next)
            if (ctraverse->current != NULL)
                write_small_creature(save_file, ctraverse->current);
            write_clist(save_file, master_clist);
            }
        if (!(master_ilist == NULL))
            {
            for(itraverse = master_ilist; (!(itraverse == NULL)); itraverse =
              itraverse->next)
            if (itraverse->current != NULL)
                write_small_item(save_file, itraverse->current);
            write_ilist(save_file, master_ilist);
            }
        write_game_variables_struct(save_file, game_variables);
        clear();
        refresh();
        close(save_file);
        my_finish(0);
        }
    }

void restore(char *save_filename)
    {
    long i, j;
    struct pointer_struct *temp_player, *temp_current_level, *temp_countryside,
        *temp_main_city, *temp_game_variables, *temp_master_llist,
        *temp_master_clist, *temp_master_ilist, *traverse;
    struct clist *this_clist;
    struct faith_struct *this_faith_struct;
    struct ilist *this_ilist;
    struct level *this_level;
    struct light_source_struct *this_light_source;
    struct llist *this_llist;
    struct master_creature *this_master_creature;
    struct shop_struct *this_shop_struct;
    struct small_creature *this_small_creature;
    struct small_item *this_small_item;
    struct special_struct *this_special_struct;
    struct text_struct *this_text_struct;
    int save_file;
    master_pointers = NULL;
    pmsg("Restoring; one moment, please...");
    save_file=open( save_filename, O_RDONLY , 0600 );
    if (save_file == -1)
        {
        pmsg("Error: could not open save file.  Aborting...");
    morewait();
        my_finish(1);
        }
    else
        {
        /* First we read special pointers.  */
        read(save_file, &temp_player, sizeof(temp_player));
        read(save_file, &temp_current_level, sizeof(temp_current_level));
        read(save_file, &temp_countryside, sizeof(temp_countryside));
        read(save_file, &temp_main_city, sizeof(temp_main_city));
        read(save_file, &temp_game_variables, sizeof(temp_game_variables));
        read(save_file, &temp_master_llist, sizeof(temp_master_llist));
        read(save_file, &temp_master_clist, sizeof(temp_master_clist));
        read(save_file, &temp_master_ilist, sizeof(temp_master_ilist));
        /* Then we read the data, old pointers and all.  */
        while (read_datum(save_file));
        /* Then we correct the pointers.  */
        if (master_pointers == NULL)
            {
            pmsg("Error: invalid save file.  Aborting...");
        morewait();
            my_finish(1);
            }
        else
            {
            for(traverse = master_pointers; (!(traverse == NULL)); traverse = traverse->next)
                switch(traverse->data_type)
                    {
                    case CLIST:
                        this_clist = (struct clist *) traverse->new_address;
                        this_clist->current =
                          (struct small_creature *)
                          get_new_pointer((struct pointer_struct *)
                          this_clist->current);
                        if (!(this_clist->next == NULL))
                            this_clist->next = (struct clist *)
                              get_new_pointer((struct pointer_struct *)
                              this_clist->next);
                    break;
                    case FAITH_STRUCT:
                        this_faith_struct = (struct faith_struct *)
                          traverse->new_address;
                        if (this_faith_struct->breath_prayer != NULL)
                            this_faith_struct->breath_prayer =
                              (struct text_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_faith_struct->breath_prayer);
                    break;
                    case ILIST:
                        this_ilist = (struct ilist *) traverse->new_address;
                        this_ilist->current = (struct small_item *)
                          get_new_pointer((struct pointer_struct *)
                          this_ilist->current);
                        if (!(this_ilist->next == NULL))
                            this_ilist->next = (struct ilist *)
                              get_new_pointer((struct pointer_struct *)
                              this_ilist->next);
                    break;
                    case LEVEL:
                        this_level = (struct level *) traverse->new_address;
                        for(i = 0; i < MAX_X; ++i)
                            for(j = 0; j < MAX_Y; ++j)
                                {
                                if (this_level->space[i][j].creatures != NULL)
                                    this_level->space[i][j].creatures =
                                      (struct clist *) get_new_pointer(
                                      (struct pointer_struct *)
                                      this_level->space[i][j].creatures);
                                if (this_level->space[i][j].items != NULL)
                                    this_level->space[i][j].items =
                                      (struct ilist *) get_new_pointer(
                                      (struct pointer_struct *)
                                      this_level->space[i][j].items);
                                if (this_level->space[i][j].special != NULL)
                                    this_level->space[i][j].special =
                                      (struct special_struct *)
                                      get_new_pointer(
                                      (struct pointer_struct *)
                                      this_level->space[i][j].special);
                                }
                        if (!(this_level->light_sources == NULL))
                            this_level->light_sources =
                                (struct light_source_struct *)
                                  get_new_pointer((struct pointer_struct *)
                                  this_level->light_sources);
                        if (!(this_level->creatures == NULL))
                            this_level->creatures = (struct clist *)
                              get_new_pointer((struct pointer_struct *)
                              this_level->creatures);
                    break;
                    case LIGHT_SOURCE_STRUCT:
                        this_light_source = (struct light_source_struct *)
                          traverse->new_address;
                        this_light_source->me = this_light_source;
                        if (this_light_source->holder != NULL)
                            this_light_source->holder = (struct
                              small_creature *) get_new_pointer((struct
                              pointer_struct *) this_light_source->holder);
                        if (!(this_light_source->next == NULL))
                            this_light_source->next = (struct
                              light_source_struct *) get_new_pointer((struct
                              pointer_struct *) this_light_source->next);
                    break;
                    case LLIST:
                        this_llist = (struct llist *) traverse->new_address;
                        this_llist->current = (struct level *)
                          get_new_pointer((struct pointer_struct *)
                          this_llist->current);
                        if (!(this_llist->next == NULL))
                            this_llist->next = (struct llist *)
                              get_new_pointer((struct pointer_struct *)
                              this_llist->next);
                    break;
                    case MASTER_CREATURE:
                        this_master_creature = (struct master_creature *)
                          traverse->new_address;
                        if (!(this_master_creature->mount == NULL))
                            this_master_creature->mount =
                              (struct small_creature *)
                              get_new_pointer((struct pointer_struct *)
                              this_master_creature->mount);
                        if (!(this_master_creature->wear_wield == NULL))
                            this_master_creature->wear_wield =
                              (struct ilist *)
                              get_new_pointer((struct pointer_struct *)
                              this_master_creature->wear_wield);
                        if (!(this_master_creature->pack == NULL))
                            this_master_creature->pack =
                              (struct ilist *)
                              get_new_pointer((struct pointer_struct *)
                              this_master_creature->pack);
                        if (!(this_master_creature->stati == NULL))
                            this_master_creature->stati = (struct adj_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_master_creature->stati);
                        if (!(this_master_creature->skills == NULL))
                            this_master_creature->skills =
                              (struct skills_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_master_creature->skills);
                        if (this_master_creature->faith != NULL)
                            this_master_creature->faith =
                              (struct faith_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_master_creature->faith);
                    break;
                    case SHOP_STRUCT:
                        this_shop_struct = (struct shop_struct *)
                          traverse->new_address;
                        if (!(this_shop_struct->items == NULL))
                            this_shop_struct->items = (struct ilist *)
                              get_new_pointer((struct pointer_struct *)
                              this_shop_struct->items);
                        if (!(this_shop_struct->creatures == NULL))
                            this_shop_struct->creatures = (struct clist *)
                              get_new_pointer((struct pointer_struct *)
                              this_shop_struct->creatures);
                        break;
                    case SMALL_CREATURE:
                        this_small_creature = (struct small_creature *)
                          traverse->new_address;
                        if (!(this_small_creature->name == NULL))
                            this_small_creature->name = (struct text_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_small_creature->name);
                        if (!(this_small_creature->follow == NULL))
                            this_small_creature->follow = (struct clist *)
                              get_new_pointer((struct pointer_struct *)
                              this_small_creature->follow);
                        if (!(this_small_creature->followed_by == NULL))
                            this_small_creature->followed_by = (struct clist *)
                              get_new_pointer((struct pointer_struct *)
                              this_small_creature->followed_by);
                        if (!(this_small_creature->hostile == NULL))
                            this_small_creature->hostile = (struct clist *)
                              get_new_pointer((struct pointer_struct *)
                              this_small_creature->hostile);
                        if (!(this_small_creature->extended == NULL))
                            this_small_creature->extended =
                              (struct master_creature *)
                              get_new_pointer((struct pointer_struct *)
                              this_small_creature->extended);
                    break;
                    case SMALL_ITEM:
                        this_small_item = (struct small_item *)
                          traverse->new_address;
                        if (!(this_small_item->tname == NULL))
                            this_small_item->tname = (struct text_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_small_item->tname);
                        if (!(this_small_item->contents == NULL))
                            this_small_item->contents = (struct ilist *)
                              get_new_pointer((struct pointer_struct *)
                              this_small_item->contents);
                        if (!(this_small_item->writing == NULL))
                            this_small_item->writing = (struct text_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_small_item->writing);
                        if (this_small_item->creatures != NULL)
                            this_small_item->creatures = (struct clist *)
                              get_new_pointer((struct pointer_struct *)
                              this_small_item->creatures);
                    break;
                    case SPECIAL_STRUCT:
                        this_special_struct = (struct special_struct *)
                          traverse->new_address;
                        if (!(this_special_struct->shop == NULL))
                            this_special_struct->shop = (struct shop_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_special_struct->shop);
                        if (!(this_special_struct->takes_player_to == NULL))
                            this_special_struct->takes_player_to =
                              (struct level *)
                              get_new_pointer((struct pointer_struct *)
                              this_special_struct->takes_player_to);
                        if (this_special_struct->text != NULL)
                            this_special_struct->text = (struct text_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_special_struct->text);
                        if (this_special_struct->establishment != NULL)
                            this_special_struct->establishment =
                              (struct establishment_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_special_struct->establishment);
                    break;
                    case TEXT_STRUCT:
                        this_text_struct = (struct text_struct *)
                          traverse->new_address;
                        if (!(this_text_struct->next == NULL))
                            this_text_struct->next = (struct text_struct *)
                              get_new_pointer((struct pointer_struct *)
                              this_text_struct->next);
                    break;
                    }
            player = (struct small_creature *) get_new_pointer(
              (struct pointer_struct *) temp_player);
            current_level = (struct level *) get_new_pointer(
              (struct pointer_struct *) temp_current_level);
            countryside = (struct level *) get_new_pointer(
              (struct pointer_struct *) temp_countryside);
            main_city = (struct level *) get_new_pointer((struct pointer_struct
              *) temp_main_city);
            free(game_variables);
            game_variables = (struct game_variables_struct *)
              get_new_pointer((struct pointer_struct *) temp_game_variables);
            master_llist = (struct llist *) get_new_pointer
              ((struct pointer_struct *) temp_master_llist);
            master_clist = (struct clist *) get_new_pointer
              ((struct pointer_struct *) temp_master_clist);
            master_ilist = (struct ilist *) get_new_pointer
              ((struct pointer_struct *) temp_master_ilist);
            }
        }
    unlink(save_filename);
    /* system(message); */
    }

void write_level(int save_file, struct level *this_level)
    {
    long data_type, i, j;
    struct level* new_level;
    data_type = LEVEL;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_level, sizeof(this_level));
    if (this_level->me != this_level)
        {
        /*
        new_level = dig_level(LEVEL_URVANOVESTILLI_PLAINS, 0, 0, 0);
        */
        new_level = calloc(1, sizeof(struct level));
        write(save_file, new_level, sizeof(*new_level));
        return;
        }
    write(save_file, this_level, sizeof(*this_level));
    for(i=0;i<MAX_X; ++i)
        for(j = 0; j < MAX_Y; ++j)
            {
            if (!(this_level->space[i][j].creatures==NULL))
                write_clist(save_file, this_level->space[i][j].creatures);
            if (!(this_level->space[i][j].items == NULL))
                write_ilist(save_file, this_level->space[i][j].items);
            if (!(this_level->space[i][j].special == NULL))
                write_special_struct(save_file,
                  this_level->space[i][j].special);
            }
    if (!(this_level->light_sources == NULL))
        write_light_sources(save_file, this_level->light_sources);
    if (!(this_level->creatures == NULL))
        write_clist(save_file, this_level->creatures);
    }

void write_light_sources(int save_file, struct light_source_struct
  *this_light_source_struct)
    {
    long data_type;
    struct light_source_struct* new_light_source_struct;
    data_type = LIGHT_SOURCE_STRUCT;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_light_source_struct,
      sizeof(this_light_source_struct));
    if ((long) this_light_source_struct <= 0xff || this_light_source_struct->me != this_light_source_struct)
        {
        new_light_source_struct = calloc(1, sizeof(struct
          light_source_struct));
        write(save_file, new_light_source_struct,
          sizeof(*new_light_source_struct));
        return;
        }
    write(save_file, this_light_source_struct,
      sizeof(*this_light_source_struct));
    if (!(this_light_source_struct->next == NULL))
        write_light_sources(save_file, this_light_source_struct->next);
    }

/* Write a list of creatures, but not the creatures themselves.  */

void write_clist(int save_file, struct clist *this_clist)
    {
    long data_type;
    struct clist *traverse;
    struct clist* new_clist;
    data_type = CLIST;
    if (!(this_clist == NULL))
    {
        for(traverse = this_clist; (!(traverse == NULL)); traverse =
          traverse->next)
            {
            write(save_file, &data_type, sizeof(data_type));
            write(save_file, &traverse, sizeof(traverse));
        if (traverse->me != traverse)
            {
            new_clist = calloc(1, sizeof(struct clist));
            write(save_file, new_clist, sizeof(*new_clist));
            return;
            }
            write(save_file, traverse, sizeof(*traverse));
            }
    }
    }

/* Write out the menu info for an eating/drinking establishment.  */

void write_establishment_struct(int save_file, struct establishment_struct
  *this_establishment_struct)
    {
    long data_type;
    struct establishment_struct* new_establishment_struct;
    data_type = ESTABLISHMENT_STRUCT;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_establishment_struct,
      sizeof(this_establishment_struct));
    if (this_establishment_struct->me != this_establishment_struct)
        {
        new_establishment_struct = calloc(1, sizeof(struct
          establishment_struct));
        write(save_file, new_establishment_struct,
          sizeof(*new_establishment_struct));
        return;
        }
    write(save_file, this_establishment_struct,
      sizeof(*this_establishment_struct));
    }

/* Write a list of items, but not the items themselves.  */

void write_ilist(int save_file, struct ilist *this_ilist)
    {
    long data_type;
    struct ilist *traverse;
    struct ilist* new_ilist;
    data_type = ILIST;
    if (!(this_ilist == NULL))
    {
        for(traverse = this_ilist; (!(traverse == NULL)); traverse =
          traverse->next)
            {
            write(save_file, &data_type, sizeof(data_type));
            write(save_file, &traverse, sizeof(traverse));
        if (traverse->me != traverse)
            {
            new_ilist = calloc(1, sizeof(struct ilist));
            write(save_file, new_ilist, sizeof(*new_ilist));
            return;
            }
            write(save_file, traverse, sizeof(*traverse));
            }
    }
    }

/* Write a list of levels, but not the levels themselves.  */

void write_llist(int save_file, struct llist *this_llist)
    {
    long data_type;
    struct llist *traverse;
    struct llist* new_llist;
    data_type = LLIST;
    if (!(this_llist == NULL))
    {
        for(traverse = this_llist; (!(traverse == NULL)); traverse =
          traverse->next)
            {
            write(save_file, &data_type, sizeof(data_type));
            write(save_file, &traverse, sizeof(traverse));
        if (traverse->me != traverse)
            {
            new_llist = calloc(1, sizeof(struct llist));
            write(save_file, new_llist, sizeof(*new_llist));
            return;
            }
            write(save_file, traverse, sizeof(*traverse));
            }
    }
    }

/* Write a special struct and its shop, but not a level pointed to.  */

void write_special_struct(int save_file, struct special_struct
  *this_special_struct)
    {
    long data_type;
    struct special_struct* new_special_struct;
    data_type = SPECIAL_STRUCT;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_special_struct, sizeof(this_special_struct));
    if (this_special_struct->me != this_special_struct)
        {
        /*
        new_special_struct = new_special();
        */
        new_special_struct = calloc(1, sizeof(new_special_struct));
        write(save_file, new_special_struct, sizeof(*new_special_struct));
        return;
        }
    write(save_file, this_special_struct, sizeof(*this_special_struct));
    if (!(this_special_struct->shop == NULL))
        write_shop_struct(save_file, this_special_struct->shop);
    if (this_special_struct->establishment != NULL)
        write_establishment_struct(save_file, this_special_struct->
          establishment);
    if (this_special_struct->text != NULL)
        write_text_struct(save_file, this_special_struct->text);
    }

/* Write a shop and list its inventory, but don't print out the actual */
/* creatures and items.  */

void write_shop_struct(int save_file, struct shop_struct *this_shop_struct)
    {
    long data_type;
    struct shop_struct* new_shop_struct;
    data_type = SHOP_STRUCT;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_shop_struct, sizeof(this_shop_struct));
    if (this_shop_struct->me != this_shop_struct)
        {
        new_shop_struct = calloc(1, sizeof(struct shop_struct));
        write(save_file, new_shop_struct, sizeof(*new_shop_struct));
        return;
        }
    write(save_file, this_shop_struct, sizeof(*this_shop_struct));
    if (!(this_shop_struct->items == NULL))
        write_ilist(save_file, this_shop_struct->items);
    if (!(this_shop_struct->creatures == NULL))
        write_clist(save_file, this_shop_struct->creatures);
    }

void write_small_creature(int save_file, struct small_creature *this_creature)
    {
    long data_type;
    struct small_creature* new_small_creature;
    data_type = SMALL_CREATURE;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_creature, sizeof(this_creature));
    if (this_creature->me != this_creature)
        {
        /*
        new_small_creature = make_random_creature(FIRST_ANIMAL);
        */
        new_small_creature = calloc(1, sizeof(struct small_creature));
        write(save_file, new_small_creature, sizeof(*new_small_creature));
        return;
        }
    write(save_file, this_creature, sizeof(*this_creature));
    if (!(this_creature->name == NULL))
        write_text_struct(save_file, this_creature->name);
    if (!(this_creature->follow == NULL))
        write_clist(save_file, this_creature->follow);
    if (!(this_creature->followed_by == NULL))
        write_clist(save_file, this_creature->followed_by);
    if (!(this_creature->hostile == NULL))
        write_clist(save_file, this_creature->hostile);
    if (!(this_creature->extended == NULL))
        write_master_creature(save_file, this_creature->extended);
    }

void write_text_struct(int save_file, struct text_struct *this_text_struct)
    {
    long data_type;
    struct text_struct* new_text_struct;
    data_type = TEXT_STRUCT;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_text_struct, sizeof(this_text_struct));
    if (this_text_struct->me != this_text_struct)
        {
        new_text_struct = calloc(1, sizeof(struct text_struct));
        write(save_file, new_text_struct, sizeof(*new_text_struct));
        return;
        }
    write(save_file, this_text_struct, sizeof(*this_text_struct));
    if (!(this_text_struct->next == NULL))
        write_text_struct(save_file, this_text_struct->next);
    }

/* Write a master creature and its inventory, stati, and skills, but not its */
/* mount.  There is no error checking because I was boneheaded and left out  */
/* 'me' member such as I gave to other structures. This shouldn't be too     */
/* of a problem as data corruption has only been observed with small_items   */
/* and is purely a precaution for other items. -Jonathan, 23 March 2003      */

void write_master_creature(int save_file, struct master_creature
  *this_master_creature)
    {
    long data_type;
    data_type = MASTER_CREATURE;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_master_creature, sizeof(this_master_creature));
    write(save_file, this_master_creature, sizeof(*this_master_creature));
    if (!(this_master_creature->wear_wield == NULL))
        write_ilist(save_file, this_master_creature->wear_wield);
    if (!(this_master_creature->pack == NULL))
        write_ilist(save_file, this_master_creature->pack);
    if (!(this_master_creature->stati == NULL))
        write_adj_struct(save_file, this_master_creature->stati);
    if (!(this_master_creature->skills == NULL))
        write_skills_struct(save_file, this_master_creature->skills);
    if (this_master_creature->faith != NULL)
        write_faith_struct(save_file, this_master_creature->faith);
    }

void write_faith_struct(int save_file, struct faith_struct *this_faith_struct)
    {
    long data_type;
    struct faith_struct* new_faith_struct;
    data_type = FAITH_STRUCT;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_faith_struct, sizeof(this_faith_struct));
    if ((long) this_faith_struct <= 0xff || this_faith_struct->me != this_faith_struct)
        {
        new_faith_struct = calloc(1, sizeof(struct faith_struct));
        write(save_file, new_faith_struct, sizeof(*new_faith_struct));
        return;
        }
    write(save_file, this_faith_struct, sizeof(*this_faith_struct));
    if (this_faith_struct->breath_prayer != NULL)
        write_text_struct(save_file, this_faith_struct->breath_prayer);
    }

void write_adj_struct(int save_file, struct adj_struct *this_adj_struct)
    {
    long data_type;
    struct adj_struct* new_adj_struct;
    data_type = ADJ_STRUCT;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_adj_struct, sizeof(this_adj_struct));
    if (this_adj_struct->me != this_adj_struct)
        {
        new_adj_struct = calloc(1, sizeof(struct adj_struct));
        write(save_file, new_adj_struct, sizeof(*new_adj_struct));
        return;
        }
    write(save_file, this_adj_struct, sizeof(*this_adj_struct));
    }

void write_skills_struct(int save_file, struct skills_struct
  *this_skills_struct)
    {
    long data_type;
    struct skills_struct* new_skills_struct;
    data_type = SKILLS_STRUCT;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_skills_struct, sizeof(this_skills_struct));
    if (this_skills_struct->me != this_skills_struct)
        {
        new_skills_struct = calloc(1, sizeof(struct skills_struct));
        write(save_file, new_skills_struct, sizeof(*new_skills_struct));
        return;
        }
    write(save_file, this_skills_struct, sizeof(*this_skills_struct));
    }

void write_small_item(int save_file, struct small_item *this_small_item)
    {
    long data_type;
    struct small_item* new_small_item;
    data_type = SMALL_ITEM;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_small_item, sizeof(this_small_item));
    if (this_small_item->me != this_small_item)
        {
        /*
        new_small_item = generate_item(countryside, LONGSWORD);
        new_small_item = generate_item(dig_level(LEVEL_DUNGEON, 0, 0, 0),
          LONGSWORD);
        */
        new_small_item = calloc(1, sizeof(struct small_item));
        write(save_file, new_small_item, sizeof(*new_small_item));
        return;
        }
    write(save_file, this_small_item, sizeof(*this_small_item));
    if (!(this_small_item->tname == NULL))
        write_text_struct(save_file, this_small_item->tname);
    if (!(this_small_item->contents == NULL))
        write_ilist(save_file, this_small_item->contents);
    if (!(this_small_item->writing == NULL))
        write_text_struct(save_file, this_small_item->writing);
    if (this_small_item->creatures != NULL)
        write_clist(save_file, this_small_item->creatures);
    }

void write_game_variables_struct(int save_file, struct game_variables_struct
  *this_game_variables_struct)
    {
    long data_type;
    struct game_variables_struct* new_game_variables_struct;
    data_type = GAME_VARIABLES_STRUCT;
    write(save_file, &data_type, sizeof(data_type));
    write(save_file, &this_game_variables_struct,
      sizeof(this_game_variables_struct));
    if (this_game_variables_struct->me != this_game_variables_struct)
        {
        new_game_variables_struct = calloc(1, sizeof(struct game_variables_struct));
        write(save_file, new_game_variables_struct,
          sizeof(*new_game_variables_struct));
        return;
        }
    write(save_file, this_game_variables_struct,
      sizeof(*this_game_variables_struct));
    }

/* The data structure keeps track of the data type, and then has pointers */
/* used a little non-conventionally -- the old pointer is there for the sake */
/* of tracking down, and the new pointer points to whatever data type is */
/* indicated, not generally to a pointer_struct.  This section will probably */
/* generate compiler warnings.  */

long read_datum(int save_file)
    {
    long success;
    struct pointer_struct *this_pointer;
    this_pointer = (struct pointer_struct *) calloc(1, sizeof(struct
      pointer_struct));
    this_pointer->me = this_pointer;
    success = read(save_file, &this_pointer->data_type,
      sizeof(this_pointer->data_type));
    if (success)
        {
        read(save_file, &this_pointer->old_address,
          sizeof(struct pointer_struct *));
        switch(this_pointer->data_type)
            {
            case ADJ_STRUCT:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct adj_struct));
                read(save_file, this_pointer->new_address, sizeof(struct
                  adj_struct));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case CLIST:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct clist));
                read(save_file, this_pointer->new_address, sizeof(struct
                  clist));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case ESTABLISHMENT_STRUCT:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct establishment_struct));
                read(save_file, this_pointer->new_address, sizeof(struct
                  establishment_struct));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case FAITH_STRUCT:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct faith_struct));
                read(save_file, this_pointer->new_address, sizeof(struct
                  faith_struct));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case GAME_VARIABLES_STRUCT:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct game_variables_struct));
                read(save_file, this_pointer->new_address, sizeof(struct
                  game_variables_struct));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case ILIST:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct ilist));
                read(save_file, this_pointer->new_address, sizeof(struct
                  ilist));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case LEVEL:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct level));
                read(save_file, this_pointer->new_address, sizeof(struct
                  level));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case LIGHT_SOURCE_STRUCT:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct light_source_struct));
                read(save_file, this_pointer->new_address, sizeof(struct
                  light_source_struct));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case LLIST:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct llist));
                read(save_file, this_pointer->new_address, sizeof(struct
                  llist));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case MASTER_CREATURE:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct master_creature));
                read(save_file, this_pointer->new_address, sizeof(struct
                  master_creature));
            break;
            case SHOP_STRUCT:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct shop_struct));
                read(save_file, this_pointer->new_address, sizeof(struct
                  shop_struct));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case SKILLS_STRUCT:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct skills_struct));
                read(save_file, this_pointer->new_address, sizeof(struct
                  skills_struct));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case SMALL_CREATURE:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct small_creature));
                read(save_file, this_pointer->new_address, sizeof(struct
                  small_creature));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case SMALL_ITEM:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct small_item));
                read(save_file, this_pointer->new_address, sizeof(struct
                  small_item));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case SPECIAL_STRUCT:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct special_struct));
                read(save_file, this_pointer->new_address, sizeof(struct
                  special_struct));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            case TEXT_STRUCT:
                this_pointer->new_address = (struct pointer_struct *)
                  calloc(1, sizeof(struct text_struct));
                read(save_file, this_pointer->new_address, sizeof(struct
                  text_struct));
                this_pointer->new_address->me = this_pointer->new_address;
            break;
            default:
                perror("Error: invalid save file format.  Aborting...");
                my_finish(1);
            break;
            }
        this_pointer->next = master_pointers;
        master_pointers = this_pointer;
        }
    else
        free(this_pointer);
    return success;
    }

struct pointer_struct *get_new_pointer(struct pointer_struct *old_pointer)
    {
    struct pointer_struct *traverse;
    if (master_pointers == NULL)
        return NULL;
    else
        for(traverse = master_pointers; (!(traverse == NULL)); traverse =
          traverse->next)
            if (traverse->old_address == old_pointer)
                return traverse->new_address;
    return NULL;
    }
