/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2003 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include <stdlib.h>
#include <string.h>

/* Edit the following definitions appropriately... */


/* Uncomment one of the following.  If your system is not one of the below, */
/* please define OTHER_SYSTEM, and then e-mail me what system you are */
/* running and what you need to do to port it.  */

#define LINUX
/* #define MSDOS */
/* #define NETBSD */
/* #define SOLARIS */
/* #define OTHER_SYSTEM */

/* It is necessary to retain the trailing slash at the end of LIB_DIR.  */
/* This should be the directory where the data files are kept. */
/* NOTE: the trailing '/' is necessary.  I.E. "/foo/blorg/" is acceptable; */
/* "/foo/blorg" will give the game indigestion. */

#ifdef MSDOS
#define LIB_DIR "lib\\"
#else
#define LIB_DIR "/usr/lib/games/otms/"
#endif

#define SAVE_FILE "save.otms"

/* Uncomment the following line if your system does not have random(), but */
/* only has rand().  */
/* (Try 'man random' if you do not know this.  Most systems do.)  */

/* #define USE_RAND */

/******************************************************************************
 *                                                                            *
 * You shouldn't need to change anything below this line.  Modify at your own *
 * risk...                                                                    *
 *                                                                            *
 ******************************************************************************/

#ifndef MSDOS
#ifndef LINUX
#ifndef NETBSD
#ifndef SOLARIS
#ifndef OTHER_SYSTEM

Error! No operating environment defined.  Please uncomment an appropriate line
in tms.h.

#endif
#endif
#endif
#endif
#endif

#ifdef LINUX
#define SPECIAL_WNOUTREFRESH
#define HAS_SNPRINTF
#endif
#ifdef MSDOS
#define SPECIAL_WNOUTREFRESH
#define HAS_SNPRINTF
#endif
#ifdef NETBSD
#define NO_WNOUTREFRESH
#define HAS_SNPRINTF
#endif

#include <curses.h>

#define NONE -1
#define NEVER 0
#define ESCAPE 27

#define UNITS_PER_SECOND 100L /* Must have one day's worth of units less than */
                              /* the maximum long integer */
#define SECOND UNITS_PER_SECOND
#define MINUTE (60L * SECOND)
#define HOUR (60L * MINUTE)
#define DAY (24L * HOUR)

/* We store number of units into the day, and number of days into time. */

#define WEEK 7L
#define MONTH (4L * WEEK)
#define YEAR (12L * MONTH)

#define PI 3.14159

#define UNITS_PER_EP 1000L

#define MAX_X 80
#define MAX_Y MAX_X

#define MAX_PUZZLE_X 9 /* Must be able to all fit in the appropriate window */
#define MAX_PUZZLE_Y MAX_PUZZLE_X /* and furthermore be odd.  */

#define MY_PRINT 0
#define MY_READ 1

/* I am using #defines instead of an enum here because the enum is */
/* conflicting with some of the definitions of the curses library.  */

#define AG 0
#define AL 1
#define CH 2
#define CO 3
#define DE 4
#define IN 5
#define KN 6
#define ME 7
#define PE 8
#define SPEED 9
#define ST 10
#define WI 11 /* willpower, not wisdom */

#define NUM_ATTRIBUTES (WI + 1)

enum
    {
    ACQUISITION,
    ANATOMY,
    ANIMAL_HANDLING,
    APPRAISAL,
    ATTACK_AXE,
    ATTACK_CROSSBOW,
    ATTACK_DAGGER,
    ATTACK_FIST,
    ATTACK_HALBERD,
    ATTACK_LANCE,
    ATTACK_LONGBOW,
    ATTACK_LONGSWORD,
    ATTACK_MACE,
    ATTACK_RAPIER,
    ATTACK_SHORTSWORD,
    ATTACK_THROW,
    ATTACK_TWO_HANDED_SWORD,
    BLIND_ACTION,
    CHEMISTRY,
    CLIMBING,
    COLD_TOLERANCE,
    DODGE,
    ENDURANCE,
    FENCING_AXE,
    FENCING_DAGGER,
    FENCING_HALBERD,
    FENCING_LONGSWORD,
    FENCING_MACE,
    FENCING_RAPIER,
    FENCING_SHORTSWORD,
    FENCING_TWO_HANDED_SWORD,
    FISHING,
    GEOGRAPHY,
    GUESS_ACTIONS,
    HAGGLING,
    HEAR_NOISES,
    HEAT_TOLERANCE,
    HERBALISM,
    JUMPING,
    KEEN_EYESIGHT,
    LANGUAGE_JANRA,
    LANGUAGE_JEC,
    LANGUAGE_NORKRIN,
    LANGUAGE_SHAL,
    LANGUAGE_TUZ,
    LANGUAGE_URVANOVESTILLI,
    LANGUAGE_YEDIDIA,
    MEDICINE,
    MUSIC_FLUTE,
    MUSIC_HARP,
    MUSIC_LUTE,
    MUSIC_ORGAN,
    MUSIC_SINGING,
    NAVIGATION,
    PERSUASION,
    PICK_LOCKS,
    READING_WRITING,
    REPAIR,
    RIDING,
    SAILING,
    SEARCH,
    SMELL_CREATURE,
    STEALTH,
    SWIMMING,
    TECHNOLOGY_IDENTIFICATION,
    TINKERING,
    TRACKING,
    WRESTLING,

/* And some designations of areas of skills for NPC's.  */

    ATTACK_HTH,
    ATTACK_MSL,
    FENCING,
    MUSIC
    };

#define NUM_SKILLS (WRESTLING+1)

#define NUM_LEARNING_DIFFERENCES 123

/* Aliasing here... */

#define ATTACK_UNARMED ATTACK_FIST

/* level types */

enum
    {
    LEVEL_CATHEDRAL,
    LEVEL_CAVERN,
    LEVEL_COUNTRYSIDE,
    LEVEL_CRYPT,
    LEVEL_DUNGEON,
    LEVEL_FINAL_QUEST,
    LEVEL_JEC_MIDDLE_PLAINS,
    LEVEL_JEC_TOWN,
    LEVEL_MANSION,
    LEVEL_MAZE,
    LEVEL_NORKRIN_EAST_RIDGE_MOUNTAINS,
    LEVEL_NORKRIN_ICE_PEAKS,
    LEVEL_NORKRIN_ICE_PEAKS_HIDDEN_POOL,
    LEVEL_NORKRIN_PLAINS,
    LEVEL_OCEAN,
    LEVEL_OCEAN_ISLE,
    LEVEL_SHAL_FOREST,
    LEVEL_SHAL_VILLAGE,
    LEVEL_SMALL_CAVERN,
    LEVEL_TAVERN,
    LEVEL_TEST,
    LEVEL_TUZ_EAST_RIDGE_MOUNTAINS,
    LEVEL_TUZ_FOREST,
    LEVEL_TUZ_VILLAGE,
    LEVEL_URVANOVESTILLI_CITY,
    LEVEL_URVANOVESTILLI_EAST_RIDGE_MOUNTAINS,
    LEVEL_URVANOVESTILLI_FOG_VALLEY,
    LEVEL_URVANOVESTILLI_MANSION,
    LEVEL_URVANOVESTILLI_PLAINS,
    LEVEL_YEDIDIA_FOREST,
    LEVEL_YEDIDIA_VILLAGE
    };

/* types of things with which to decorate a city or other level */

enum
    {
    T_ASSIGN_DOOR,
    T_ASSIGN_MANSION_ROOMS,
    T_BUILDING_CIRCULAR,
    T_BUILDING_POOL, /* pool shaped building */
    T_BUILDING_RECTANGULAR,
    T_BUILDING_ROUNDED,
    T_BUILDING_SQUARE,
    T_BUILDING_TURRETS,
    T_CLOCKWORK_DOOR,
    T_CLOSED_DOOR,
    T_DRY_TREE,
    T_DUNGEON_ADD_ROOM,
    T_DUNGEON_JOIN_COMPONENTS,
    T_ENTRANCE,
    T_FOUNTAIN,
    T_FRUIT_TREE,
    T_GARDEN,
    T_GREEN_TREE,
    T_HEDGE,
    T_HIDDEN_MAZE_ENTRANCE,
    T_LOCKED_DOOR,
    T_MANSION_HORIZONTAL_WALL,
    T_MANSION_VERTICAL_WALL,
    T_MAZE_JOIN_SPACES,
    T_OPEN_DOOR,
    T_POOL,
    T_ROOM_CIRCULAR,
    T_ROOM_RECTANGULAR,
    T_ROOM_ROUNDED,
    T_ROOM_SQUARE,
    T_SEASIDE,
    T_SECRET_PASSAGE,
    T_STAIRWELL_DOWN,
    T_STAIRWELL_UP,
    T_STATUE,
    T_STREAM,
    T_TREE_NO_BOUNDARY,
    T_WINDOW
    };

/* location types, i.e. the identity of different spaces.  Countryside later. */

enum
    {
    L_ALTAR,
    L_BED,
    L_CLOCKWORK_DOOR,
    L_DOOR,
    L_ENTRANCE,
    L_EXIT,
    L_FINAL_TEST,
    L_FIRE,
    L_FLOOR,
    L_FOUNTAIN,
    L_HEDGE,
    L_MECHANICAL,
    L_PEAK,
    L_PIT,
    L_SAND,
    L_SECRET_PASSAGE,
    L_SHOP,
    L_SNOW_ICE,
    L_STAIRWELL_DOWN,
    L_STAIRWELL_UP,
    L_STATUE,
    L_TREE,
    L_WALL,
    L_WATER,
    L_WINDOW
    };

#define NUM_GARDENS 9L /* How many 5 x 5 garden layouts there are. */

/* City names.  */

enum
    {
    JEC_TOWN_HISH,
    JEC_TOWN_HOS,
    JEC_TOWN_KANS,
    JEC_TOWN_LUT,
    JEC_TOWN_MILN,
    JEC_TOWN_NUV,
    JEC_TOWN_TOL,
    JEC_TOWN_VERN,
    SHAL_VILLAGE_HESRI,
    SHAL_VILLAGE_INGSA,
    SHAL_VILLAGE_KASSILLA,
    SHAL_VILLAGE_LITRI,
    SHAL_VILLAGE_MACEP,
    SHAL_VILLAGE_NOLDI,
    SHAL_VILLAGE_SALN,
    SHAL_VILLAGE_SIF,
    TUZ_VILLAGE_BORD,
    TUZ_VILLAGE_DOZ,
    TUZ_VILLAGE_GHIRTON,
    TUZ_VILLAGE_GORF,
    TUZ_VILLAGE_KANDRHI,
    TUZ_VILLAGE_KORG,
    TUZ_VILLAGE_KUNDER,
    TUZ_VILLAGE_LUZZ,
    TUZ_VILLAGE_RASTI,
    TUZ_VILLAGE_RHALLTIR,
    TUZ_VILLAGE_RHAV,
    TUZ_VILLAGE_STORNGE,
    TUZ_VILLAGE_TUZZNIR,
    TUZ_VILLAGE_WAZ,
    TUZ_VILLAGE_ZOLK,
    TUZ_VILLAGE_ZUT,
    URVANOVESTILLI_CITY_CANSOMILTRAMA,
    URVANOVESTILLI_CITY_CAPITELLO,
    URVANOVESTILLI_CITY_ELHANNADAN,
    URVANOVESTILLI_CITY_ELIRE,
    URVANOVESTILLI_CITY_ELMIRTRA,
    URVANOVESTILLI_CITY_KILNATRONA,
    URVANOVESTILLI_CITY_MISTRELLI,
    URVANOVESTILLI_CITY_SANDRELLA,
    URVANOVESTILLI_CITY_STANDRILNATRELLA,
    URVANOVESTILLI_CITY_TALMIRNATRII,
    YEDIDIA_VILLAGE_DOSSE,
    YEDIDIA_VILLAGE_EHOLINA,
    YEDIDIA_VILLAGE_FILTRI,
    YEDIDIA_VILLAGE_FISRATIL,
    YEDIDIA_VILLAGE_FISSK,
    YEDIDIA_VILLAGE_SALINA,
    YEDIDIA_VILLAGE_SANLI,
    YEDIDIA_VILLAGE_SILNA,
    YEDIDIA_VILLAGE_TIRNA,
    YEDIDIA_VILLAGE_VASLI
    };

/* creature flags */

#define HUMAN           0x00000001L
#define SLEEPING        0x00000002L
#define HIDDEN          0x00000004L
#define C_FEMALE        0x00000008L
#define IMMOBILE        0x00000010L
#define NO_CLEAN            0x00000020L
#define RUNNING 64L
#define NO_DEFEND_MASTER 128L /* So little pets won't get clobbered.  */
#define CANT_SEE 256L
#define FLYING 512L
#define MISSLE_ATTACK 1024L
#define UNIQUE 2048L
#define BELLICOSE 4096L
#define OBSCURE_VISION 8192L
#define INACTIVE 16384L
#define STICKY 32768L /* tar baby */
#define HAS_VENOM 65536L
#define TERRIFYING 131072L
#define AFRAID 262144L
#define HAS_SINNED 524288L /* last quest will be failed in this case */
#define HITS_BACK 1048576L /* porcupine */
#define ABOVE_GROUND 2097152L /* i.e. can only be hit by missle or other */
                  /* flying creatures.  This is set false */
                  /* when attacking an on-ground creature. */
#define WATER_ONLY 4194304L
#define HOSTILE 8388608L /* naturally hostile to humans */
#define C_BLUNT_DAMAGE 16777216L /* Creature inflicts blunt damage */
#define LEFT_HANDED 33554432L
#define HAS_LIGHT_SOURCE 67108864L
#define CONTROL_MOVE 134217728L
#define SHIFT_MOVE 268435456L
#define C_HAGGLED 536870912L
#define C_WANDERING 1073741824L

/* First set of item flags */

#define CAN_ACTIVATE 1L
#define CAN_READ 2L
#define CAN_WRITE_ON 4L
#define BROKEN 8L
#define CONTAINER 16L
#define IMMOVABLE 32L
#define WEAR_WIELD 64L
#define EXPENDABLE 128L
#define I_UNIQUE 256L
#define CAN_TINKER 512L /* Engineer with clockwork device craftsmanship skill */
#define I_VEHICLE 1024L
#define LAND_ONLY 2048L
#define I_WATER_ONLY 4096L
#define LOCKED 8192L
#define NOT_PURCHASED 16384L
#define IDENTIFIED 32768L
#define LIQUID 65536L
#define MAY_HAVE_COMPARTMENT 131072L
#define FINE_QUALITY 262144L
#define POOR_QUALITY 524288L
#define CAN_OPEN 1048576L
#define IS_OPEN 2097152L
#define CAN_LOCK 4194304L
#define ACTIVATED 8388608L /* Candles, etc. */
#define DISAPPEAR_LAST_USE 16777216L /* Whether or not an expendable item
    disappears after its last use */
#define HOLD_LIQUID 33554432L /* Can a container hold liquids? */
#define FLAMMABLE 67108864L /* only items which are ignited to be used */
#define CAN_CHEM 134217728L
#define CAN_HERB 268435456L
#define NO_DUNGEON 536870912L   /* An item is not naturally found in the */
                /* dungeon. */
#define TRANSLUCENT 1073741824L /* A container that, even when closed, will */
                                /* allow you to see what's inside. */

/* Second set of item flags */

#define SOME 1L /* An item like a liquid, spices, etc. that one has some of, */
                /* rather than being one or two or five. */
#define LATENT 2L /* An object in a store which the store owner is */
                /* acquiring.  It does not show up, and cannot be purchased, */
                /* until the number of elapsed days equals or exceeds the */
                /* *other* value in the item structure, at which point the */
                /* flag is cleared. */
#define HAGGLED 4L
#define IM_BEATS 8L /* combat messages */
#define IM_HITS 16L
#define IM_SHOOTS 32L
#define IM_SLASHES 64L
#define IM_STABS 128L
#define IM_STRIKES 256L
#define IS_WEAPON 512L
#define I_BLUNT_DAMAGE 1024L
#define DONT_PRINT_NAME_UNLESS_IDENTIFIED 2048L
#define APPRAISED 4096L
#define APPRAISE_FAILED 8192L
#define IDENTIFY_FAILED 16384L
#define WRITING_IS_FILENAME 32768L
#define I_NO_PICKUP 65536L
#define I_MISSLE_WEAPON 131072L
#define IM_SHOOTS_ROCKETS 262144L
#define I_CAN_WRITE 524288L
#define I_ALWAYS_NORMAL_QUALITY 1048576L
#define I_ALL_ITEMS 2097152L
#define I_REPAIR_FAILED 4194304L
#define I_TRAVEL_WATER 8388608L
#define I_WRITE_ON_LOG 16777216L

/* skill flags */

#define NEEDS_ITEM 1L /* A skill requires an item to use.  */
#define GENERALLY_USABLE 2L /* A skill which is usable in general, i.e. can */
                            /* be used with the 's' command.  (Such a skill */
                            /* may still need enabling, etc.)  */
#define CONTINUOUS 4L /* A skill is used continuously, in which case the */
                      /* time value denotes how often the check is.  May */
                      /* be obsolete given time_check().  */
#define NO_HOSTILE 8L /* Cannot be used on a level with hostile creatures.  */
#define NEEDS_SPECIAL 16L /* A skill that needs a special environment to */
                          /* work, i.e. swimming in water, tinkering in a */
                          /* laboratory, weather in the outdoors, or */
                          /* tracking in the countryside.  These are */
                          /* idiosyncratic enough to handle individually in */
                          /* code, rather than as a group with a specific */
                          /* flag for each.*/

/* level flags */

#define IS_CITY 1L
#define IS_SEASIDE 2L
#define L_CLOAKED_BY_MIST 4L
#define PRINT_LEVEL_NUMBER 8L
#define OUTDOORS 16L /* Affects, among other things, whether or not */
                     /* spaces are illuminated. */
#define NO_FREE 32L /* A level which should not be freed upon exit.  */
#define HAS_MENTOR 64L
#define ALWAYS_FREE 128L

/* space flags */

#define PERM_ILLUMINATED 1L
#define KNOWN 2L
#define TRANSPARENT 4L
#define CURR_ILLUMINATED 8L
#define CAN_OCCUPY 16L
#define DEVICE_LABORATORY 32L
#define CHEMICAL_LABORATORY 64L
#define HAS_HERBS 128L
#define OCCUPIED 256L
#define IS_WATER 512L /* Keep this flag, even though redundant */
#define IS_COLD 1024L
#define EXTREMELY_COLD 2048L
#define AUTOMATIC_EFFECT 4096L
#define DOOR_CLOSED 16384L
#define DOOR_LOCKED 32768L
#define PERM_DIMLY_LIT 65536L
#define AVAILABLE 131072L
#define SHALLOW 262144L /* water that you can't drown in (like a fountain) */
#define MARKED 524288L /* internal use in dungeon creation */
#define SALT_WATER 1048576L
#define S_CLOAKED_BY_MIST 2097152L
#define IS_MOUNTAIN 4194304L
#define AVAILABLE3 8388608L /* For shops etc. where you can't just pick up an */
                            /* item.  */
#define DIMLY_LIT 16777216L /* CURR_ILLUMINATED takes precedence over */
                            /* DIMLY_LIT */
#define EFFECT_BEFORE_MOVE 33554432L
#define OTHER_IS_LOCATION_TYPE 67108864L
#define IS_SANCTUARY 134217728L
#define HOLY_GROUND 268435456L
#define HAS_SECRET 536870912L

/* special property flags */

/* (none yet) */

/* game variables/game stati flags */

#define MESSAGES_PROMPT 1L
#define ASK_PICKUP 2L
#define MAX_REFRESH 4L
#define PLAYER_AT_CENTER 8L
#define INCREMENTAL /* update of current screen; not yet implemented properly */ 16L
#define NEGATIVE_CONFIRM 32L /* Write negative instead of positive messages */
                             /* when the general confirm procedure is */
                             /* used.  Good for newcomers, when confirming */
                             /* is more likely to be helpful for actions */
                             /* they didn't intend. */
#define ONE_SECOND_CHECK 64L
#define ONE_MINUTE_CHECK 128L
#define ONE_HOUR_CHECK 256L
#define ONE_DAY_CHECK 512L
#define ONE_MONTH_CHECK 1024L
#define ONE_YEAR_CHECK 2048L
#define SMALL_SAVE_FILE 4096L /* Only save certain essential levels.  */
#define DURING_INIT 8192L /* can't assume everything is generated if this */
                                                    /* flag is set */
#define CONFIRM_WHEN_IN_DOUBT 16384L
#define FREE_UNNEEDED_LEVELS 32768L
#define BLACKSMITH_GAVE_QUEST 65536L
#define DEBUG_MODE 131072L
#define DAYLIGHT 262144L
#define TWILIGHT 524288L
#define PLAYER_JOINED_TINKERERS_GUILD 1048576L
#define GOING_UP 2097152L
#define PLAYER_SLEEPING_UNTIL_SUNRISE 4194304L
#define ALWAYS_DISPLAY_STAIRCASES 8388608L

/* slot flags for items and people */

#define FEET 1L
#define FOREARMS 2L
#define PRIMARY_HAND 4L
#define SECONDARY_HAND 8L
#define HEAD 16L
#define S_CLOAK 32L
#define ARMOR 64L
#define VEHICLE 128L

#define LAST_SLOT VEHICLE

/* flags to pass to the level generation program */

#define LOAD 1L
#define F_COUNTRYSIDE 2L /* Treat a bit differently */

/* Races */

#define NUM_RACES 7

/* Genders */

#define NUM_GENDERS 3

#define MALE 0
#define FEMALE 1
#define NEUTER 2

/* Age classes */

#define NUM_AGE_CLASSES 6

enum
    {
    INFANT,
    CHILD,
    YOUNG_ADULT,
    MIDDLE_AGED,
    OLD,
    ANCIENT
    };

#define NUM_ADJUSTMENTS 6


enum
    {

/* Races of people */

    JANRA,
    JEC,
    NORKRIN,
    SHAL,
    TUZ,
    URVANOVESTILLI,
    YEDIDIA,

/* Animals and monsters (generally referred to as animals) */

    ANGEL,
    ACID_SLIME_MOLD,
    ACID_SPITTER,
    ANTEATER,
    BARRACUDA,
    BASS,
    BEAR,
    BEHEMOTH,
    BOAR,
    BULETTE,
    CARIBOU,
    CARNIVOROUS_LOG,
    CARNIVOROUS_TREE,
    CHIMERA,
    COBRA,
    COLORSPRAY,
    CROCODILE,
    CUDDLER,
    DEER,
    DOG,
    DOLPHIN,
    DOVE,
    DRAGON,
    DUCK,
    ELECTRIC_EEL,
    ELEPHANT,
    FOG_THING,
    FURRED_SERPENT,
    GARTER_SNAKE,
    GIANT_APHID,
    GIANT_CRAB,
    GIANT_FIREFLY,
    GIANT_LAND_LOBSTER,
    GIANT_SCORPION,
    GIANT_SQUID,
    GIANT_VIPER,
    GIANT_WALKING_STICK,
    GIANT_WASP,
    GIANT_WEBTHROWER,
    GLOWER,
    GORILLA,
    GRYPHON,
    HAWK,
    HEDGEHOG,
    HIPPOGRIFF,
    HIPPOPOTAMUS,
    HNAKRA,
    HORSE,
    HOVERFEATHER,
    HUMMINGBIRD,
    ICEFLYER,
    ICESTRIKER,
    IRONRAM,
    JELLYFISH,
    JEWEL_SERPENT,
    JUMPCLING,
    JUMPER,
    KRAKEN,
    KRIIT,
    LAND_OCTOPUS,
    LAVISHNATIM,
    LEVIATHAN,
    LION,
    MAMMOTH,
    MASTODON,
    MILE_LONG_SNAKE,
    MILSHH,
    MIMIC,
    MIRIOR,
    MISHRAIM,
    MONKEY,
    MOUSE,
    MUCKDWELLER,
    OCTOPUS,
    OSTRICH,
    OWL,
    PANTHER,
    PARROT,
    PEGASUS,
    PIKE,
    PIRANHA,
    PLATYPUS,
    POISON_QUILLED_PORCUPINE,
    PORCUPINE,
    PRAIRIE_DOG,
    PTERODACTYL,
    PYTHON,
    QUAIL,
    RABBIT,
    RAM,
    RAT,
    RHINOCEROS,
    RICOCHET,
    ROC,
    ROCK_CRUSHER,
    ROCK_THROWER,
    RODENT_OF_UNUSUAL_SIZE,
    SAND_TRAPPER,
    SCORPION,
    SEA_SERPENT,
    SEAL,
    SHARK,
    SHOCKER,
    SKUNK,
    SLOTH,
    SOFT_ROLLING_STONE,
    SPARROW,
    SPINSTAR,
    STEGOSAURUS,
    STINGING_INSECT,
    STONESHELL,
    STRIDER,
    SWAMP_THING,
    TAIL_SPIKETHROWER,
    TAR_BABY,
    TERRASK,
    THOUSAND_LEGGED_ROLLER,
    TICKLEBUG,
    TIGER,
    TORPOR_BEAST,
    TRANSLUCENT_FROG,
    TRICERATOPS,
    TRIN,
    TROUT,
    TURTLE,
    TYRANNOSAURUS_REX,
    VELOCIRAPTOR,
    WALRUS,
    WARM_FUZZY,
    WIND_HUMMER,
    WOLF,
    WYVERN,

/* Different types of encounters -- what land, how hard of a dungeon, etc. */

    JEC_ENCOUNTER,
    NORKRIN_ENCOUNTER,
    SHAL_ENCOUNTER,
    TUZ_ENCOUNTER,
    URVANOVESTILLI_ENCOUNTER,
    YEDIDIA_ENCOUNTER,
    SEA_ENCOUNTER,
    FISHING_ENCOUNTER,
    LEVEL_1_ENCOUNTER,
    LEVEL_2_ENCOUNTER,
    LEVEL_3_ENCOUNTER,
    LEVEL_4_ENCOUNTER,
    LEVEL_5_ENCOUNTER,
    LAND_SPECIAL_ENCOUNTER, /* terrifying, 1/10 chance unique */
    SEA_SPECIAL_ENCOUNTER, /* "" */
    DUNGEON_ENCOUNTER /* easy, medium, or hard */
    };

/* Animal species */

#define NUM_CREATURES (WYVERN + 1)

#define FIRST_NONHUMAN ANGEL
#define FIRST_ANIMAL ACID_SLIME_MOLD
#define LAST_ANIMAL WYVERN

#define NUM_ANIMALS (LAST_ANIMAL - FIRST_ANIMAL + 1)

#define FIRST_ENCOUNTER_TYPE JEC_ENCOUNTER
#define LAST_ENCOUNTER_TYPE DUNGEON_ENCOUNTER

#define NUM_ENCOUNTER_TYPES 21
#define NUM_ENCOUNTERS 101

#define E_JEC 0
#define E_NORKRIN 1
#define E_SHAL 2
#define E_TUZ 3
#define E_URVANOVESTILLI 4
#define E_YEDIDIA 5

#define E_SEA 6

#define E_EASY 7
#define E_MEDIUM 8
#define E_HARD 9

/* Item identifiers */

enum
    {
    ADRENALINE,
    ANTIDOTE, /* Possibly different poisons and antidotes */
    AMULET,
    AXE,
    BACKPACK,
    BED,
    BEER,
    BELAYING_DEVICE,
    BOOK,
    BOOTS,
    BOTTLE,
    BRACERS,
    BRACERS_TITANIUM,
    BRAZIER,
    CABINET,
    CALCULATOR,
    CAMOUFLAGE_CLOAK,
    CANDLE,
    CANDLESTICK,
    CATS_CLAW,
    CHAIN_MAIL,
    CHAIN_MAIL_FEATHER,
    CHAIR,
    CHEST_LARGE,
    CHEST_MEDIUM,
    CHEST_SMALL,
    CHALICE,
    CLOAK,
    CLOCK,
    CLOCKWORK_DEVICE,
    CLOTHING,
    COFFEE,
    COFISA_TEA,
    COMPASS,
    CORDIAL,
    CROSSBOW,
    CROSSBOW_PUMP,
    CROSSBOW_PUMP_SIGHTED,
    CROSSBOW_SIGHTED,
    CROSSBOW_SPRAY,
    CROSSBOW_BOLT,
    CROSSBOW_BOLT_EXPLODING,
    CROSSBOW_BOLT_POISON,
    CROWBAR,
    CROWN,
    DAGGER,
    DAGGER_POISON,
    DIAMOND_CHALICE,
    EARHORN,
    FIRESTAR,
    FIREWOOD,
    FISHING_NET,
    FISHING_ROD,
    FLASK,
    FLOWER,
    FLUTE,
    FOLDING_BOAT,
    FOOD,
    GEM,
    HALBERD,
    HARP,
    HELM_IRON,
    HELM_LEATHER,
    HELSRIANA_TEA,
    HERBAL_MEDICINES,
    HORN,
    HOT_AIR_BALLOON,
    HUMMER,
    INCENSE,
    JANRA_BALL,
    JEWELRY,
    JUGGERNAUT,
    JUICE,
    KEY,
    KHOOR,
    LANCE,
    LANTERN,
    LEATHER_ARMOR,
    LEATHER_VEST,
    LIGHTER,
    LOCK_PICKS,
    LONGBOW,
    LONGBOW_ARROW,
    LONGSWORD,
    LUTE,
    MACE,
    MANUAL_OF_SKILL,
    MEDICAL_KIT,
    MIRROR,
    MORTAL_REMAINS,
    MUSIC_BOX,
    OIL,
    OTHER,
    ORGAN,
    PAPER, /* a piece of */
    PEARL_OF_GREAT_PRICE,
    PEN,
    PERFUME,
    PLATE,
    PLATE_ARMOR_HEAVY,
    PLATE_ARMOR_LIGHT,
    POISON_WEAK,
    POISON_MODERATE,
    POISON_STRONG,
    POISON_VERY_STRONG,
    POISON_EXTREMELY_STRONG,
    POUCH,
    QUIVER,
    RAFT,
    RAPIER,
    RATION,
    RELIC,
    RING,
    ROPE_GRAPPLING_HOOK,
    SAILBOAT,
    SCEPTRE,
    SCROLL,
    SCUBA,
    SHELVES,
    SHIELD_LARGE,
    SHIELD_MEDIUM,
    SHIELD_SMALL,
    SHIP,
    SHORTSWORD,
    SKIN, /* waterskin, wineskin, etc. */
    SOFT_BOOTS,
    SPICES,
    SPIDER_SILK_ROBE,
    STATUETTE,
    STAFF_CLIMB,
    STAFF_DART,
    STAFF_LANTERN,
    STAFF_ROCKET,
    STONE,
    SYRINGE,
    SUBMARINE,
    TABLE,
    TALINOR_TEA,
    TAPESTRY,
    TINDERBOX,
    TOOL_KIT,
    TORCH,
    TREE_FRUIT,
    TWO_HANDED_SWORD,
    WATCH,
    WATER,
    WINE,
    WINTER_CLOTHING, /* last true item */
    ARMOR_FINE, /* beginning of item probability distributions; fine must */
                            /* always precede normal, and then normal_fine, */
                            /* exactly as done here.  */
    ARMOR_NORMAL,
    ARMOR_NORMAL_FINE, /* a normal distribution armor, but it's of fine */
               /* quality */
    ART_FINE,
    ART_NORMAL,
    ART_NORMAL_FINE,
    DEVICE_FINE,
    DEVICE_NORMAL,
    DEVICE_NORMAL_FINE,
    FURNITURE_FINE,
    FURNITURE_NORMAL,
    FURNITURE_NORMAL_FINE,
    LIQUID_FINE,
    LIQUID_NORMAL,
    LIQUID_NORMAL_FINE,
    MUSICAL_INSTRUMENT_FINE,
    MUSICAL_INSTRUMENT_NORMAL,
    MUSICAL_INSTRUMENT_NORMAL_FINE,
    NATURAL_FINE,
    NATURAL_NORMAL,
    NATURAL_NORMAL_FINE,
    NON_DEVICE_EQUIPMENT_FINE,
    NON_DEVICE_EQUIPMENT_NORMAL,
    NON_DEVICE_EQUIPMENT_NORMAL_FINE,
    NON_EQUIPMENT_TREASURE_FINE,
    NON_EQUIPMENT_TREASURE_NORMAL,
    NON_EQUIPMENT_TREASURE_NORMAL_FINE,
    SUPPLIES_FINE,
    SUPPLIES_NORMAL,
    SUPPLIES_NORMAL_FINE,
    WEAPON_FINE,
    WEAPON_NORMAL,
    WEAPON_NORMAL_FINE,
    BUILDING_ITEM_FINE,
    BUILDING_ITEM_NORMAL,
    BUILDING_ITEM_NORMAL_FINE,
    DUNGEON_ITEM_FINE,
    DUNGEON_ITEM_NORMAL,
    DUNGEON_ITEM_NORMAL_FINE,
    OUTDOORS_ITEM_FINE,
    OUTDOORS_ITEM_NORMAL,
    OUTDOORS_ITEM_NORMAL_FINE,
    TINY_ITEM_FINE,
    TINY_ITEM_NORMAL,
    TINY_ITEM_NORMAL_FINE,
    BOOKSTORE_ITEM_FINE,
    BOOKSTORE_ITEM_NORMAL,
    BOOKSTORE_ITEM_NORMAL_FINE,
    HERBALIST_ITEM_FINE,
    HERBALIST_ITEM_NORMAL,
    HERBALIST_ITEM_NORMAL_FINE,
    JEWELLER_ITEM_FINE,
    JEWELLER_ITEM_NORMAL,
    JEWELLER_ITEM_NORMAL_FINE,
    BOAT_FINE,
    BOAT_NORMAL,
    BOAT_NORMAL_FINE
    };

#define MAX_ITEM WINTER_CLOTHING
#define NUM_ITEMS (MAX_ITEM+1) /* enum starts at 0 */

#define MAX_ITEM_TYPE JEWELLER_ITEM_NORMAL_FINE

#define DIST_NORMAL 1 /* Where in the array normal and fine are */
#define DIST_FINE 2 /* Fine must be one greater than normal */

enum
    {
    MATRIX_POOR,
    MATRIX_NORMAL,
    MATRIX_FINE
    };

#define NUM_DIST_SLOTS 100 /* The number of slots in a probability */
              /* distribution for an item; do not change this */
              /* without affecting the item dists in data.c */

/* item effects (on activation) */

enum
    {
    AID_OPEN, /* Help in prying something open */
    ALCOHOL,
    BREATHE_UNDERWATER,
    CATCH_FISH,
    E_ADRENALINE,
    E_ANTIDOTE,
    E_CALCULATOR,
    E_CLOCKWORK_DEVICE, /* Program should modify to have other functions. */
    E_COFFEE,
    E_COFISA_TEA,
    E_EQUIP,
    E_FLY,
    E_FOOD,
    E_HELSRIANA_TEA,
    E_HORN, /* Perhaps making creatures come/leave */
    E_HUMMER,
    E_INCENSE, /* possibly lowering persuasion difficulties or temp. increasing
        charisma */
    E_JANRA_BALL,
    E_KEY,
    E_MANUAL_OF_SKILL,
    E_MEDICINE,
    E_MIRROR,
    E_MUSIC_BOX,
    E_MUSIC_FLUTE,
    E_MUSIC_HARP,
    E_MUSIC_LUTE,
    E_MUSIC_ORGAN,
    E_PERFUME,
    E_POISON,
    E_SHOOT_DART,
    E_SHOOT_ROCKET,
    E_TALINOR_TEA,
    E_TEXT, /* paper with something writen on it.  The id'd description may
        either be the text itself, or a reference to the filename which has the
        paper's contents. */
    FIND_DIRECTION, /* compass */
    FIREBREATHER,
    GIVES_LIGHT,
    IGNITE,
    INJECT,
    ONE_ARROW,
    ONE_BOLT, /* a crossbow that uses one bolt when firing */
    QUENCH_THIRST, /* included in other drinks */
    TELLS_TIME,
    TWENTY_BOLTS,
    WARM_ENVIRONMENT /* firewood, etc. */
    };

#define CHANCE_FINE 10 /* 1 time in n, an item will be of fine quality. */
#define CHANCE_POOR 5   /* 1 time in n, an item not of fine quality will be */
            /* of poor quality */
#define CHANCE_COMPARTMENT 10 /* 1 time in n, an item will have a compartment. */
#define CHANCE_CONTENTS 2 /* 1 time in n, a compartment will have contents. */
#define CHANCE_OTHER_HANDEDNESS 10 /* a creature having opposite handedness */
#define CHANCE_NEXT_LEVEL 10 /* (n-1)^l times in n^l, where l is the level */
                             /* of a dungeon, we do not bump up to the next */
                             /* power or quality level.  (easy, medium, hard, */
                             /* normal, fine, etc.)  */

/* difficulties */

#define VERY_EASY -80
#define EASY -40
#define MODERATE 0
#define DIFFICULT 40
#define VERY_DIFFICULT 80
#define EXTREMELY_DIFFICULT 120
#define LEGENDARILY_DIFFICULT 160

#define ONE_NOTCH DIFFICULT
#define ONE_HALF_NOTCH (ONE_NOTCH/2)
#define ONE_QUARTER_NOTCH (ONE_HALF_NOTCH/2)
#define ONE_EIGHTH_NOTCH (ONE_QUARTER_NOTCH/2)

/* stati */

enum
    {
    STATUS_ADRENALINE,
    STATUS_ALCOHOL,
    STATUS_BREATHE_WATER,
    STATUS_COFFEE,
    STATUS_COFISA,
    STATUS_COLD, /* dealing with hypothermia */
    STATUS_FATIGUED,
    STATUS_FLYING,
    STATUS_HEALABLE, /* This is the amount of damage that can be quickly 
                          healed by medical skill */
    STATUS_HEALABLE_ANTIDOTE, /* This number is the number of times that a */
              /* character can */
              /* receive medical benefit from a poison antidote.  */
    STATUS_HELSRIANA,
    STATUS_HUMMER,
    STATUS_HUNGRY,
    STATUS_IMMOBILE,
    STATUS_LOST,
    STATUS_MIRACLE_AEGIS_OF_GOD,
    STATUS_MIRACLE_CONVERSE,
    STATUS_MIRACLE_DIVINE_SUSTENANCE,
    STATUS_MIRACLE_FAVOR_WITH_MAN,
    STATUS_MIRACLE_FORTITUDE,
    STATUS_MIRACLE_HOLD_TIME,
    STATUS_MIRACLE_INCREASE_FAITH,
    STATUS_MIRACLE_PROVIDENCE,
    STATUS_MIRACLE_RESTORATION,
    STATUS_MIRACLE_WALK_ON_WATER,
    STATUS_PASSED_OUT,
    STATUS_PLEASING, /* temporary charisma boost after playing music */
    STATUS_PRAYED,
    STATUS_SLEEPING,
    STATUS_STINKY,
    STATUS_TALINOR,
    STATUS_THIRSTY,
    STATUS_TIRED,
    STATUS_WOUNDED
    };

#define NUM_STATI (STATUS_WOUNDED + 1) /* last status */

/* Values of different kinds of coin */

#define CU 1
#define SI (8*CU)
#define EL (4*SI)
#define AU (2*EL)

/* Weight of objects */

#define OZ 1L
#define LB (16L * OZ)
#define TON (2000L * LB)

/* English measure, for scale */

#define INCH 1L
#define FOOT (12L * INCH)
#define YARD (3L * FOOT)
#define MILE (5280L * YARD)

/* hand to hand attack flags */

#define HITS 1L
#define STABS 2L
#define SLASHES 4L
#define CLAWS 8L
#define BITES 16L
#define SHOCKS 32L
#define BEATS 64L
#define GORES 128L
#define RAMS 256L
#define SQUEEZES 512L
#define STINGS 1024L
#define TRAMPLES 2048L
#define SLICES 4096L
#define STRIKES 8192L

#define MAX_HTH STRIKES

/* missle attack flags */

#define MSL_HITS 1L
#define SHOOTS 2L
#define SPITS_ACID_ON 4L
#define BREATHES_FIRE_ON 8L
#define ENTANGLES 16L
#define ROCKET_HITS 32L
#define SHOOTS_WITH_ARROW 64L
#define SHOOTS_WITH_BOLT 128L
#define HITS_WITH_DART 256L

#define MAX_MSL ENTANGLES

/* inventory function flags */

#define LETTER_ITEMS 1L
#define LIST_SLOTS 2L
#define FULLSCREEN 4L
#define LIST_PRICES 8L
#define INV_LEFT_HANDED 16L
#define INV_RECURSIVE 32L

/* flags for stati/adjustments */

#define INCREASES_OVER_TIME 1L
#define DECREASES_OVER_TIME 2L /* Should not both be defined.  If neither is */
                               /* defined, the status remains constant over */
                               /* time. */
#define HAS_MAXIMUM 4L
#define HAS_MINIMUM 8L
#define STAMINA_RESIST 16L
#define CHECK_PASS_OUT 32L
#define S_CANT_SEE 64L
#define CHECK_HIGH_VALUES_DAMAGE 128L
#define NO_INCREASE_WHEN_ASLEEP 256L
#define NO_CHANGE_IN_RESTORATION 512L

/* How far to indent, by default, when printing nested inventory.  An item's
contents appear indented. */

#define INDENT_DEFAULT 2L

/* quest flags, order not significant except first and last.  (yet.) */
/* quests given by retired adventurer.  Urvanovestilli, city begins in
Capitello.

order: sent on quest, talked sage, named child, drank lake, serpent jewel,
rode dragon, completed dungeon, completed mountain, explored ocean, guessed
Janra
won archery, answered riddle, found thus-and-such unusual person,

seven jewel keys -- possibly each in possession of family, and send on other
quest.  (still have to think of quest, though.)

first -- after initial -- seven peoples.  After initial stuff.  Maybe.

Janra: guessing game.
Jec: name child.
Nor'krin: drink from lake.
Shal: be.  (simply have to return, unlike others where necessary to do
something else.)
Tuz: pin village's best wrestler.  (or blacksmith)
Urvanovestilli: answer riddle.
Yedidia: watch flower open (once per year.)

man without eyes (won't answer questions)
thousand scorpion stings, slew roc, slew behemoth, slew leviathan, slew terrask
last quest
*/

#define SENT_ON_QUEST 1L
#define DRANK_LAKE 2L /* Nor'krin */
#define WRESTLED_BLACKSMITH 4L /* Tuz */
#define ANSWERED_RIDDLE 8L /* Urvanovestilli */ /* 'twas whispered... */
#define TAMED_ANIMAL 16L /* Yedidia */
#define NAMED_CHILD 32L /* Jec */
#define WAS 64L /* Shal */
#define GUESSED_JANRA 128L /* Janra */
#define GAVE_GIFT 256L
#define SERPENT_JEWEL 512L
#define MECHANICAL_PUZZLE 1024L
#define WON_ARCHERY 2048L
#define COMPLETED_DUNGEON 4096L /* Have some item deep in dungeon.  */
#define MECHANICAL_PUZZLE_II 8192L
#define EXPLORED_OCEAN 16384L   /* and brought back giant pearl lost on */
                /* shipwreck */
#define CHOSEN_QUEST 32768L /* Tells player to choose his own quest.  */
#define MECHANICAL_PUZZLE_III 65536L    /* from a Janra child -- told to receive a */
                /* gift without asking for it. */
#define EXPLORED_MISTRELLI 131072L
/*

What has tendrils, yet is not solid,
Is wet, yet is not liquid,
Can be breathed, yet is not gaseous,
Obscures vision, yet can be seen through,
and beneath which may be found a chalice
made from earth,
harder than stone,
clearer than water,
purer than air,
and worth more than gold?

(find a diamond chalice under Mistrelli)

TAIAP removed.
*/
#define PETTED_DOLPHIN 262144L
#define MISSING_LETTERS 524288L

/* fill in remainder with cryptograms */

#define MAN_WITHOUT_EYES 4194304L
/* "what plague does this text really mention?" -- first page/paragraph has no
'r's, second one no 'a's, 3rd one no 't's, 4th one no 's's. */
#define CONTRADICTION 8388608L
/*
What is bigger than a mountain,
smaller than a grain of sand,
brighter than the sun,
darker than a cave,
stronger than the Behemoth,
weaker than an ant,
fiercer than a firestorm,
more gentle than a kitten,
harder than diamond,
softer than air,
longer than a thousand years,
shorter than a second,
older than the oldest sage,
and younger than a newborn babe?

(nothing)
*/
#define DOZEN_GIANT_SCORPIONS 16777216L
#define SLEW_ROC 33554432L
#define SLEW_KRAKEN 67108864L
#define SLEW_BEHEMOTH 134217728L
#define SLEW_LEVIATHAN 268435456L
#define SLEW_TERRASK 536870912L
#define FINAL_QUEST 1073741824L

/* Commands */

#define LEFT 'h'
#define SECOND_LEFT '4' /* alternate character by which to move left */
#define DOWN 'j'
#define SECOND_DOWN '2'
#define UP 'k'
#define SECOND_UP '8'
#define RIGHT 'l'
#define SECOND_RIGHT '6'
#define UP_LEFT 'y'
#define SECOND_UP_LEFT '7'
#define UP_RIGHT 'u'
#define SECOND_UP_RIGHT '9'
#define DOWN_LEFT 'b'
#define SECOND_DOWN_LEFT '1'
#define DOWN_RIGHT 'n'
#define SECOND_DOWN_RIGHT '3'
#define JOG_LEFT 8 /* ^H */ /* not actually jog/run, just go until something */
#define JOG_DOWN 10 /* ^J */ /* significant or as far as possible */
#define JOG_UP 11 /* ^K */
#define JOG_RIGHT 12 /* ^L */
#define JOG_UP_LEFT 25 /* ^Y */
#define JOG_UP_RIGHT 21 /* ^U */
#define JOG_DOWN_LEFT 2 /* ^B */
#define JOG_DOWN_RIGHT 14 /* ^N */
#define RUN_LEFT 'H'
#define RUN_DOWN 'J'
#define RUN_UP 'K'
#define RUN_RIGHT 'L'
#define RUN_UP_LEFT 'Y'
#define RUN_UP_RIGHT 'U'
#define RUN_DOWN_LEFT 'B'
#define RUN_DOWN_RIGHT 'N'
#define REFRESH 18
#define ACTIVATE 'a'
#define CLOSE_ITEM 'c'
#define DROP 'd'
#define EQUIP 'e'
#define FIRE_THROW 'f'
#define GIVE 'g'
#define INVENTORY 'i'
#define MUNCH 'm'
#define OPEN_ITEM 'o'
#define PRAY 'p'
#define QUAFF 'q'
#define READ_ITEM 'r'
#define USE_SKILL 's'
#define TALK 't'
#define VAULT 'v'
#define WALK 'w'
#define EXAMINE_ITEM 'x'
#define ALLOCATE_EXPERIENCE 'A'
#define CLOSE_DOOR 'C'
#define DO_ACTION 'D'
#define UNEQUIP 'E'
#define FLY 'F'
#define GO_TO_SLEEP 'G'
#define INSPECT_SEARCH 'I'
#define CITY_MOVE 'M'
#define OPEN_DOOR 'O'
#define PRINT_COPYRIGHT 'P'
#define QUIT 'Q'
#define ROLE_PLAY_INFO 'R'
#define SAVE 'S'
#define THANKS 'T'
#define WRITE_ON_ITEM 'W'
#define EXAMINE_SPACE 'X'
#define ACTIVATE_SPACE '@'
#define REST_ONCE '.'
#define REST_AWHILE ','
#define ENTER_OR_EXIT '>'
#define ABRIDGED_HELP '?'
#define HELP '/'

/* The display (graphic) characters for various matters in the dungeon */

#define C_UNKNOWN ' '
#define C_FLOOR '.'
#define C_GROUND C_FLOOR
#define C_LIQUID '!'
#define C_PLAYER '@'
#define C_WALL '#'
#define C_MONEY '$'
#define C_FIRE_LIGHT '%'
#define C_HEDGE C_TREE
#define C_PEAK '^'
#define C_DEVICE '&'
#define C_VEHICLE C_DEVICE
#define C_CLOCKWORK_DOOR C_DEVICE
#define C_PILE '*'
#define C_TREE '('
#define C_WEAPON ')'
#define C_ARMOR ']'
#define C_CLOTHING '['
#define C_PIT '_'
#define C_FOOD ':'
#define C_OPEN_DOOR '|'
#define C_CLOSED_DOOR '-'
#define C_MORTAL_REMAINS '+'
#define C_WOOD '`'
#define C_NON_DEVICE_EQUIPMENT '\\'
#define C_NON_EQUIPMENT_TREASURE '/'
#define C_TAPESTRY C_NON_EQUIPMENT_TREASURE
#define C_WATER '\"'
#define C_MIST '\''
#define C_SAND ','
#define C_RUBBLE ';'
#define C_STAIRWELL_UP '<'
#define C_STAIRWELL_DOWN '>'
#define C_LIGHT_SOURCE '{'
#define C_BOOK '}'
#define C_SNOW_ICE '~'
#define C_GEM '='
#define C_SOMETHING_ELSE '?'
#define C_CHAIR '1'
#define C_BED '2'
#define C_WINDOW '3'
#define C_TABLE '4'
#define C_STATUE '5'
#define C_CABINET '6'
#define C_SHELVES '7'
#define C_FOUNTAIN '8'
#define C_ALTAR '9'
#define C_OTHER '0'
#define C_CANT_TELL 'X'

/* Display characters for the countryside display -- slightly different set */
/* from the regular display.  */

#define C_COUNTRYSIDE_PLAINS C_FLOOR
#define C_COUNTRYSIDE_MOUNTAINS C_PEAK
#define C_COUNTRYSIDE_OCEAN C_WATER
#define C_COUNTRYSIDE_FOREST C_TREE
#define C_COUNTRYSIDE_SETTLEMENT '#'
#define C_COUNTRYSIDE_FEATURE '$'

/* Display characters for clockwork device games */

#define C_PUZZLE_AVAILABLE '_'
#define C_PUZZLE_PLAYER '@'
#define C_PUZZLE_OPPONENT '*'

/* Types of spaces */

enum
    {
    S_ALTAR,
    S_AUTOMATIC_EXIT, /* up; it is a pop, rather than a push. */
    S_BED,
    S_CATHEDRAL_ENTRANCE,
    S_CABINET,
    S_CAVERN_ENTRANCE,
    S_CHAIR,
    S_CLOCKWORK_DOOR,
    S_CLOSED_DOOR,
    S_COLLECTION_BOX,
    S_COUNTRYSIDE_CAVERN_ENTRANCE,
    S_COUNTRYSIDE_JEC_MIDDLE_PLAINS,
    S_COUNTRYSIDE_JEC_TOWN,
    S_COUNTRYSIDE_NORKRIN_EAST_RIDGE_MOUNTAINS,
    S_COUNTRYSIDE_NORKRIN_ICE_PEAKS,
    S_COUNTRYSIDE_NORKRIN_ICE_PEAKS_HIDDEN_POOL,
    S_COUNTRYSIDE_NORKRIN_ICE_PEAKS_POOL,
    S_COUNTRYSIDE_NORKRIN_PLAINS,
    S_COUNTRYSIDE_OCEAN,
    S_COUNTRYSIDE_OCEAN_HIDDEN_ISLE,
    S_COUNTRYSIDE_OCEAN_ISLE,
    S_COUNTRYSIDE_URVANOVESTILLI_CITY,
    S_COUNTRYSIDE_URVANOVESTILLI_EAST_RIDGE_MOUNTAINS,
    S_COUNTRYSIDE_URVANOVESTILLI_FOG_VALLEY,
    S_COUNTRYSIDE_URVANOVESTILLI_HIDDEN_MANSION,
    S_COUNTRYSIDE_URVANOVESTILLI_MANSION,
    S_COUNTRYSIDE_URVANOVESTILLI_PLAINS,
    S_COUNTRYSIDE_TUZ_EAST_RIDGE_MOUNTAINS,
    S_COUNTRYSIDE_TUZ_FOREST,
    S_COUNTRYSIDE_TUZ_VILLAGE,
    S_COUNTRYSIDE_SHAL_FOREST,
    S_COUNTRYSIDE_SHAL_VILLAGE,
    S_COUNTRYSIDE_YEDIDIA_FOREST,
    S_COUNTRYSIDE_YEDIDIA_VILLAGE,
    S_DRY_TREE,
    S_FINAL_TEST,
    S_FIRE,
    S_FLOOR,
    S_FOUNTAIN,
    S_FRUIT_TREE,
    S_GREEN_TREE,
    S_HEDGE,
    S_HOUSE_DOOR,
    S_INN_ENTRANCE,
    S_LOCKED_DOOR,
    S_MAZE_ENTRANCE,
    S_MECHANICAL,
    S_OPEN_DOOR,
    S_PEAK,
    S_PEARL_OF_GREAT_PRICE,
    S_PEW,
    S_PIT,
    S_PRAYER_TABLE,
    S_RUBBLE,
    S_SALT_WATER,
    S_SAND,
    S_SECRET_PASSAGE,
    S_SHALLOW_WATER,
    S_SHELVES,
    S_SHOP,
    S_SNOW_ICE,
    S_STAINED_GLASS_WINDOW,
    S_STAIRWELL_DOWN,
    S_STAIRWELL_UP,
    S_STATUE,
    S_TABLE,
    S_TOMB,
    S_TORCH,
    S_WALL,
    S_WATER,
    S_WINDOW,
    S_WOODEN_WALL
    };

/* Special *p*roperties of land spaces */

enum
    {
    P_ADVENTURERS_GUILD,
    P_BED,
    P_CLOCKWORK_DOOR,
    P_COLLECTION_BOX,
    P_DEEP_WATER,
    P_DRY_TREE,
    P_ENTRANCE,
    P_EXIT, /* Possibly distinct from up (ex: a multi-floor house with a */
                    /* basement, in a city.)  */
    P_FINAL_TEST,
    P_FIRE,
    P_FRUIT_TREE,
    P_GREEN_TREE,
    P_HEDGE, /* scratches */
    P_HOUSE,
    P_INN_ENTRANCE,
    P_INSCRIPTION,
    P_MAPMAKER,
    P_MEDIC,
    P_MENTOR,
    P_NORTHERN_POOL,
    P_PEAK,
    P_PIT,
    P_PRAYER_TABLE,
    P_PUSHES_LEVEL,
    P_RESTAURANT,
    P_RUBBLE, /* possibly fall and be injured (latter case -- fail two */
              /* agility rolls.)  */
    P_SAND,
    P_SECRET, /* other identifies what it is to become.  */
    P_SHALLOW_WATER,
    P_SHOP,
    P_STAIRWELL_DOWN,
    P_STAIRWELL_UP,
    P_TAVERN,
    P_TAVERN_SEAT,
    P_TINKERERS_GUILD,
    P_TORCH
    };

/* puzzles */

enum
    {
    PUZZLE_BOARD_COMPLETE_SQUARE,
    PUZZLE_BOARD_CONVERT_ADJACENT,
    PUZZLE_BOARD_HIDDEN_MAZE,
    PUZZLE_BOARD_RANDOM,
    PUZZLE_BOARD_SURROUND_OPPONENT,
    PUZZLE_PEG_ALL_BUT_LAST_DOWN,
    PUZZLE_PEG_ALTERNATING,
    PUZZLE_PEG_CHECKSUM,
    PUZZLE_PEG_RANDOM,
    PUZZLE_PEG_SYMMETRY,
    PUZZLE_RIDDLE
    };

#define PEG_DOWN 0
#define PEG_UP 1

#define NUM_PEGS 7

/* board game puzzle space flags */

#define BOARD_MARKED 1L
#define BOARD_JUST_ADDED 2L
#define BOARD_AVAILABLE 4L

/* Different types of locations. Some duct tape has been added to add the "exit
 * settlement" without breaking save file backwards compatibility. */

enum
    {
    ADVENTURERS_STORE, /* Will buy back anything.  */
    ADVENTURERS_STORE_FINE,
    ARMORER,
    ARMORER_FINE,
    BOAT_SHOP,
    BOOKSTORE,
    BOOKSTORE_FINE,
    BRIC_A_BRAC, /* non-device treasure */
    DEVICE_SHOP,
    DEVICE_SHOP_FINE,
    FURNITURE_STORE,
    HERBALIST_SHOP,
    HERBALIST_SHOP_FINE,
    HORSE_SHOP,
    JEWELLER,
    LOCATOR, /* Will locate items on request, given an acquisition difficulty */
                     /* skill check.  */
    MISCELLANEOUS_EQUIPMENT,
    PET_SHOP,
    RANDOM_CREATURE_SHOP,
    SUPPLY_STORE,
    WEAPONSMITH,
    WEAPONSMITH_FINE,

/* And non-shop doorway functions.  */
    
    ADVENTURERS_GUILD,
    CATHEDRAL,
    CLOCKWORK_DOOR,
    CLOSED_DOOR,
    DOOR_OPEN_DOOR,
    HOUSE,
    LOCKED_DOOR,
    MAPMAKER,
    MENTOR,
    MEDICS,
    RESTAURANT,
    SECRET_PASSAGE,
    TAVERN,
    TINKERERS_GUILD,

/* Special addition which must follow others for reasons of backwards
 * compatibility. */

    EXIT_SETTLEMENT
    };

#define MAX_SHOP WEAPONSMITH_FINE

#define NUM_LOCATION_TYPES 27

/* shop flags */

#define BUY_ALL 1L
#define CAN_ACQUIRE_ANYTHING 2L
#define CARRIES_ITEMS 4L
#define CARRIES_ANIMALS 8L
#define NOT_STOCKED 16L

/* Adventuring and non-adventuring professions for different characters.  */

enum
    {

/* Adventurers.  */

    ACROBAT,
    ANIMAL_HANDLER,
    ARCHER,
    BARD,
    HERBALIST,
    HUNTER,
    INTERPRETER,
    JACK_OF_ALL_TRADES,
    MAN_AT_ARMS,
    MEDIC,
    MULTIPLE_PROFESSION,
    SCHOLAR,
    SCOUT,
    WOODSMAN,

/* Non-adventurers.  */

    AFFIRMER,
    ARTISAN,
    BAKER,
    BLACKSMITH,
    BREWER,
    CARPENTER,
    COBBLER,
    COOK,
    DEVICE_MAKER,
    FARMER,
    FISHERMAN,
    GARDENER,
    MASON,
    MERCHANT,
    MYSTIC,
    PHILOSOPHER,
    POET,
    SAILOR,
    SHEPHERD,
    TAILOR,
    TANNER,
    WEAVER,

/* Internal use.  */

    JANRA_ADVENTURER,
    JEC_ADVENTURER,
    NORKRIN_ADVENTURER,
    SHAL_ADVENTURER,
    TUZ_ADVENTURER,
    URVANOVESTILLI_ADVENTURER,
    YEDIDIA_ADVENTURER,
    JANRA_MULTIPLE_PROFESSION, /* Multiple adventuring professions.  */
    JEC_MULTIPLE_PROFESSION,
    NORKRIN_MULTIPLE_PROFESSION,
    SHAL_MULTIPLE_PROFESSION,
    TUZ_MULTIPLE_PROFESSION,
    URVANOVESTILLI_MULTIPLE_PROFESSION,
    YEDIDIA_MULTIPLE_PROFESSION,
    JANRA_PARTY,
    JEC_PARTY,
    NORKRIN_PARTY,
    SHAL_PARTY,
    TUZ_PARTY,
    URVANOVESTILLI_PARTY,
    YEDIDIA_PARTY,
    MULTIRACIAL_PARTY
    };

#define LAST_REAL_PROFESSION WEAVER

enum
    {
    MEAT_NONE,
    MEAT_DEAD,
    MEAT_FILLET,
    MEAT_JERKY,
    MEAT_MEAT,
    MEAT_NAME_ALONE,
    MEAT_ROAST,
    MEAT_STEAK,
    MEAT_VENISON
    };

enum
    {
    PRAYER_ADORATION,
    PRAYER_AEGIS_OF_GOD,
    PRAYER_BLESSING,
    PRAYER_BREATH_OF_GOD,
    PRAYER_BREATH_PRAYER,
    PRAYER_BREATHE_UNDERWATER,
    PRAYER_CHANT,
    PRAYER_CHARIOT_OF_FIRE,
    PRAYER_CONTEMPLATE_SCRIPTURE,
    PRAYER_CONVERSE,
    PRAYER_DANCE,
    PRAYER_DAWN_OF_CREATION,
    PRAYER_DIVINE_SUSTENANCE,
    PRAYER_DOXOLOGY,
    PRAYER_EMPTYING,
    PRAYER_FAVOR_WITH_MAN,
    PRAYER_FINAL_STRIKE,
    PRAYER_FIRE_FROM_HEAVEN,
    PRAYER_FLYING,
    PRAYER_FORTITUDE,
    PRAYER_FUNERAL,
    PRAYER_GUARDIAN_ANGEL,
    PRAYER_HEALING,
    PRAYER_HOLY_GROUND,
    PRAYER_HOLY_OF_HOLIES,
    PRAYER_HUMBLING_BEFORE_GOD,
    PRAYER_IMAGES, /* Praying in a visual language.  */
    PRAYER_INCREASE_ATTRIBUTE,
    PRAYER_INCREASE_FAITH,
    PRAYER_INCREASE_SKILL,
    PRAYER_INSIGHT,
    PRAYER_INTERPRET_TONGUES,
    PRAYER_JANRA_BLESSING,
    PRAYER_KYTHE,
    PRAYER_LIGHTNING_STRIKE,
    PRAYER_LISTEN_TO_CREATION,
    PRAYER_LISTEN_TO_SILENCE,
    PRAYER_LISTEN_TO_THE_ETERNAL_SONG,
    PRAYER_LITURGY,
    PRAYER_LOVE,
    PRAYER_MEDITATION,
    PRAYER_NAME,
    PRAYER_NAME_OF_JESUS,
    PRAYER_OFFER_SELF,
    PRAYER_PATERNOSTER,
    PRAYER_PERSUASION,
    PRAYER_PRAISE_GOD,
    PRAYER_PROLOGUE_TO_JOHN,
    PRAYER_PROVIDENCE,
    PRAYER_RAISE_DEAD,
    PRAYER_RECEIVE_GIFT,
    PRAYER_REJUVENATE,
    PRAYER_RESTORATION,
    PRAYER_REVEAL_TERRAIN,
    PRAYER_SANCTUARY,
    PRAYER_SHINING_LIGHT,
    PRAYER_SILENT_COMMUNION,
    PRAYER_SILENT_CONTEMPLATION,
    PRAYER_SING_IN_TONGUES,
    PRAYER_SING_PRAISES,
    PRAYER_SLAY_CREATURE,
    PRAYER_SPEAK_IN_TONGUES,
    PRAYER_STAR_SONG,
    PRAYER_STILLNESS,
    PRAYER_STOP_TIME,
    PRAYER_SUBMISSION,
    PRAYER_THANKSGIVING,
    PRAYER_TOGETHER_WITH_ANOTHER_PERSON, /* With another person.  */
    PRAYER_TREMBLE,
    PRAYER_WALK_ON_WATER,
    PRAYER_WORSHIP,
    PRAYER_WORSHIP_SERVICE
    };

#define NUM_PRAYERS (PRAYER_WORSHIP_SERVICE + 1)

/* Flags for specific prayers. */

#define PRAY_AVAILABLE 1L
#define PRAY_AUTOMATIC 2L
#define PRAY_REQUIRES_GIFT 4L
#define PRAY_CRITICAL_SUCCESS_PERMANENT 8L
#define PRAY_TWO_CRITICAL_SUCCESSES_PERMANENT 16L
#define PRAY_THREE_CRITICAL_SUCCESSES_PERMANENT 32L
#define PRAY_TAKES_HOUR 64L

/* Flags for spiritual gifts */

#define GIFT_ANY 1L
#define GIFT_COMMUNION 2L
#define GIFT_FAITH 4L
#define GIFT_HEALING 8L
#define GIFT_INTERPRETING_TONGUES 16L
#define GIFT_KNOWLEDGE 32L
#define GIFT_MIRACULOUS_POWERS 64L
#define GIFT_PREACHING 128L
#define GIFT_PROPHECY 256L
#define GIFT_SERVICE 512L
#define GIFT_SPEAKING_IN_TONGUES 1024L
#define GIFT_TEACHING 2048L
#define GIFT_WISDOM 4096L
#define GIFT_WORD_OF_KNOWLEDGE 8192L

#define NUM_GIFTS 14

/* flags for attack_common */

#define ATTACK_IS_HTH 1L
#define ATTACK_IS_MSL 2L
#define ATTACK_HIT 4L
#define ATTACK_MISS 8L
#define ATTACK_ONE_CRITICAL_SUCCESS 16L
#define ATTACK_TWO_CRITICAL_SUCCESSES 32L
#define ATTACK_THREE_CRITICAL_SUCCESSES 64L

/* extract_item flags */

#define EXTRACT_REMOVE_ITEM 1L
#define EXTRACT_RECURSIVE 2L
#define EXTRACT_PROMPT_BOTH_PACK_AND_EQUIPMENT 4L

/* skill check flags */

#define SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE 1L
#define SKILL_CHECK_NO_SIGHT_ADJUST 2L

enum
    {
    ST_DEFAULT, /* i.e. don't look here for the string, have it be some default */
                            /* appropriate to the context.  */
    ST_EMPTY, /* i.e. "" */
    ST_A_BARE_ROOM,
    ST_A_BED,
    ST_A_BEDROOM,
    ST_A_BOLOGNA_SANDWICH,
    ST_A_BRONZE_STATUE_IN_A_NATIVITY_SCENE,
    ST_A_BUILDING,
    ST_A_BUILDING_WOVEN_OUT_OF_LIVING_TREES,
    ST_A_CABINET,
    ST_A_CATHEDRAL,
    ST_A_CHAIR,
    ST_A_CHEMICAL_LABORATORY,
    ST_A_CLOAKROOM,
    ST_A_CLOSED_DOOR,
    ST_A_CLOSET,
    ST_A_COCONUT,
    ST_A_COLLECTION_BOX,
    ST_A_CRYPT,
    ST_A_CUCUMBER,
    ST_A_DEN,
    ST_A_DENSE_FOREST,
    ST_A_DEVICE_LABORATORY,
    ST_A_DIAS,
    ST_A_DOORWAY_OF_HANGING_VINES,
    ST_A_DUNGEON_DEEP_IN_THE_BOWELS_OF_THE_EARTH,
    ST_A_FIRE,
    ST_A_FOUNTAIN,
    ST_A_GARDEN,
    ST_A_GREAT_HALL,
    ST_A_HALLWAY,
    ST_A_HEDGE,
    ST_A_JEC_TOWN,
    ST_A_KITCHEN,
    ST_A_LABYRINTH,
    ST_A_LARGE_AND_WELL_WORN_BOOK,
    ST_A_LIBRARY,
    ST_A_LITTLE_OF_THIS_A_LITTLE_OF_THAT,
    ST_A_MANGO,
    ST_A_MECHANICAL_ROOM,
    ST_A_MUSIC_ROOM,
    ST_A_MYSTERIOUS_DUNGEON,
    ST_A_NECTARINE,
    ST_A_PARLOR,
    ST_A_PARTRIDGE,
    ST_A_PEACEFUL_FOREST,
    ST_A_PEACH,
    ST_A_PEAR,
    ST_A_PEW,
    ST_A_PILE_OF_RUBBLE,
    ST_A_PIT,
    ST_A_POOL_OF_WATER,
    ST_A_REUBEN,
    ST_A_ROCKY_PEAK,
    ST_A_ROOM_WITH_A_DIAS,
    ST_A_ROOM_WITH_MURALS,
    ST_A_SHAL_VILLAGE,
    ST_A_SMALL_ISLAND_IN_THE_OCEAN,
    ST_A_STAINED_GLASS_WINDOW,
    ST_A_STAIRWELL_LEADING_DOWN,
    ST_A_STAIRWELL_LEADING_UP,
    ST_A_STATUE,
    ST_A_STONE_WALL,
    ST_A_STOREROOM,
    ST_A_STREAM,
    ST_A_SYSTEM_OF_CAVERNS,
    ST_A_TABLE,
    ST_A_TABLE_OF_PRAYER_CANDLES,
    ST_A_TANGERINE,
    ST_A_TAVERN,
    ST_A_TORCH,
    ST_A_TREASURY,
    ST_A_TUNA_MELT,
    ST_A_TUZ_VILLAGE,
    ST_A_TWISTY_PASSAGEWAY,
    ST_A_VAST_MANSION,
    ST_A_VERDANT_FOREST,
    ST_A_WINDOW,
    ST_A_WOODEN_WALL,
    ST_A_YEDIDIA_FOREST_VILLAGE,
    ST_ALE_JEC,
    ST_ALE_SHAL,
    ST_ALE_TUZ,
    ST_AN_ALTAR,
    ST_AN_APPLE,
    ST_AN_ARMORY,
    ST_AN_ART_GALLERY,
    ST_AN_ART_STUDIO,
    ST_AN_OPEN_DOOR,
    ST_AN_ORANGE,
    ST_AN_URVANOVESTILLI_CITY,
    ST_ANKLE_BRACELET,
    ST_ANTIPASTA,
    ST_APPLE,
    ST_APPLE_CIDER_SHAL,
    ST_APPLE_CIDER_URVANOVESTILLI,
    ST_APPLE_CIDER_YEDIDIA,
    ST_APPLE_JUICE,
    ST_APPLE_WINE_YEDIDIA,
    ST_ARMOR_FOR_EVERYONE,
    ST_ARMOR_OF_CALIPER_FOR_SERIOUS_ADVENTURERS,
    ST_BACON,
    ST_BEAN_SALAD,
    ST_BEANS,
    ST_BEAR_CURRY,
    ST_BEAR_JERKY,
    ST_BEEF_BARLEY_SOUP,
    ST_BEEF_BARLEY_STEW,
    ST_BEEF_CURRY,
    ST_BEEF_JERKY,
    ST_BEEF_NOODLE_SOUP,
    ST_BEEF_STEW,
    ST_BERRY_TEA,
    ST_BISCUITS,
    ST_BLUE_CHEESE,
    ST_BLUE_LEATHER_BOUND_BOOK,
    ST_BLUEBERRY_WINE_YEDIDIA,
    ST_BOOK_WITH_RAINBOW_CLOTH_COVER,
    ST_BOOKS_OF_CALIPER_FOR_SERIOUS_STUDENTS,
    ST_BRAISED_CABBAGE,
    ST_BRANDY_URVANOVESTILLI,
    ST_BREAD,
    ST_BREAD_AND_CHUTNEY,
    ST_BREADED_RABBIT,
    ST_CAMEMBERT,
    ST_CAPPUCINO_COFFEE,
    ST_CAVIAR,
    ST_CHEESE_MEDLEY,
    ST_CHERRY_CORDIAL_URVANOVESTILLI,
    ST_CHICKEN,
    ST_CHICKEN_CACCIATORE,
    ST_CHICKEN_GUMBO,
    ST_CHOCOLATE,
    ST_CIOPPINO,
    ST_CIRCLE_OF_FRIENDS,
    ST_CLOCKWORK_DEVICES_OF_CALIPER,
    ST_COFISA_TEA,
    ST_COOL_MOCHA_COFFEE,
    ST_COME_AND_EAT,
    ST_COME_ONE_COME_ALL,
    ST_CORNED_BEEF_AND_CABBAGE,
    ST_CRAB,
    ST_CRAB_SALAD,
    ST_CRAM,
    ST_CRYONA,
    ST_CURED_APRICOTS,
    ST_DANDELION_WINE_YEDIDIA,
    ST_DEEP_SALTY_WATER,
    ST_DIAMOND,
    ST_DICED_POTATOES,
    ST_DRAGON_STEAK,
    ST_DRIED_BERRIES,
    ST_DRIED_FISH,
    ST_DRIED_PEACHES,
    ST_EMERALD,
    ST_ENTER_IN_SILENCE,
    ST_EQUIPMENT_FOR_ADVENTURERS,
    ST_EQUIPMENT_OF_CALIPER_FOR_SERIOUS_ADVENTURERS,
    ST_ESCARGOT,
    ST_ESPRESSO_COFFEE,
    ST_EXTRA_STOUT_TUZ,
    ST_FETTUCCINE_ALFREDO,
    ST_FIGS,
    ST_FINELY_CRAFTED_SILVER_RING,
    ST_FISH_CURRY,
    ST_FISH_HEAD_CURRY,
    ST_FLARISTIMMO,
    ST_FRIED_CLAMS,
    ST_FRIED_RICE,
    ST_FRIENDLY_PETS_SOLD_HERE,
    ST_FRITTATA,
    ST_FRUIT_SALAD,
    ST_GIN_URVANOVESTILLI,
    ST_GINGER_BEER,
    ST_GOAT_CHEESE,
    ST_GOAT_CURRY,
    ST_GOAT_KID,
    ST_GOAT_MILK,
    ST_GOLD_RING_WITH_A_LARGE_EMERALD,
    ST_GOLDEN_BROOCH,
    ST_GRAPES,
    ST_GREEN_WINE_URVANOVESTILLI_MISTRELLI,
    ST_GROG_TUZ,
    ST_GUAVA,
    ST_GUAVA_CIDER_YEDIDIA,
    ST_GUAVA_PUREE,
    ST_GUAVA_WINE_YEDIDIA,
    ST_HELSRIANA_TEA,
    ST_HELSRIANA_TEA_SPICED,
    ST_HERBAL_SOUP,
    ST_HOT_TODDY_URVANOVESTILLI,
    ST_HOUSE_RED_WINE,
    ST_HOUSE_WHITE_WINE,
    ST_ILLUMINATED_MANUSCRIPT,
    ST_IVORY_BRACELET,
    ST_JERKY,
    ST_JERKY_CHEESE,
    ST_KHOOR_TUZ,
    ST_KIWI_JUICE,
    ST_KIWI_WINE_YEDIDIA,
    ST_KONSILA_TEA,
    ST_LAGER_JEC,
    ST_LAGER_URVANOVESTILLI,
    ST_LAGER_YEDIDIA,
    ST_LAPIS_LAZULI,
    ST_LASAGNA,
    ST_LEATHERBOUND_BIBLE,
    ST_LEEK_SOUP,
    ST_LEMON_TEA,
    ST_LEMON_WINE_YEDIDIA,
    ST_LENTIL_SOUP,
    ST_LETTUCE_SALAD,
    ST_LISS,
    ST_LOBSTER,
    ST_MANGO_CURRY,
    ST_MAPLE_SYRUP_WINE_YEDIDIA,
    ST_MEAD_JEC,
    ST_MEAD_SHAL,
    ST_MEAD_URVANOVESTILLI,
    ST_MEAD_YEDIDIA,
    ST_MEAT_AND_POTATOES,
    ST_MECHANICAL_EQUIPMENT,
    ST_MEDICAL_HOSPICE_FOR_THE_SICK_AND_WOUNDED,
    ST_MILK,
    ST_MINESTRONE,
    ST_MINT_ESPRESSO_COFFEE,
    ST_MINT_TEA,
    ST_MISCELLANEOUS_EQUIPMENT_FOR_ADVENTURERS,
    ST_MOCHA_COFFEE,
    ST_MOSTACCIOLI,
    ST_MUTTON,
    ST_MUTTON_CURRY,
    ST_NECTARINE_WINE_YEDIDIA,
    ST_NEVER_NEVER_LAND,
    ST_OATMEAL_STOUT_TUZ,
    ST_OLD_ROTTED_TOME,
    ST_ORANGE,
    ST_ORANGE_JUICE,
    ST_ORANGE_TANGERINE_NECTARINE_SALAD,
    ST_ORANGE_WINE_YEDIDIA,
    ST_OUTSIDE_A_JEC_TOWN,
    ST_OUTSIDE_A_PEACEFUL_SHAL_VILLAGE,
    ST_OUTSIDE_A_POOL_OF_WATER,
    ST_OUTSIDE_A_SMALL_ISLAND,
    ST_OUTSIDE_A_SMALL_TUZ_VILLAGE,
    ST_OUTSIDE_A_YEDIDIA_VILLAGE,
    ST_OUTSIDE_AN_URVANOVESTILLI_CITY,
    ST_OUTSIDE_THE_MOUTH_OF_A_CAVERN,
    ST_PAIR_OF_RUBY_EARRINGS,
    ST_PEACH,
    ST_PEACH_PIE,
    ST_PEACH_WINE_YEDIDIA,
    ST_PEAR,
    ST_PEAR_CIDER_SHAL,
    ST_PEAR_CIDER_URVANOVESTILLI,
    ST_PEAR_CIDER_YEDIDIA,
    ST_PEAR_JUICE,
    ST_PEAR_LIQUEUR_URVANOVESTILLI,
    ST_PEAR_WINE_YEDIDIA,
    ST_PEAR_SAUCE_WITH_RAISINS,
    ST_PEARS,
    ST_PEELED_APPLES,
    ST_PEPPER_CHEESE,
    ST_PINEAPPLE,
    ST_PIPE_ORGAN,
    ST_PLUM_PIE,
    ST_PLUMS,
    ST_PORK_SIRLOIN,
    ST_PORTER_TUZ,
    ST_PORTER_URVANOVESTILLI,
    ST_PORTER_YEDIDIA,
    ST_PORTO_URVANOVESTILLI,
    ST_POTATOES,
    ST_PROVIDING_FINE_HORSES_TO_EVERY_CUSTOMER,
    ST_RAISINS,
    ST_RASPBERRY_WINE_YEDIDIA,
    ST_RAVIOLI,
    ST_RED_WINE,
    ST_RED_WINE_JEC_HISH,
    ST_RED_WINE_JEC_HOS,
    ST_RED_WINE_JEC_KANS,
    ST_RED_WINE_JEC_LUT,
    ST_RED_WINE_JEC_MILN,
    ST_RED_WINE_JEC_NUV,
    ST_RED_WINE_JEC_TOL,
    ST_RED_WINE_JEC_VERN,
    ST_RED_WINE_SHAL_HESRI,
    ST_RED_WINE_SHAL_INGSA,
    ST_RED_WINE_SHAL_KASSILLA,
    ST_RED_WINE_SHAL_LITRI,
    ST_RED_WINE_SHAL_MACEP,
    ST_RED_WINE_SHAL_NOLDI,
    ST_RED_WINE_SHAL_SALN,
    ST_RED_WINE_SHAL_SIF,
    ST_RED_WINE_URVANOVESTILLI_CANSOMILTRAMA,
    ST_RED_WINE_URVANOVESTILLI_CAPITELLO,
    ST_RED_WINE_URVANOVESTILLI_ELHANNADAN,
    ST_RED_WINE_URVANOVESTILLI_ELIRE,
    ST_RED_WINE_URVANOVESTILLI_ELMIRTRA,
    ST_RED_WINE_URVANOVESTILLI_KILNATRONA,
    ST_RED_WINE_URVANOVESTILLI_MISTRELLI,
    ST_RED_WINE_URVANOVESTILLI_SANDRELLA,
    ST_RED_WINE_URVANOVESTILLI_STANDRILNATRELLA,
    ST_RED_WINE_URVANOVESTILLI_TALMINDATRII,
    ST_RED_WINE_YEDIDIA_DOSSE,
    ST_RED_WINE_YEDIDIA_EHOLINA,
    ST_RED_WINE_YEDIDIA_FILTRI,
    ST_RED_WINE_YEDIDIA_FISRATIL,
    ST_RED_WINE_YEDIDIA_FISSK,
    ST_RED_WINE_YEDIDIA_SALINA,
    ST_RED_WINE_YEDIDIA_SANLI,
    ST_RED_WINE_YEDIDIA_SILNA,
    ST_RED_WINE_YEDIDIA_VASLI,
    ST_RHOG,
    ST_RICE,
    ST_RICE_WITH_TOMATOES,
    ST_ROAST_APPLE,
    ST_ROAST_BOAR,
    ST_ROAST_FISH,
    ST_ROAST_PEANUTS,
    ST_ROAST_RABBIT,
    ST_ROAST_VENISON,
    ST_ROOT_BEER,
    ST_ROSE_WINE_URVANOVESTILLI_ELIRE,
    ST_ROSE_WINE_YEDIDIA_DOSSE,
    ST_ROSE_WINE_YEDIDIA_EHOLINA,
    ST_ROSE_WINE_YEDIDIA_FILTRI,
    ST_ROSE_WINE_YEDIDIA_FISRATIL,
    ST_ROSE_WINE_YEDIDIA_FISSK,
    ST_ROSE_WINE_YEDIDIA_SALINA,
    ST_ROSE_WINE_YEDIDIA_SANLI,
    ST_ROSE_WINE_YEDIDIA_SILNA,
    ST_ROSE_WINE_YEDIDIA_TIRNA,
    ST_ROSE_WINE_YEDIDIA_VASLI,
    ST_RUBY,
    ST_RUM_CAKES,
    ST_RUM_TUZ,
    ST_RUM_URVANOVESTILLI,
    ST_RYANS_CORNER,
    ST_RYE_BREAD,
    ST_SALAMI,
    ST_SHARING_NATURES_SECRETS_FOR_GENERATIONS,
    ST_SHARP_CHEDDAR,
    ST_SHELVES,
    ST_SHERRY_URVANOVESTILLI,
    ST_SMALL_BLACK_LEATHER_BOOK,
    ST_SMALL_WHITE_BOOK,
    ST_SMALL_JOURNAL,
    ST_SMOKED_BEEF,
    ST_SMOKED_BEER_TUZ,
    ST_SOUP,
    ST_SPAGHETTI,
    ST_SPICED_RUM_TUZ,
    ST_SPICED_RUM_URVANOVESTILLI,
    ST_SPICED_RUM_YEDIDIA,
    ST_SPICED_WINE_SHAL,
    ST_SPICED_WINE_URVANOVESTILLI,
    ST_SPICED_WINE_YEDIDIA,
    ST_SPLIT_PEA_SOUP,
    ST_SQUASH,
    ST_STAR_SAPPHIRE,
    ST_STEAK_AND_BISCUITS,
    ST_STOUT_TUZ,
    ST_STRAWBERRIES,
    ST_STRAWBERRY_CORDIAL_URVANOVESTILLI,
    ST_STRAWBERRY_JUICE,
    ST_STRAWBERRY_PIE,
    ST_STRAWBERRY_TEA,
    ST_STRAWBERRY_WINE_YEDIDIA,
    ST_SUGAR_CANE,
    ST_SUPPLIES_TO_MEET_YOUR_DAY_TO_DAY_NEEDS,
    ST_SYLLII,
    ST_TALINOR_TEA,
    ST_TEQUILA_TUZ,
    ST_TEQUILA_URVANOVESTILLI,
    ST_TEST,
    ST_TEV,
    ST_THE_ADVENTURERS_GUILD,
    ST_THE_BEST_IN_RARE_HERBS,
    ST_THE_BOARS_HEAD,
    ST_THE_BOOK_LOVERS_CORNER,
    ST_THE_COUNTRYSIDE,
    ST_THE_DRAGONS_DEN,
    ST_THE_EAST_RIDGE_MOUNTAINS,
    ST_THE_FLOOR,
    ST_THE_FOG_VALLEY,
    ST_THE_FROZEN_GROUND,
    ST_THE_GRIFFIN,
    ST_THE_GROUND,
    ST_THE_ICE_PEAKS,
    ST_THE_JEC_TOWN_HISH,
    ST_THE_JEC_TOWN_HOS,
    ST_THE_JEC_TOWN_KANS,
    ST_THE_JEC_TOWN_LUT,
    ST_THE_JEC_TOWN_MILN,
    ST_THE_JEC_TOWN_NUV,
    ST_THE_JEC_TOWN_TOL,
    ST_THE_JEC_TOWN_VERN,
    ST_THE_KINGS_COURT,
    ST_THE_LION_TAMERS_DEN,
    ST_THE_LIONHEART,
    ST_THE_MAPMAKERS_SHOP,
    ST_THE_MIDDLE_PLAINS,
    ST_THE_MOONLIT_PATH,
    ST_THE_NORTHERN_WASTES, /* formerly northern plains */
    ST_THE_OCEAN,
    ST_THE_SAILORS_CRAG,
    ST_THE_SANDY_GROUND,
    ST_THE_SHAL_VILLAGE_HESRI,
    ST_THE_SHAL_VILLAGE_INGSA,
    ST_THE_SHAL_VILLAGE_KASSILLA,
    ST_THE_SHAL_VILLAGE_LITRI,
    ST_THE_SHAL_VILLAGE_MACEP,
    ST_THE_SHAL_VILLAGE_NOLDI,
    ST_THE_SHAL_VILLAGE_SALN,
    ST_THE_SHAL_VILLAGE_SIF,
    ST_THE_SILVER_RING,
    ST_THE_SILVERFISH,
    ST_THE_TINKERERS_GUILD,
    ST_THE_TOMB_OF_A_SAINT,
    ST_THE_TUZ_VILLAGE_BORD,
    ST_THE_TUZ_VILLAGE_DOZ,
    ST_THE_TUZ_VILLAGE_GHIRTON,
    ST_THE_TUZ_VILLAGE_GORF,
    ST_THE_TUZ_VILLAGE_KANDRHI,
    ST_THE_TUZ_VILLAGE_KORG,
    ST_THE_TUZ_VILLAGE_KUNDER,
    ST_THE_TUZ_VILLAGE_LUZZ,
    ST_THE_TUZ_VILLAGE_RASTI,
    ST_THE_TUZ_VILLAGE_RHALLTIR,
    ST_THE_TUZ_VILLAGE_RHAV,
    ST_THE_TUZ_VILLAGE_STORNGE,
    ST_THE_TUZ_VILLAGE_TUZZNIR,
    ST_THE_TUZ_VILLAGE_WAZ,
    ST_THE_TUZ_VILLAGE_ZOLK,
    ST_THE_TUZ_VILLAGE_ZUT,
    ST_THE_URVANOVESTILLI_CITY_CANSOMILTRAMA,
    ST_THE_URVANOVESTILLI_CITY_CAPITELLO,
    ST_THE_URVANOVESTILLI_CITY_ELHANNADAN,
    ST_THE_URVANOVESTILLI_CITY_ELIRE,
    ST_THE_URVANOVESTILLI_CITY_ELMIRTRA,
    ST_THE_URVANOVESTILLI_CITY_KILNATRONA,
    ST_THE_URVANOVESTILLI_CITY_MISTRELLI,
    ST_THE_URVANOVESTILLI_CITY_SANDRELLA,
    ST_THE_URVANOVESTILLI_CITY_STANDRILNATRELLA,
    ST_THE_URVANOVESTILLI_CITY_TALMIRNATRII,
    ST_THE_YEDIDIA_VILLAGE_DOSSE,
    ST_THE_YEDIDIA_VILLAGE_EHOLINA,
    ST_THE_YEDIDIA_VILLAGE_FILTRI,
    ST_THE_YEDIDIA_VILLAGE_FISRATIL,
    ST_THE_YEDIDIA_VILLAGE_FISSK,
    ST_THE_YEDIDIA_VILLAGE_SALINA,
    ST_THE_YEDIDIA_VILLAGE_SANLI,
    ST_THE_YEDIDIA_VILLAGE_SILNA,
    ST_THE_YEDIDIA_VILLAGE_TIRNA,
    ST_THE_YEDIDIA_VILLAGE_VASLI,
    ST_THIN_BOOK_WITH_A_DECORATED_SPINE,
    ST_TIGERS_EYE,
    ST_TISANE_TEA,
    ST_TUNA_STEAK,
    ST_TUZ_COFFEE,
    ST_UNDERNEATH_A_TREE,
    ST_VEGETABLE_STEW,
    ST_VENISON,
    ST_VENISON_JERKY,
    ST_WASSAIL_JEC,
    ST_WASSAIL_SHAL,
    ST_WASSAIL_TUZ,
    ST_WASSAIL_URVANOVESTILLI,
    ST_WASSAIL_YEDIDIA,
    ST_WATER,
    ST_WE_HELP_MAKE_A_HOUSE_A_HOME,
    ST_WE_LOCATE_RARE_AND_HARD_TO_FIND_ITEMS,
    ST_WEAPONS_FOR_THE_COMMON_MAN,
    ST_WEAPONS_OF_CALIPER_FOR_SERIOUS_ADVENTURERS,
    ST_WHEAT_BREAD,
    ST_WHISKEY_JEC,
    ST_WHISKEY_URVANOVESTILLI,
    ST_WHITE_WINE,
    ST_WHITE_WINE_SHAL_HESRI,
    ST_WHITE_WINE_SHAL_INGSA,
    ST_WHITE_WINE_SHAL_KASSILLA,
    ST_WHITE_WINE_SHAL_LITRI,
    ST_WHITE_WINE_SHAL_MACEP,
    ST_WHITE_WINE_SHAL_NOLDI,
    ST_WHITE_WINE_SHAL_SALN,
    ST_WHITE_WINE_SHAL_SIF,
    ST_WHITE_WINE_URVANOVESTILLI_CANSOMILTRAMA,
    ST_WHITE_WINE_URVANOVESTILLI_CAPITELLO,
    ST_WHITE_WINE_URVANOVESTILLI_ELHANNADAN,
    ST_WHITE_WINE_URVANOVESTILLI_ELIRE,
    ST_WHITE_WINE_URVANOVESTILLI_ELMIRTRA,
    ST_WHITE_WINE_URVANOVESTILLI_KILNATRONA,
    ST_WHITE_WINE_URVANOVESTILLI_MISTRELLI,
    ST_WHITE_WINE_URVANOVESTILLI_SANDRELLA,
    ST_WHITE_WINE_URVANOVESTILLI_STANDRILNATRELLA,
    ST_WHITE_WINE_URVANOVESTILLI_TALMIRNATRII,
    ST_WHITE_WINE_YEDIDIA_DOSSE,
    ST_WHITE_WINE_YEDIDIA_EHOLINA,
    ST_WHITE_WINE_YEDIDIA_FILTRI,
    ST_WHITE_WINE_YEDIDIA_FISRATIL,
    ST_WHITE_WINE_YEDIDIA_FISSK,
    ST_WHITE_WINE_YEDIDIA_SALINA,
    ST_WHITE_WINE_YEDIDIA_SANLI,
    ST_WHITE_WINE_YEDIDIA_SILNA,
    ST_WHITE_WINE_YEDIDIA_TIRNA,
    ST_WHITE_WINE_YEDIDIA_VASLI,
    ST_YAMS,
    ST_YE_OLDE_JEWELLERS_SHOPPE,
    ST_YONA_TEA,
    ST_YOU_ASCEND_FROM_A_CRYPT,
    ST_YOU_DESCEND_INTO_A_CRYPT,
    ST_YOU_ENTER_A_CATHEDRAL,
    ST_YOU_ENTER_A_TAVERN,
    ST_YOU_LEAVE_A_CATHEDRAL,
    ST_YOU_LEAVE_A_JEC_TOWN,
    ST_YOU_LEAVE_A_SHAL_VILLAGE,
    ST_YOU_LEAVE_A_TAVERN,
    ST_YOU_LEAVE_A_TUZ_VILLAGE,
    ST_YOU_LEAVE_A_YEDIDIA_VILLAGE,
    ST_YOU_LEAVE_AN_URVANOVESTILLI_CITY,
    ST_YOU_LEAVE_THE_COUNTRYSIDE,
    ST_YOU_RETURN_TO_THE_COUNTRYSIDE,
    ST_YOU_WALK_INTO_A_JEC_TOWN,
    ST_YOU_WALK_INTO_A_SHAL_VILLAGE,
    ST_YOU_WALK_INTO_A_TUZ_VILLAGE,
    ST_YOU_WALK_INTO_A_YEDIDIA_VILLAGE,
    ST_YOU_WALK_INTO_AN_URVANOVESTILLI_CITY,
    ST_YOUR_SOURCE_FOR_CLOCKWORK_DEVICES
    };

/* Definitions of actions for the 'A' command.  */

enum
    {
    ACTION_ABOUT_THE_AUTHOR,
    ACTION_BECOME_BELLICOSE,
    ACTION_CHARITY_CONTACTS,
    ACTION_CLEAN,
    ACTION_COVER_WITH_POISON,
    ACTION_DEBUG,
    /* Disabled 25 Mar 03 by Jonathan Hayward due to possible crashing related
     * to mounting animals. */
    ACTION_DISMOUNT,
    ACTION_DROP_MONEY,
    ACTION_EXTENDED_HELP,
    ACTION_FILL_WITH_OIL,
    ACTION_FILL_WITH_WATER,
    ACTION_GATHER_FROM_TREE,
    ACTION_GIVE_NAME,
    ACTION_HASTE,
    ACTION_INSERT,
    ACTION_LIST_CHANGES,
    ACTION_MOUNT,
    ACTION_NAP,
    ACTION_PET,
    ACTION_PRINT_SKILL_VALUES,
    ACTION_PUSH_CREATURE,
    ACTION_READ_FAQ_LIST,
    ACTION_REMOVE,
    ACTION_RUN,
    ACTION_SET_OPTIONS,
    ACTION_SLEEP_UNTIL_SUNRISE,
    ACTION_SWAP_PLACES,
    ACTION_WALK
    };

#define NUM_ACTIONS (ACTION_WALK + 1) /* Last action, plus one.  */

#define PEG_GAME_IMAGE_X 9
#define PEG_GAME_IMAGE_Y 4

#define CALCULATOR_X 4
#define CALCULATOR_Y 4

/* Text arguments to be given to the text parser.  */

enum
    {
    TEXT_ACTION,
    TEXT_ATTRIBUTE,
    TEXT_CREATURE,
    TEXT_GIFT,
    TEXT_ITEM,
    TEXT_LOCATION,
    TEXT_PRAYER,
    TEXT_SKILL,
    TEXT_SKILL_FULLSCREEN
    };

#define NUM_TEXT_TYPES (TEXT_SKILL + 1)

/* Distribution types.  */

enum
    {
    DISTRIBUTION_CREATURE,
    DISTRIBUTION_ITEM
    };

/* creature damage flags */

#define CREATURE_DAMAGE_BLUNT_DAMAGE 1L
#define CREATURE_DAMAGE_WAKE_UP 2L
#define CREATURE_DAMAGE_ARMOR_ABSORBS 4L

/* location flags */

#define LOCATION_KNOWN 1L

/* types of talking.  */

enum
    {

/* Racial defaults.  */

    TALK_JANRA,
    TALK_JEC,
    TALK_NORKRIN,
    TALK_SHAL,
    TALK_TUZ,
    TALK_URVANOVESTILLI,
    TALK_YEDIDIA,

/* Specialized kinds of talking.  */

    TALK_CELEBRANT,
    TALK_INTERCESSOR,
    TALK_SERVER
    };

/* Flags for establishments.  */

#define ESTABLISHMENT_JEC_RESTAURANT                    0x00000001L
#define ESTABLISHMENT_JEC_TAVERN                    0x00000002L
#define ESTABLISHMENT_SHAL_RESTAURANT                    0x00000004L
#define ESTABLISHMENT_SHAL_TAVERN                    0x00000008L
#define ESTABLISHMENT_TUZ_RESTAURANT                    0x00000010L
#define ESTABLISHMENT_TUZ_TAVERN                    0x00000020L
#define ESTABLISHMENT_URVANOVESTILLI_RESTAURANT 0x00000040L
#define ESTABLISHMENT_URVANOVESTILLI_TAVERN     0x00000080L
#define ESTABLISHMENT_YEDIDIA_RESTAURANT        0x00000100L
#define ESTABLISHMENT_YEDIDIA_TAVERN            0x00000200L
#define ESTABLISHMENT_ALCOHOL                   0x00000400L
#define ESTABLISHMENT_CAFFEINE                  0x00000800L
#define ESTABLISHMENT_COFISA_TEA                0x00001000L
#define ESTABLISHMENT_HELSRIANA_TEA             0x00002000L
#define ESTABLISHMENT_TALINOR_TEA               0x00004000L
#define ESTABLISHMENT_FIREBREATHER              0x00008000L
#define ESTABLISHMENT_QUENCH_THIRST             0x00010000L
#define ESTABLISHMENT_MAKE_SLEEPY                0x00020000L
#define ESTABLISHMENT_WARM_UP                        0x00040000L
#define ESTABLISHMENT_FOOD                      0x00080000L

/* What is served at eating establishments.  */

enum
    {

/* Foods.  */

    ED_ANTIPASTA,
    ED_AN_APPLE,
    ED_BACON,
    ED_BEAN_SALAD,
    ED_BEANS,
    ED_BEAR_CURRY,
    ED_BEAR_JERKY,
    ED_BEEF_BARLEY_SOUP,
    ED_BEEF_BARLEY_STEW,
    ED_BEEF_CURRY,
    ED_BEEF_JERKY,
    ED_BEEF_NOODLE_SOUP,
    ED_BEEF_STEW,
    ED_BISCUITS,
    ED_A_BOLOGNA_SANDWICH,
    ED_BRAISED_CABBAGE,
    ED_BREAD,
    ED_BREAD_AND_CHUTNEY,
    ED_BREADED_RABBIT,
    ED_CAMEMBERT,
    ED_CAVIAR,
    ED_CHEESE_MEDLEY,
    ED_CHICKEN,
    ED_CHICKEN_CACCIATORE,
    ED_CHICKEN_GUMBO,
    ED_CHOCOLATE,
    ED_CIOPPINO,
    ED_A_COCONUT,
    ED_CORNED_BEEF_AND_CABBAGE,
    ED_CRAB,
    ED_CRAB_SALAD,
    ED_A_CUCUMBER,
    ED_CURED_APRICOTS,
    ED_DRAGON_STEAK,
    ED_DRIED_PEACHES,
    ED_ESCARGOT,
    ED_FETTUCCINE_ALFREDO,
    ED_FISH_CURRY,
    ED_FISH_HEAD_CURRY,
    ED_FRIED_CLAMS,
    ED_FRIED_RICE,
    ED_FRITTATA,
    ED_FRUIT_SALAD,
    ED_GOAT_CHEESE,
    ED_GOAT_CURRY,
    ED_GOAT_KID,
    ED_GRAPES,
    ED_GUAVA,
    ED_GUAVA_PUREE,
    ED_HERBAL_SOUP,
    ED_LASAGNA,
    ED_LEEK_SOUP,
    ED_LENTIL_SOUP,
    ED_LETTUCE_SALAD,
    ED_LOBSTER,
    ED_A_MANGO,
    ED_MANGO_CURRY,
    ED_MEAT_AND_POTATOES,
    ED_MINESTRONE,
    ED_MOSTACCIOLI,
    ED_MUTTON,
    ED_MUTTON_CURRY,
    ED_A_NECTARINE,
    ED_AN_ORANGE,
    ED_ORANGE_TANGERINE_NECTARINE_SALAD,
    ED_A_PARTRIDGE,
    ED_A_PEACH,
    ED_PEACH_PIE,
    ED_A_PEAR,
    ED_PEAR_SAUCE_WITH_RAISINS,
    ED_PEARS,
    ED_PEELED_APPLES,
    ED_PEPPER_CHEESE,
    ED_PINEAPPLE,
    ED_PLUM_PIE,
    ED_PLUMS,
    ED_PORK_SIRLOIN,
    ED_POTATOES,
    ED_RAVIOLI,
    ED_A_REUBEN,
    ED_RICE,
    ED_RICE_WITH_TOMATOES,
    ED_ROAST_APPLE,
    ED_ROAST_BOAR,
    ED_ROAST_FISH,
    ED_ROAST_PEANUTS,
    ED_ROAST_RABBIT,
    ED_ROAST_VENISON,
    ED_RUM_CAKES,
    ED_RYE_BREAD,
    ED_SALAMI,
    ED_SHARP_CHEDDAR,
    ED_SOUP,
    ED_SPAGHETTI,
    ED_SPLIT_PEA_SOUP,
    ED_SQUASH,
    ED_STEAK_AND_BISCUITS,
    ED_STRAWBERRIES,
    ED_STRAWBERRY_PIE,
    ED_SUGAR_CANE,
    ED_A_TANGERINE,
    ED_A_TUNA_MELT,
    ED_TUNA_STEAK,
    ED_VEGETABLE_STEW,
    ED_VENISON,
    ED_VENISON_JERKY,
    ED_WHEAT_BREAD,
    ED_YAMS,

/* Drinks.  */

    ED_ALE_JEC,
    ED_ALE_SHAL,
    ED_ALE_TUZ,
    ED_APPLE_CIDER_SHAL,
    ED_APPLE_CIDER_URVANOVESTILLI,
    ED_APPLE_CIDER_YEDIDIA,
    ED_APPLE_JUICE,
    ED_APPLE_WINE_YEDIDIA,
    ED_BERRY_TEA,
    ED_BLUEBERRY_WINE_YEDIDIA,
    ED_CAPPUCINO_COFFEE,
    ED_CHERRY_CORDIAL_URVANOVESTILLI,
    ED_COFISA_TEA,
    ED_COOL_MOCHA_COFFEE,
    ED_DANDELION_WINE_YEDIDIA,
    ED_ESPRESSO_COFFEE,
    ED_EXTRA_STOUT_TUZ,
    ED_GINGER_BEER,
    ED_GIN_URVANOVESTILLI,
    ED_GOAT_MILK,
    ED_GREEN_WINE_URVANOVESTILLI_MISTRELLI,
    ED_GROG_TUZ,
    ED_GUAVA_CIDER_YEDIDIA,
    ED_GUAVA_WINE_YEDIDIA,
    ED_HELSRIANA_TEA,
    ED_HELSRIANA_TEA_SPICED,
    ED_HOT_TODDY_URVANOVESTILLI,
    ED_HOUSE_RED_WINE,
    ED_HOUSE_WHITE_WINE,
    ED_KHOOR_TUZ,
    ED_KIWI_JUICE,
    ED_KIWI_WINE_YEDIDIA,
    ED_KONSILA_TEA,
    ED_LAGER_JEC,
    ED_LAGER_URVANOVESTILLI,
    ED_LAGER_YEDIDIA,
    ED_LEMON_TEA,
    ED_LEMON_WINE_YEDIDIA,
    ED_MAPLE_SYRUP_WINE_YEDIDIA,
    ED_MEAD_JEC,
    ED_MEAD_SHAL,
    ED_MEAD_URVANOVESTILLI,
    ED_MEAD_YEDIDIA,
    ED_MILK,
    ED_MINT_ESPRESSO_COFFEE,
    ED_MINT_TEA,
    ED_MOCHA_COFFEE,
    ED_NECTARINE_WINE_YEDIDIA,
    ED_OATMEAL_STOUT_TUZ,
    ED_ORANGE_JUICE,
    ED_ORANGE_WINE_YEDIDIA,
    ED_PEACH_WINE_YEDIDIA,
    ED_PEAR_CIDER_SHAL,
    ED_PEAR_CIDER_URVANOVESTILLI,
    ED_PEAR_CIDER_YEDIDIA,
    ED_PEAR_JUICE,
    ED_PEAR_LIQUEUR_URVANOVESTILLI,
    ED_PEAR_WINE_YEDIDIA,
    ED_PORTER_TUZ,
    ED_PORTER_URVANOVESTILLI,
    ED_PORTER_YEDIDIA,
    ED_PORTO_URVANOVESTILLI,
    ED_RASPBERRY_WINE_YEDIDIA,
    ED_RED_WINE_JEC_HISH,
    ED_RED_WINE_JEC_HOS,
    ED_RED_WINE_JEC_KANS,
    ED_RED_WINE_JEC_LUT,
    ED_RED_WINE_JEC_MILN,
    ED_RED_WINE_JEC_NUV,
    ED_RED_WINE_JEC_TOL,
    ED_RED_WINE_JEC_VERN,
    ED_RED_WINE_SHAL_HESRI,
    ED_RED_WINE_SHAL_INGSA,
    ED_RED_WINE_SHAL_KASSILLA,
    ED_RED_WINE_SHAL_LITRI,
    ED_RED_WINE_SHAL_MACEP,
    ED_RED_WINE_SHAL_NOLDI,
    ED_RED_WINE_SHAL_SALN,
    ED_RED_WINE_SHAL_SIF,
    ED_RED_WINE_URVANOVESTILLI_CANSOMILTRAMA,
    ED_RED_WINE_URVANOVESTILLI_CAPITELLO,
    ED_RED_WINE_URVANOVESTILLI_ELHANNADAN,
    ED_RED_WINE_URVANOVESTILLI_ELIRE,
    ED_RED_WINE_URVANOVESTILLI_ELMIRTRA,
    ED_RED_WINE_URVANOVESTILLI_KILNATRONA,
    ED_RED_WINE_URVANOVESTILLI_MISTRELLI,
    ED_RED_WINE_URVANOVESTILLI_SANDRELLA,
    ED_RED_WINE_URVANOVESTILLI_STANDRILNATRELLA,
    ED_RED_WINE_URVANOVESTILLI_TALMINDATRII,
    ED_RED_WINE_YEDIDIA_DOSSE,
    ED_RED_WINE_YEDIDIA_EHOLINA,
    ED_RED_WINE_YEDIDIA_FILTRI,
    ED_RED_WINE_YEDIDIA_FISRATIL,
    ED_RED_WINE_YEDIDIA_FISSK,
    ED_RED_WINE_YEDIDIA_SALINA,
    ED_RED_WINE_YEDIDIA_SANLI,
    ED_RED_WINE_YEDIDIA_SILNA,
    ED_RED_WINE_YEDIDIA_VASLI,
    ED_ROOT_BEER,
    ED_ROSE_WINE_URVANOVESTILLI_ELIRE,
    ED_ROSE_WINE_YEDIDIA_DOSSE,
    ED_ROSE_WINE_YEDIDIA_EHOLINA,
    ED_ROSE_WINE_YEDIDIA_FILTRI,
    ED_ROSE_WINE_YEDIDIA_FISRATIL,
    ED_ROSE_WINE_YEDIDIA_FISSK,
    ED_ROSE_WINE_YEDIDIA_SALINA,
    ED_ROSE_WINE_YEDIDIA_SANLI,
    ED_ROSE_WINE_YEDIDIA_SILNA,
    ED_ROSE_WINE_YEDIDIA_TIRNA,
    ED_ROSE_WINE_YEDIDIA_VASLI,
    ED_RUM_TUZ,
    ED_RUM_URVANOVESTILLI,
    ED_SHERRY_URVANOVESTILLI,
    ED_SMOKED_BEER_TUZ,
    ED_SPICED_RUM_TUZ,
    ED_SPICED_RUM_URVANOVESTILLI,
    ED_SPICED_RUM_YEDIDIA,
    ED_SPICED_WINE_SHAL,
    ED_SPICED_WINE_URVANOVESTILLI,
    ED_SPICED_WINE_YEDIDIA,
    ED_STOUT_TUZ,
    ED_STRAWBERRY_CORDIAL_URVANOVESTILLI,
    ED_STRAWBERRY_JUICE,
    ED_STRAWBERRY_TEA,
    ED_STRAWBERRY_WINE_YEDIDIA,
    ED_TALINOR_TEA,
    ED_TEQUILA_TUZ,
    ED_TEQUILA_URVANOVESTILLI,
    ED_TISANE_TEA, /* Makes tired.  */
    ED_TUZ_COFFEE,
    ED_WASSAIL_JEC,
    ED_WASSAIL_SHAL,
    ED_WASSAIL_TUZ,
    ED_WASSAIL_URVANOVESTILLI,
    ED_WASSAIL_YEDIDIA,
    ED_WATER,
    ED_WHISKEY_JEC,
    ED_WHISKEY_URVANOVESTILLI,
    ED_WHITE_WINE_SHAL_HESRI,
    ED_WHITE_WINE_SHAL_INGSA,
    ED_WHITE_WINE_SHAL_KASSILLA,
    ED_WHITE_WINE_SHAL_LITRI,
    ED_WHITE_WINE_SHAL_MACEP,
    ED_WHITE_WINE_SHAL_NOLDI,
    ED_WHITE_WINE_SHAL_SALN,
    ED_WHITE_WINE_SHAL_SIF,
    ED_WHITE_WINE_URVANOVESTILLI_CANSOMILTRAMA,
    ED_WHITE_WINE_URVANOVESTILLI_CAPITELLO,
    ED_WHITE_WINE_URVANOVESTILLI_ELHANNADAN,
    ED_WHITE_WINE_URVANOVESTILLI_ELIRE,
    ED_WHITE_WINE_URVANOVESTILLI_ELMIRTRA,
    ED_WHITE_WINE_URVANOVESTILLI_KILNATRONA,
    ED_WHITE_WINE_URVANOVESTILLI_MISTRELLI,
    ED_WHITE_WINE_URVANOVESTILLI_SANDRELLA,
    ED_WHITE_WINE_URVANOVESTILLI_STANDRILNATRELLA,
    ED_WHITE_WINE_URVANOVESTILLI_TALMIRNATRII,
    ED_WHITE_WINE_YEDIDIA_DOSSE,
    ED_WHITE_WINE_YEDIDIA_EHOLINA,
    ED_WHITE_WINE_YEDIDIA_FILTRI,
    ED_WHITE_WINE_YEDIDIA_FISRATIL,
    ED_WHITE_WINE_YEDIDIA_FISSK,
    ED_WHITE_WINE_YEDIDIA_SALINA,
    ED_WHITE_WINE_YEDIDIA_SANLI,
    ED_WHITE_WINE_YEDIDIA_SILNA,
    ED_WHITE_WINE_YEDIDIA_TIRNA,
    ED_WHITE_WINE_YEDIDIA_VASLI,
    ED_YONA_TEA
    };

#define NUM_ESTABLISHMENT_ITEMS (ED_YONA_TEA + 1)

#define ESTABLISHMENT_ITEM_AVAILABLE 1L

/* Definitions of room types, for cavern and mansion.  */

enum
    {
    ROOM_ARMORY,
    ROOM_ART_GALLERY,
    ROOM_ART_STUDIO,
    ROOM_BARE_ROOM,
    ROOM_BEDROOM,
    ROOM_CHEMICAL_LABORATORY,
    ROOM_CLOAKROOM,
    ROOM_CLOSET,
    ROOM_DEN,
    ROOM_DEVICE_LABORATORY,
    ROOM_GREAT_HALL,
    ROOM_HALLWAY,
    ROOM_KITCHEN,
    ROOM_LIBRARY,
    ROOM_MECHANICAL_ROOM,
    ROOM_MUSIC_ROOM,
    ROOM_PARLOR,
    ROOM_ROOM_WITH_A_DIAS,
    ROOM_ROOM_WITH_MURALS,
    ROOM_STOREROOM,
    ROOM_TREASURY
    };

/* Return codes for the player keystroke in read_file */

enum
    {
    READ_FILE_CONTINUE,
    READ_FILE_HELP,
    READ_FILE_PAGE_DOWN,
    READ_FILE_PAGE_UP,
    READ_FILE_QUIT,
    READ_FILE_REFRESH,
    READ_FILE_SEARCH_BACKWARDS,
    READ_FILE_SEARCH_FORWARDS
    };

/* Definitions of data structures */

enum
    {
    ADJ_INFO_STRUCT,
    ADJ_STRUCT,
    CLIST,
    ESTABLISHMENT_STRUCT,
    FAITH_STRUCT,
    GAME_VARIABLES_STRUCT,
    ILIST,
    LEVEL,
    LIGHT_SOURCE_STRUCT,
    LLIST,
    MASTER_CREATURE,
    MASTER_ITEM,
    POINTER_STRUCT,
    PUZZLE_SPACE_STRUCT,
    SHOP_STRUCT,
    SKILL,
    SKILLS_STRUCT,
    SMALL_CREATURE,
    SMALL_ITEM,
    SPECIAL_STRUCT,
    TEXT_STRUCT
    };

/* The names of the files in the lib directory. */

#define FILE_ABOUT_THE_AUTHOR "aauthor.txt"
#define FILE_ABRIDGED_HELP "scomm.txt"
#define FILE_ARCHERY_TOURNAMENT_RULES "archery.txt"
#define FILE_BENEDICTIONS "benedict.txt"
#define FILE_BOARD_PUZZLE_HELP "bpuzhelp.txt"
#define FILE_BOOK_A_DREAM_OF_LIGHT "book1.txt"
#define FILE_BOOK_A_PICTURE_OF_EVIL "book2.txt"
#define FILE_BOOK_BIBLE "bible.txt"
#define FILE_BOOK_CULTURES "book5.txt"
#define FILE_BOOK_KOANS "book3.txt"
#define FILE_BOOK_RIDDLES "book6.txt"
#define FILE_BOOK_ROSTER_OF_HEROES "book8.txt"
#define FILE_BOOK_THE_NATURE_OF_A_SAINT "book7.txt"
#define FILE_BOOK_THE_WAY_OF_THE_WAY "book4.txt"
#define FILE_BOOK_THE_WRITINGS_OF_THE_ADVENTURERS "book9.txt"
#define FILE_CATHEDRAL_1 "cath01.dat"
#define FILE_CATHEDRAL_2 "cath02.dat"
#define FILE_CATHEDRAL_3 "cath03.dat"
#define FILE_CATHEDRAL_4 "cath04.dat"
#define FILE_CATHEDRAL_5 "cath05.dat"
#define FILE_CHANGES "changes.txt"
#define FILE_CHARIOT_OF_FIRE "chariot.txt"
#define FILE_CHARITY_CONTACTS "charity.txt"
#define FILE_COMMUNION "communio.txt"
#define FILE_COPYRIGHT "copyrigh.txt"
#define FILE_COUNTRYSIDE "countrys.dat"
#define FILE_CRYPT_1 "crypt01.dat"
#define FILE_CRYPT_2 "crypt02.dat"
#define FILE_CRYPT_3 "crypt03.dat"
#define FILE_CULTURES "cultures.txt"
#define FILE_EXTENDED_HELP "help.txt"
#define FILE_FAQ_LIST "faq.txt"
#define FILE_FINAL_QUEST_DUNGEON "final.dat"
#define FILE_FINAL_QUEST_LOSE "fail.txt"
#define FILE_FINAL_QUEST_TEST "lasttest.txt"
#define FILE_FINAL_QUEST_WIN "win.txt"
#define FILE_GM_INTRO "gm.txt"
#define FILE_HELP "commands.txt"
#define FILE_HINTS "hints.txt"
#define FILE_HOMILIES "homilies.txt"
#define FILE_HYMNS "hymns.txt"
#define FILE_OCEAN_ISLE "isle.dat"
#define FILE_ICE_PEAKS_POOL "ice_peak.dat"
#define FILE_INVOCATIONS_TO_WORSHIP "invocati.txt"
#define FILE_JANRA_BALL "jball.txt"
#define FILE_MODEL "model.txt"
#define FILE_MOTD "motd.txt"
#define FILE_NAMES_JANRA "jnames.txt"
#define FILE_NAMES_JEC "cnames.txt"
#define FILE_NAMES_NORKRIN "nnames.txt"
#define FILE_NAMES_SHAL "snames.txt"
#define FILE_NAMES_TUZ "tnames.txt"
#define FILE_NAMES_URVANOVESTILLI "unames.txt"
#define FILE_NAMES_YEDIDIA "ynames.txt"
#define FILE_NOTES "notes.txt"
#define FILE_PEG_PUZZLE_HELP "ppuzhelp.txt"
#define FILE_PLAYER_ENTERS_GAME "enter.txt"
#define FILE_PLAYER_INTRO "player.txt"
#define FILE_PRAYERS "prayers.txt"
#define FILE_PRINT_ATTRIBUTES_ABBREVIATIONS "pa_abbr.txt"
#define FILE_QUEST_ANSWERED_RIDDLE "questar.txt"
#define FILE_QUEST_CHOSEN_QUEST "questcq.txt"
#define FILE_QUEST_COMPLETED_DUNGEON "questcd.txt"
#define FILE_QUEST_CONTRADICTION "questc.txt"
#define FILE_QUEST_DOZEN_GIANT_SCORPIONS "questdgs.txt"
#define FILE_QUEST_EXPLORED_MISTRELLI "questem2.txt"
#define FILE_QUEST_EXPLORED_OCEAN "questeo.txt"
#define FILE_QUEST_FINAL_QUEST "questfq.txt"
#define FILE_QUEST_GAVE_GIFT "questgg.txt"
#define FILE_QUEST_GUESSED_JANRA "questgj.txt"
#define FILE_QUEST_MAN_WITHOUT_EYES "questmwe.txt"
#define FILE_QUEST_MECHANICAL_PUZZLE "questmp1.txt"
#define FILE_QUEST_MECHANICAL_PUZZLE_II "questmp2.txt"
#define FILE_QUEST_MECHANICAL_PUZZLE_III "questmp3.txt"
#define FILE_QUEST_MISSING_LETTERS "questml.txt"
#define FILE_QUEST_NAMED_CHILD "questnc.txt"
#define FILE_QUEST_PETTED_DOLPHIN "questpd.txt"
#define FILE_QUEST_SERPENT_JEWEL "questsj.txt"
#define FILE_QUEST_SLEW_BEHEMOTH "questsb.txt"
#define FILE_QUEST_SLEW_KRAKEN "questsk.txt"
#define FILE_QUEST_SLEW_LEVIATHAN "questsl.txt"
#define FILE_QUEST_SLEW_ROC "questsr.txt"
#define FILE_QUEST_SLEW_TERRASK "questst.txt"
#define FILE_QUEST_TAMED_ANIMAL "questta.txt"
#define FILE_QUEST_WAS "questw.txt"
#define FILE_QUEST_WON_ARCHERY "questwa.txt"
#define FILE_QUEST_WRESTLED_BLACKSMITH "questwb.txt"
#define FILE_QUESTMASTER_INTRO "questm.txt"
#define FILE_QUESTS_COMPLETED "questsc.txt"
#define FILE_QUOTES "quotes.txt"
#define FILE_READ_FILE_HELP "rf_help.txt"
#define FILE_RIDDLE_CONTRADICTION "riddlec.txt"
#define FILE_RIDDLE_DIAMOND_CHALICE "riddledc.txt"
#define FILE_RIDDLE_LETTER_H "riddlelh.txt"
#define FILE_RIDDLE_MISSING_LETTERS "riddleml.txt"
#define FILE_SCRIPTURE_PASSAGES "scriptur.txt"
#define FILE_SIMPLE_MODEL "simple.txt"
#define FILE_TAVERN_1 "tavern01.dat"
#define FILE_TAVERN_2 "tavern02.dat"
#define FILE_TAVERN_3 "tavern03.dat"
#define FILE_TAVERN_4 "tavern04.dat"
#define FILE_THANKS "thanks.txt"
#define FILE_TOMBSTONE "tombston.txt"
#define FILE_TRANSLATION_FAILED "mistrans.txt"
#define FILE_WHYPLAY "whyplay.txt"

/* Use one of the free slots for knowledges */

struct master_creature /* includes player */
    {
    char name[256], species[256], title[256], other[256], body[256], image;
    long po, wa, /* used for animals, not humans */ attributes[NUM_ATTRIBUTES],
      perm_attributes[NUM_ATTRIBUTES];
    long att, dmg, haste, wounded, phv, def, sharp, blunt, profession, penalty,
      price,
      value, move, moving_direction_x,
      moving_direction_y, natural_weight, attack_time, number;
    struct faith_struct *faith;
    long persuade_diff /* animal handling diff. for animals */,
      study_points, talk;
    long meat_type;
    long chance_hostility /* to a new creature on the level.  (Percentage)  */,
      c_other;
    long age, age_class, max_age, race /* species for an animal */, gender;
    long flags, slots, radius, /* of light source, etc.  */ available_slot2,
      curr_weight;
    long au, el, si, cu, hand_to_hand_attack_messages, missle_attack_messages;
    struct clist *follow, *hostile;
    struct small_creature *mount;
    struct ilist *wear_wield, *pack;
    struct adj_struct *stati; /* how long certain stati will last. */
    struct skills_struct *skills;
    long unspent_ep, total_ep, effective_ep, partial_ep /* thousandths
    or something like that */;
    };

struct master_item
    {
    char nonidentified[256], identified[256], noniddesc[256], iddesc[256],
        image;
    long identity, number, /* more than one arrow, etc.  Default is average
    number, 1+trandom()%n+trandom()%n */ uses, maxuses, effect, time /* to
    use */, wa, po, penalty /* to ag, de, sp */,
    skill_adjust[2][2] /* What skill is adjusted, and how much */,
    skill_enable[2], other;
    /* skill adjust: first number is skill adjusted, second is how much. */
    long flags, slots, weight, value, acq_diff, cdce_diff, sharp, blunt, range
    /* when used */, size, space /* inside, for a container */, space_filled,
    weight_contained, other1, other2, other3, price /* asking price if */
    /* HAGGLED has not been set, final price if it has */, flags2 /* A second
      set */
    /* of flags; I've already used the bits in the first integer.  */;
    struct ilist *contents;
    };

struct text_struct
    {
    void *me;
    char text[118];
    struct text_struct *next;
    };

struct read_file_text_struct
    {
    void *me;
    char text[256];
    struct read_file_text_struct *next, *prev;
    };

struct small_creature
    {
    void *me;
    struct text_struct *name;
    long identity, race, age, att, dmg, hv, def, sp, sharp, blunt, x, y,
      epvalue, price, attack_time, wounded, nextaction, flags;
    struct clist *follow, *followed_by, *hostile;
    struct master_creature *extended;
    };

struct small_item
    {
    void *me;
    long identity, name, number, uses, value, price, weight, space_filled,
        weight_contained, flags, flags2, other;
    struct text_struct *tname;
    struct ilist *contents;
    struct text_struct *writing;
    struct clist *creatures;
    };

struct skill
    {
    char name[256];
    long adjustments[NUM_ATTRIBUTES];
    long learning_difficulty, effect, flags, time;
    };

struct skills_struct
    {
    void *me;
    long ub[NUM_SKILLS], bv[NUM_SKILLS], ep[NUM_SKILLS], mod[NUM_SKILLS],
    av[NUM_SKILLS]; /* work in ep bit */
    };

struct clist
    {
    void *me;
    struct small_creature *current;
    struct clist *next;
    };

struct ilist
    {
    void *me;
    struct small_item *current;
    struct ilist *next;
    };

struct llist
    {
    void *me;
    struct level *current;
    struct llist *next;
    };

struct space_struct
    {
    void *me;
    char image;
    long space_description, room_description;
    long flags, au, el, si, cu, type, property, sign, other;
    /* Other is sign if the place has a sign.  */
    struct clist *creatures;
    struct ilist *items;
    struct special_struct *special;
    };

struct location_struct
    {
    void *me;
    long flags, identity, x, y;
    };

struct level
    {
    void *me;
    long environment_name, entrance_message, exit_message;
    long flags, scale, timescale, power_level, level_type, race,
      animal_encounter_type, animal_encounter_frequency, human_encounter_type,
      human_encounter_frequency;
    struct space_struct space[MAX_X][MAX_Y];
    struct location_struct location[NUM_LOCATION_TYPES];
    struct establishment_struct *establishment;
    struct light_source_struct *light_sources;
    struct clist *creatures;
    };

struct special_struct
    {
    void *me;
    long flags, level_flags, type, x, y /* that it takes a player to, on the */
        /* next level or possibly affects, on the current level */;
    long level_type, animal_encounter_type /* for countryside -- level type is
      what */
    /* kind of level for a random encounter; encounter type is what kind of */
    /* monster for a random encounter */, animal_encounter_frequency /*
      encounter 1 */
    /* time in n, checked hourly -- a 0 indicates no encounters */,
    human_encounter_type, human_encounter_frequency, other;
    struct establishment_struct *establishment;
    struct shop_struct *shop;
    struct text_struct *text;
    struct level *takes_player_to;
    /* struct special_struct *special; */
    };

struct shop_struct
    {
    void *me;
    long merchandise, flags, markup, buyback;
    struct ilist *items;
    struct clist *creatures;
    };

struct game_variables_struct
    {
    void *me;
    long messages_printed, fs_messages_printed, elapsed_units,
    elapsed_days, display_center_x, display_center_y, display_type,
    flags, quests_completed, current_quest, indent_width, new_level_player_x,
    new_level_player_y, scorpion_stings_found, countryside_player_x,
    countryside_player_y, save_file_compression_level;
    };

struct adj_info_struct
    {
    long identity, time_increment, adjustments[NUM_ATTRIBUTES], min
        /* adjustment value */, max, flags;
    };

struct adj_struct
    {
    void *me;
    long time[NUM_STATI], permanent[NUM_STATI];
    };

struct faith_struct
    {
    void *me;
    struct text_struct *breath_prayer;
    long faith, gifts, prayers[NUM_PRAYERS];
    };

struct establishment_info_struct
    {
    long identity, string, flags, chance, price;
    };

struct establishment_struct
    {
    void *me;
    long flags[NUM_ESTABLISHMENT_ITEMS], price[NUM_ESTABLISHMENT_ITEMS];
    };

struct pointer_struct
    {
    void *me;
    struct pointer_struct *old_address; /* Not really pointers used
      traditionally.  */
    struct pointer_struct *new_address;
    long data_type;
    struct pointer_struct *next;
    };

struct light_source_struct /* For movable light sources -- so we can keep */
                           /* track of when they move around, turn on and */
                           /* off, etc., and deal with the level accordingly */
    {
    void *me;
    long x, y, radius, is_on;
    struct small_creature *holder; /* NULL if the source is not being carried */
                                   /* by a creature */
    struct light_source_struct *next;
    };

struct prayer_struct
    {
    char name[256];
    long difficulty, identity, gifts, flags;
    };

struct puzzle_space_struct
    {
    void *me;
    long image, flags, strategic_value;
    };

struct list_text_struct
    {
    char string[256];
    long identity;
    };

extern struct establishment_info_struct establishment_info
  [NUM_ESTABLISHMENT_ITEMS];
extern struct list_text_struct actions[NUM_ACTIONS];
extern struct list_text_struct attributes[NUM_ATTRIBUTES];
extern struct list_text_struct gifts[NUM_GIFTS];
extern struct list_text_struct locations[NUM_LOCATION_TYPES + 1];
extern struct small_creature *player;
extern struct clist *master_clist;
extern struct ilist *master_ilist;
extern struct llist *master_llist;
extern struct game_variables_struct *game_variables;
extern struct level *current_level, *countryside, *main_city, *prev_level;
extern struct master_item *master_items[NUM_ITEMS][3];
extern struct pointer_struct *master_pointers;

extern struct pointer_index_struct *pointer_index;
extern WINDOW *top_text, *left_panel, *bottom_panel, *dungeon, *puzzle;

extern char calculator_image[CALCULATOR_Y + 1][CALCULATOR_X];
extern char down_peg_image[PEG_GAME_IMAGE_Y][PEG_GAME_IMAGE_X];
extern char up_peg_image[PEG_GAME_IMAGE_Y][PEG_GAME_IMAGE_X];
extern char* save_filename;
extern long acrobat[NUM_DIST_SLOTS][3];
extern long adventurer_race[NUM_DIST_SLOTS][3];
extern long age_attribute_adjustment[NUM_AGE_CLASSES][NUM_ATTRIBUTES];
extern long age_class_years[NUM_RACES+1][NUM_AGE_CLASSES];
extern long animal_handler[NUM_DIST_SLOTS][3];
extern long archer[NUM_DIST_SLOTS][3];
extern long armor[NUM_DIST_SLOTS][3];
extern long art[NUM_DIST_SLOTS][3];
extern long attack_hth_dist[NUM_DIST_SLOTS][3];
extern long attack_msl_dist[NUM_DIST_SLOTS][3];
extern long bard[NUM_DIST_SLOTS][3];
extern long boat[NUM_DIST_SLOTS][3];
extern long bookstore_item[NUM_DIST_SLOTS][3];
extern long building_item[NUM_DIST_SLOTS][3];
extern long device[NUM_DIST_SLOTS][3];
extern long dungeon_doors[NUM_DIST_SLOTS][3];
extern long dungeon_item[NUM_DIST_SLOTS][3];
extern long fencing_dist[NUM_DIST_SLOTS][3];
extern long fishing_encounter[NUM_DIST_SLOTS][3];
extern long furniture[NUM_DIST_SLOTS][3];
extern long gardens[NUM_GARDENS][5][5];
extern long gender_attribute_adjustment[NUM_GENDERS][NUM_ATTRIBUTES];
extern long gift_dist[NUM_DIST_SLOTS][3];
extern long herbalist[NUM_DIST_SLOTS][3];
extern long herbalist_item[NUM_DIST_SLOTS][3];
extern long hunter[NUM_DIST_SLOTS][3];
extern long interpreter[NUM_DIST_SLOTS][3];
extern long jack_of_all_trades[NUM_DIST_SLOTS][3];
extern long janra_adventurer[NUM_DIST_SLOTS][3];
extern long janra_party[NUM_DIST_SLOTS][3];
extern long janra_profession[NUM_DIST_SLOTS][3];
extern long jec_adventurer[NUM_DIST_SLOTS][3];
extern long jec_doors[NUM_DIST_SLOTS][3];
extern long jec_encounter[NUM_DIST_SLOTS][3];
extern long jec_land_human[NUM_DIST_SLOTS][3];
extern long jec_menu[NUM_DIST_SLOTS][3];
extern long jec_party[NUM_DIST_SLOTS][3];
extern long jec_plains[NUM_DIST_SLOTS][3];
extern long jec_profession[NUM_DIST_SLOTS][3];
extern long jec_town_texture[NUM_DIST_SLOTS][3];
extern long jeweller_item[NUM_DIST_SLOTS][3];
extern long land_special_encounter[NUM_DIST_SLOTS][3];
extern long learning_differences[NUM_LEARNING_DIFFERENCES][3];
extern long level_1_encounter[NUM_DIST_SLOTS][3];
extern long level_2_encounter[NUM_DIST_SLOTS][3];
extern long level_3_encounter[NUM_DIST_SLOTS][3];
extern long level_4_encounter[NUM_DIST_SLOTS][3];
extern long level_5_encounter[NUM_DIST_SLOTS][3];
extern long liquid[NUM_DIST_SLOTS][3];
extern long man_at_arms[NUM_DIST_SLOTS][3];
extern long mansion_doors[NUM_DIST_SLOTS][3];
extern long mansion_rooms[NUM_DIST_SLOTS][3];
extern long maze_texture[NUM_DIST_SLOTS][3];
extern long medic[NUM_DIST_SLOTS][3];
extern long music_dist[NUM_DIST_SLOTS][3];
extern long musical_instrument[NUM_DIST_SLOTS][3];
extern long natural[NUM_DIST_SLOTS][3];
extern long non_device_equipment[NUM_DIST_SLOTS][3];
extern long non_equipment_treasure[NUM_DIST_SLOTS][3];
extern long norkrin_adventurer[NUM_DIST_SLOTS][3];
extern long norkrin_east_ridge_mountains[NUM_DIST_SLOTS][3];
extern long norkrin_encounter[NUM_DIST_SLOTS][3];
extern long norkrin_ice_peaks[NUM_DIST_SLOTS][3];
extern long norkrin_land_human[NUM_DIST_SLOTS][3];
extern long norkrin_party[NUM_DIST_SLOTS][3];
extern long norkrin_plains[NUM_DIST_SLOTS][3];
extern long norkrin_profession[NUM_DIST_SLOTS][3];
extern long ocean[NUM_DIST_SLOTS][3];
extern long outdoors_item[NUM_DIST_SLOTS][3];
extern long racial_attribute_adjustment[NUM_RACES][NUM_ATTRIBUTES];
extern long racial_base_skills[NUM_SKILLS][NUM_RACES+2];
extern long scholar[NUM_DIST_SLOTS][3];
extern long scout[NUM_DIST_SLOTS][3];
extern long sea_encounter[NUM_DIST_SLOTS][3];
extern long sea_special_encounter[NUM_DIST_SLOTS][3];
extern long shal_adventurer[NUM_DIST_SLOTS][3];
extern long shal_doors[NUM_DIST_SLOTS][3];
extern long shal_encounter[NUM_DIST_SLOTS][3];
extern long shal_forest[NUM_DIST_SLOTS][3];
extern long shal_land_human[NUM_DIST_SLOTS][3];
extern long shal_menu[NUM_DIST_SLOTS][3];
extern long shal_party[NUM_DIST_SLOTS][3];
extern long shal_profession[NUM_DIST_SLOTS][3];
extern long shal_village_texture[NUM_DIST_SLOTS][3];
extern long skills_dist[NUM_DIST_SLOTS][3];
extern long supplies[NUM_DIST_SLOTS][3];
extern long tiny_item[NUM_DIST_SLOTS][3];
extern long tuz_adventurer[NUM_DIST_SLOTS][3];
extern long tuz_doors[NUM_DIST_SLOTS][3];
extern long tuz_east_ridge_mountains[NUM_DIST_SLOTS][3];
extern long tuz_encounter[NUM_DIST_SLOTS][3];
extern long tuz_forest[NUM_DIST_SLOTS][3];
extern long tuz_land_human[NUM_DIST_SLOTS][3];
extern long tuz_menu[NUM_DIST_SLOTS][3];
extern long tuz_party[NUM_DIST_SLOTS][3];
extern long tuz_profession[NUM_DIST_SLOTS][3];
extern long tuz_village_texture[NUM_DIST_SLOTS][3];
extern long urvanovestilli_adventurer[NUM_DIST_SLOTS][3];
extern long urvanovestilli_city_texture[NUM_DIST_SLOTS][3];
extern long urvanovestilli_doors[NUM_DIST_SLOTS][3];
extern long urvanovestilli_east_ridge_mountains[NUM_DIST_SLOTS][3];
extern long urvanovestilli_encounter[NUM_DIST_SLOTS][3];
extern long urvanovestilli_fog_valley[NUM_DIST_SLOTS][3];
extern long urvanovestilli_land_human[NUM_DIST_SLOTS][3];
extern long urvanovestilli_menu[NUM_DIST_SLOTS][3];
extern long urvanovestilli_party[NUM_DIST_SLOTS][3];
extern long urvanovestilli_plains[NUM_DIST_SLOTS][3];
extern long urvanovestilli_profession[NUM_DIST_SLOTS][3];
extern long weapon[NUM_DIST_SLOTS][3];
extern long woodsman[NUM_DIST_SLOTS][3];
extern long yedidia_adventurer[NUM_DIST_SLOTS][3];
extern long yedidia_city_texture[NUM_DIST_SLOTS][3];
extern long yedidia_doors[NUM_DIST_SLOTS][3];
extern long yedidia_encounter[NUM_DIST_SLOTS][3];
extern long yedidia_forest[NUM_DIST_SLOTS][3];
extern long yedidia_land_human[NUM_DIST_SLOTS][3];
extern long yedidia_party[NUM_DIST_SLOTS][3];
extern long yedidia_profession[NUM_DIST_SLOTS][3];
extern long max_player_phv;
extern struct adj_info_struct adjustment_info[NUM_STATI];
extern struct master_creature master_creatures[NUM_CREATURES];
extern struct master_item orig_items[NUM_ITEMS];
extern struct prayer_struct prayers[NUM_PRAYERS];
extern struct skill skill_info[NUM_SKILLS];

/* Misc. utility functions, including compression.  */

#ifdef SOLARIS
long random();
#endif

/* TMS functions.  */

char tgetc(void);
long action_parse(void);
long allocate_experience_internal(struct small_creature *c, long which, long
  amount);
long ask_question(char *question, long yes_val, long no_val, long
  attribute);
long ask_question_internal(char *question, long yes_val, long no_val);
long ask_value(char *question, long average, long min_val, long max_val);
long attempt_move(struct small_creature *c, long x, long y);
long attribute_adjust(long amount, long attribute);
long attribute_parse(void);
long board_game(long game_id);
long can_fly(struct small_creature *c);
long can_see(struct small_creature *c, long x, long y);
long can_see_badly(struct small_creature *c, long x, long y);
long can_see_water(struct small_creature *c);
long cap_fs_pmsg(char *message);
long chances(long a, long b);
long check_file(char *filename);
long clear_path(long x1, long y1, long x2, long y2);
long confirm(void);
long confirm_maybe(void);
long confirm_neg(void);
long confirm_pos(void);
long confirm_silent(void);
long confirm_silent_internal(void);
long creature_damage(struct small_creature *c, long amount, long flags, long
  success);
long creature_epvalue(struct master_creature *c);
long creature_parse(void);
long cryptogram_machine(struct text_struct *cryptogram);
long deduct_amount(struct small_creature *c, long amount);
long def_sec(struct small_creature *c, long seconds);
long distance(long x1, long y1, long x2, long y2);
long find_and_remove_id(struct ilist **il, long item_id);
long find_light_source_radius(struct small_creature *c);
long fire_from_heaven(struct small_creature *c, struct small_creature *ctarget,
  long success);
long flag_check(long target, long flag);
long found_in_distribution(long unit_id, long list_id, long type);
long fs_morewait(void);
long fs_pmsg(char *message);
long fs_skill_parse(void);
long gift_parse(void);
long has_hummer(struct small_creature *c);
long has_item_id(struct ilist *il, long item_id, long flags);
long healing(struct small_creature *c, long success);
long image_character(long x, long y);
long interpret_tongues(struct small_creature *interpreter, struct
  small_creature *speaker);
long is_following(struct small_creature *c1, struct small_creature *c2);
long is_hostile(struct small_creature *c1, struct small_creature *c2);
long is_hungry(struct small_creature *c);
long is_on_clist(struct small_creature *c, struct clist *cl);
long is_on_level(struct small_creature *c, struct level *l);
long is_thirsty(struct small_creature *c);
long is_tired(struct small_creature *c);
long item_parse(long flags);
long janra_guess(void);
long language_check(struct small_creature *c, long language);
long level_add_texture(struct level *this_level, long my_texture_type, long
  other);
long lightning_strike(struct small_creature *c, struct small_creature
  *ctarget, long success);
long loc_xy(struct small_creature *c, long *result_x, long *result_y);
long location_parse(void);
long ltrandom(void);
long max(long a, long b);
long min(long a, long b);
long morewait(void);
long move_creature(struct small_creature *c, long plus_x, long plus_y);
long my_daylight(void);
long my_exp(long base_points);
long my_insert(struct level *this_level, struct small_item *new_contents,
  struct small_item *container);
long my_log(long base_points);
long nocap_pmsg(char *message);
long noprompt_pmsg(char *message);
long one_move(struct small_creature *c, long *result_x, long *result_y);
long oner(void);
long p_donation(struct small_creature *c);
long p_inn_entrance(struct small_creature *c);
long p_peak(struct small_creature *c);
long p_puzzle_door(struct small_creature *c, long x, long y);
long peg_game(long game_id);
long pmsg(char *message);
long prayer_parse(void);
long predecessor(long letter);
long random_adjust(long n);
long read_datum(int save_file);
long read_random_excerpt(char *filename);
long remove_creatures_light_source(struct level *l, struct small_creature *c);
long rf_fs_morewait(void);
long rf_fs_pmsg(char *message);
long skill_check(struct small_creature *c, long skill, long difficulty, long
  flags);
long skill_parse(void);
long space_effect(struct small_creature *c, long x, long y);
long status_check(struct small_creature *c, long status);
long strcnt(char *master_string, char *poss_substring);
long successor(long letter);
long text_parse(long list_type, long flags, long other);
long tgets(char *result);
long time_parse(void);
long tmvgetstr(long y, long x, char *result);
long trandom(void);
long twilight(void);
long upgrade_check(long power_level);
long use_item(struct small_creature *c, struct small_item *i);
long wants(struct small_creature *c, struct small_item *i);
struct establishment_struct *new_establishment(long flags, long race);
struct ilist *clean(struct small_item *i);
struct ilist *find_letter(struct ilist *i, struct small_item *target, long
  letter_to_retrieve, long *current_letter);
struct level *dig_level(long level_type, long power_level, long flags, long
  other);
struct level *load_level(long level_type);
struct level *make_level(long level_type, long power_level, long flags, long
  other);
struct master_creature *master_creature_create(long race, long age_class, long
  gender);
struct pointer_struct *get_new_pointer(struct pointer_struct *old_pointer);
struct small_creature *appoint_successor(struct small_creature *c);
struct small_creature *creature_create(long race, long age_class, long gender);
struct small_creature *creature_has_light_source(struct level *l);
struct small_creature *extended_creature_create(long race, long age_class, long
  gender);
struct small_creature *extract_creature(struct clist **cl, long
  letter_to_retrieve);
struct small_creature *find_creature(struct clist *cl, long letter_to_retrieve);
struct small_creature *guardian_angel_create();
struct small_creature *loc_creature(struct small_creature *c);
struct small_creature *make_random_creature(long ctype);
struct small_creature *nearest_hostile(struct small_creature *c);
struct small_creature *new_adventurer();
struct small_creature *new_npc(long race, long age_class, long gender);
struct small_creature *new_npc_generic(long race_generic);
struct small_creature *one_move_loc_creature(struct small_creature *c);
struct small_item *extract_item(struct ilist **i, long start_letter, long
  *current_letter, long letter_to_retrieve, long flags);
struct small_item *find_item(struct ilist **i, long letter_to_retrieve, long
  flags);
struct small_item *find_light_source(struct small_creature *c);
struct small_item *find_vehicle(struct small_creature *c);
struct small_item *find_weapon(struct small_creature *c);
struct small_item *generate_container(struct level *this_level, struct
  small_item *i, long quality);
struct small_item *generate_contents(struct level *this_level, struct
  small_item *i);
struct small_item *generate_item(struct level *this_level, long identity);
struct small_item *get_item(struct small_creature *c, long flags);
struct small_item *prepare(struct level *this_level, struct small_item *i,
  long quality);
struct special_struct *new_special(void);
struct text_struct *new_cryptogram(void);
void acquire(struct small_creature *c);
void acquire_item(struct small_creature *c, long item_id);
void act(struct small_creature *c);
void action_fly(struct small_creature *c);
void activate(struct small_creature *c, struct small_item *i);
void add_amount(struct small_creature *c, long amount);
void add_creature(struct level *l, struct small_creature *c, long x, long y);
void add_item(struct ilist **il, struct small_item *i);
void add_item_join(struct ilist **il, struct small_item **i);
void add_item_to_level(struct level *l, long item_id);
void add_light_source_to_spot(struct level *l, long x, long y, long radius);
void add_new_light_source_to_creature(struct small_creature *c, long radius);
void add_permanent_status(struct small_creature *c, long status, long
  increment);
void add_random_creature(struct level *l, long encounter_type);
void add_shop(struct level *this_level, long x, long y, long shop_type);
void aid_open(struct small_creature *c);
void allocate_experience(struct small_creature *c);
void animal_handle(struct small_creature *c, struct small_creature *ctarget);
void antidote(struct small_creature *c1, struct small_creature *c2);
void append_clist(struct clist **c1, struct clist *c2);
void append_creature_to_clist(struct small_creature *c, struct clist **cl);
void append_ilist(struct ilist **i1, struct ilist *i2);
void append_text_to_text_struct(struct text_struct **text, char *addition);
void appraise(struct small_creature *c, struct small_item *i);
void archery_tournament(struct small_creature *c);
void assign_door(struct level *this_level, long x, long y, long door_id);
void attack_common(struct small_creature *attacker, struct small_creature
  *attackee, long flags);
void attack_hth(struct small_creature *attacker, struct small_creature
  *attackee);
void attack_msl(struct small_creature *attacker, struct small_creature
  *attackee);
void attack_str(char *message, struct small_creature *attacker, struct
  small_creature *attackee, long flags);
void attempt_fly(struct small_creature *c);
void attempt_hide(struct small_creature *c);
void attempt_identify(struct small_creature *c, struct small_item *i);
void attempt_mount(struct small_creature *c1, struct small_creature *c2);
void auto_act(struct small_creature *c);
void auto_move(struct small_creature *c, long x_direction, long y_direction,
  long flags);
void calc_item_stats(struct small_item *i);
void calc_ready(struct small_creature *c);
void calculator(void);
void change_level(long x, long y);
void change_space(struct space_struct *space, long identity);
void chariot_of_fire(struct small_creature *c);
void check_addition(struct level *l, long creature_id, long x, long y);
void check_creature(struct small_creature *c);
void check_files(void);
void check_level_pointers(struct level *l);
void check_pointer(struct pointer_struct * test_pointer);
void check_skill_gain(struct small_creature *c, long sn, long amount);
void check_string(char *string);
void check_use(struct small_creature *c, struct small_item *i);
void check_xy(long x, long y);
void chemistry(struct small_creature *c);
void city_move(struct small_creature *c);
void close_door(struct small_creature *c);
void close_item(struct small_item *i);
void come_to(struct small_creature *c);
void control_weather(struct small_creature *c, long success);
void copy_table(long source[NUM_DIST_SLOTS][3], long *dest[NUM_DIST_SLOTS][3]);
void correct_xy(void);
void cover_with_poison(struct small_creature *c, struct small_item *i);
void creature_death(struct small_creature *c);
void debug(void);
void describe_creature(struct small_creature *c);
void describe_item(struct small_item *i);
void describe_space(struct small_creature *c, long x, long y);
void description(struct small_item *i, char *message);
void discover_secret(long x, long y);
void dismount(struct small_creature *c);
void distribution_copy(long source[NUM_DIST_SLOTS][3], long
  destination[NUM_DIST_SLOTS][3]);
void do_action(struct small_creature *c);
void drink_water(struct small_creature *c);
void drop_item(struct small_creature *c);
void drop_money(struct small_creature *c);
void e_horn(struct small_creature *c);
void e_janra_ball(struct small_creature *c);
void encounter(long encounter_type, long success);
void encounter_internal(struct level *l, long encounter_type, long success);
void ensure_synced_screen(void);
void examine(struct small_creature *c);
void fatigue(struct small_creature *c, long units);
void fight_to_death(struct small_creature *c, struct small_creature *ctarget);
void fill_with_oil(struct small_creature *c);
void fill_with_water(struct small_item *i);
void final_strike(struct small_creature *c);
void find_and_remove_item(struct small_item *i, struct ilist **il);
void find_and_write_on_item(struct small_creature *c);
void find_boundary(struct level *l, long *x, long *y);
void find_name(struct small_creature *c, char *namefile);
void find_nearest_water(struct small_creature *c, long *found_x, long *found_y);
void find_pronoun(struct small_creature *c, char *result);
void find_string(long string_id, char *result);
void find_title(struct small_creature *c, char *title);
void flag_reset(long *target, long flags);
void flag_set(long *target, long flags);
void free_clist(struct clist *cl);
void free_creature(struct small_creature *c);
void free_creatures(struct clist *cl);
void free_faith_struct(struct faith_struct *f);
void free_ilist(struct ilist *il);
void free_item(struct small_item *i);
void free_items(struct ilist *il);
void free_level(struct level *l);
void free_light_source(struct light_source_struct *l);
void free_master_creature(struct master_creature *c);
void free_read_file_text_struct(struct read_file_text_struct *r);
void free_shop(struct shop_struct *s);
void free_special(struct special_struct *s);
void free_text_struct(struct text_struct *t);
void funeral(struct small_creature *c, struct small_item *i);
void fs_allocate_experience(struct small_creature *c);
void fs_anykey(void);
void gain_ep(struct small_creature *c, long ep_gain);
void gain_experience(struct small_creature *c, long units);
void gain_related_skills(struct small_creature *c, long which);
void gather_from_tree(struct small_creature *c);
void generate_player(void);
void geography(struct small_creature *c);
void get_command(struct small_creature *c);
void give_item(struct small_creature *c, struct small_creature *ctarget);
void give_name(struct small_creature *namer, struct small_creature *ctarget);
void go_fishing(struct small_creature *c);
void go_to_sleep(struct small_creature *c);
void guardian_angel(struct small_creature *c);
void guess_actions(struct small_creature *c, struct small_creature *ctarget);
void hear_noises(struct small_creature *c);
void herbalism(struct small_creature *c);
void hint(void);
void holy_ground(struct small_creature *c, long success);
void hostility_check(struct level *l, struct small_creature *c);
void human_encounter(long encounter_type, long success);
void human_encounter_internal(struct level *l, long encounter_type, long
  success);
void identify(struct small_item *i);
void ignite(struct small_creature *c, struct small_item *i);
void increase_attribute(struct small_creature *c, long success);
void increase_faith(struct small_creature *c, long success);
void increase_skill(struct small_creature *c, long success);
void increment_skill_one_unit(struct small_creature *c, long which_skill);
void init(void);
void init_restore( char *savefile );
void init_stat(struct master_creature *c);
void initiate_profession(struct small_creature *c, long profession);
void initiate_professional_skills(struct small_creature *c, long
  template[NUM_DIST_SLOTS][3]);
void insert_internal(struct level *this_level, struct small_item *new_contents,
 struct small_item *container);
void insight(struct small_creature *c, long success);
void inspect_search(struct small_creature *c);
void interview(void);
void item_desc(struct small_item *i, char *description);
void janra_ball_internal(void);
void jump(struct small_creature *c);
void land_from_flying(struct small_creature *c);
void load_player(void);
void make_fine(struct master_item *i);
void make_follow(struct small_creature *c1, struct small_creature *c2);
void make_hostile(struct small_creature *c1, struct small_creature *c2);
void make_item(struct small_creature *c, long skill);
void make_normal(struct master_item *i);
void make_poor(struct master_item *i);
void mark_circle(struct level *l, long x, long y, long radius);
void mark_connected_component(struct level *l, long x, long y);
void mark_connected_component_can_occupy(struct level *l, long x, long y);
void mark_pool(struct level *l, long x, long y, long radius, long steps);
void marker(char *message);
void medicine(struct small_creature *c, struct small_creature *ctarget);
void mist_circle(struct level *l, long x, long y, long radius);
void money_string(long amount, char result[]);
void mount_act(struct small_creature *c);
void multiply_item(struct small_item *i, long number);
void murefresh(void);
void music(struct small_creature *c, long skill_id);
void my_finish(long status);
void name_item(struct small_item *i, char *name);
void navigate(struct small_creature *c);
void no_hostile_add_creature(struct level *l, struct small_creature *c, long x,
  long y);
void one_day_check(void);
void one_hour_check(void);
void one_minute_check(void);
void one_month_check(void);
void one_second_check(void);
void one_use_light_sources(void);
void one_year_check(void);
void open_door(struct small_creature *c);
void open_item(struct small_item *i);
void pick_locks(struct small_creature *c);
void player_death(void);
void p_adventurers_guild(struct small_creature *c);
void p_bed(struct small_creature *c);
void p_collection_box(struct small_creature *c);
void p_fire(struct small_creature *c);
void p_deep_water(struct small_creature *c, long x, long y);
void p_dry_tree(struct small_creature *c, long x, long y);
void p_establishment(struct small_creature *c, long establishment_id, struct
  establishment_struct *establishment);
void p_final_test(struct small_creature *c);
void p_fruit_tree(struct small_creature *c, long x, long y);
void p_green_tree(struct small_creature *c, long x, long y);
void p_hedge(struct small_creature *c);
void p_house(void);
void p_inscription(struct small_creature *c);
void p_mapmaker(struct small_creature *c);
void p_medic(struct small_creature *c);
void p_mentor(void);
void p_northern_pool(struct small_creature *c);
void p_prayer_table(struct small_creature *c);
void p_restaurant(struct small_creature *c);
void p_rubble(struct small_creature *c);
void p_sand(struct small_creature *c);
void p_shallow_water(struct small_creature *c, long x, long y);
void p_shop(struct small_creature *c, struct shop_struct *s, long sign_id);
void p_tavern(struct small_creature *c);
void p_tavern_seat(struct small_creature *c);
void p_tinkerers_guild(struct small_creature *c);
void p_wrestle_blacksmith(void);
void pacify(struct small_creature *c1, struct small_creature *c2);
void pass_days(long days);
void pass_out(struct small_creature *c, long amount);
void pass_time(long time_units);
void permanent_holy_ground(struct small_creature *c);
void permanent_restore(struct small_creature *c);
void persuade(struct small_creature *c, struct small_creature *ctarget, long
  diff_adjust);
void pet(struct small_creature *petter, struct small_creature *pettee);
void pickup(struct small_creature *c);
void place_item(struct level *this_level, struct small_item *i, long x, long y);
void populate_animal(struct level *l, long encounter_type, long power_level,
  long frequency);
void populate_item(struct level *l, long item_type, long power_level, long
  frequency);
void populate_money(struct level *this_level, long power_level, long frequency);
void pray(struct small_creature *c, long adjustment);
void prayer_units(struct small_creature *c, long units);
void prepare_room_space(struct level *l, struct space_struct *s, long room_id);
void prepare_space(struct space_struct *space, long identity);
void print_attributes(struct small_creature *c);
void print_clist(struct clist *c, long flags);
void print_ilist_internal(struct ilist *i, long indent, long *curr_letter, long
  flags);
void print_inventory(struct small_creature *c);
void projectile_path(long start_x, long start_y, long finish_x, long finish_y,
  char image);
void push_creature(struct small_creature *c);
void raise_dead(struct small_creature *c, struct small_item *corpse, long
  success);
void random_select(long distribution[NUM_DIST_SLOTS][3], long *result, long
  *other);
void randstat(void);
void read_file(char *filename);
void read_item(struct small_creature *c, struct small_item *i);
void read_text_struct(struct text_struct *text);
void reading_writing(struct small_creature *c, struct small_item *i);
void recalculate_light_sources(struct level *l);
void receive_gift(struct small_creature *c, long success);
void refresh_screen(void);
void rejuvenate(struct small_creature *c, long success);
void remove_creature(struct level *l, struct small_creature *c);
void remove_creature_from_clist(struct small_creature *c, struct clist **cl);
void remove_creature_light_sources(struct level *l);
void remove_item(struct level *this_level, struct small_item *to_remove);
void repair(struct small_creature *c, struct small_item *i);
void reset_follow(struct small_creature *c1, struct small_creature *c2);
void reset_hostility(struct small_creature *c1, struct small_creature *c2);
void rest(struct small_creature *c);
void rest_one_day(struct small_creature *c);
void restoration(struct small_creature *c);
void restore(char *save_filename);
void ride(struct small_creature *c, struct small_creature *ctarget);
void role_play_info(void);
void sanctuary(struct small_creature *c);
void save( char *save_filename);
void save_player(void);
void search(struct small_creature *c);
void select_random_result(long table[NUM_DIST_SLOTS][3], long *selected_type,
  long *selected_other);
void set_options(void);
void set_options_internal(long *variable, long flags);
void shining_light(struct small_creature *c);
void skill(struct small_creature *c);
void skill_effect(struct small_creature *c, long skill);
void smell_creature(struct small_creature *c, long diff_adjust);
void small_item_make_fine(struct small_item *i);
void small_item_make_normal(struct small_item *i);
void small_item_make_poor(struct small_item *i);
void status_add(struct small_creature *c, long status, long increment);
void status_message(struct small_creature *c, long status);
void status_reset(struct small_creature *c, long status);
void stock_shop(struct shop_struct *s);
void stop_time(struct small_creature *c, long success);
void string_check_exit(char *message);
void swap_places(struct small_creature *c1, struct small_creature *c2);
void take_time(struct small_creature *c, long time);
void talk(struct small_creature *c1, struct small_creature *c2);
void talk_celebrant(struct small_creature *c1, struct small_creature *c2);
void talk_intercessor(struct small_creature *c1, struct small_creature *c2);
void talk_server(struct small_creature *c1, struct small_creature *c2);
void talk_trade(struct small_creature *c1, struct small_creature *c2);
void time_check(void);
void tinker(struct small_creature *c);
void top_text_read_text_struct(struct text_struct *text);
void top_text_update(void);
void track(struct small_creature *c);
void transport(struct small_creature *c);
void tsrandom(void);
void two_random_select(long distribution[NUM_DIST_SLOTS][3], long *result1,
  long *result2);
void unequip(struct small_creature *c);
void unmark_level(struct level *l);
void update_light_sources(void);
void update_window(void);
void update_world(void);
void use_skill(struct small_creature *c);
void wake_up(struct small_creature *c);
void wear_wield(struct small_creature *c);
void wear_wield_internal(struct small_creature *c, struct small_item *i);
void weather_sense(struct small_creature *c);
void worship_service(void);
void wrestle(struct small_creature *c1, struct small_creature *c2);
void write_adj_struct(int save_file, struct adj_struct *this_adj_struct);
void write_clist(int save_file, struct clist *this_clist);
void write_establishment_struct(int save_file, struct establishment_struct
  *this_establishment_struct);
void write_faith_struct(int save_file, struct faith_struct *this_faith_struct);
void write_ilist(int save_file, struct ilist *this_ilist);
void write_level(int save_file, struct level *this_level);
void write_game_variables_struct(int save_file, struct game_variables_struct
  *this_game_variables_struct);
void write_light_sources(int save_file, struct light_source_struct
  *this_light_source_struct);
void write_llist(int save_file, struct llist *this_llist);
void write_master_creature(int save_file, struct master_creature
  *this_master_creature);
void write_on_item(struct text_struct **to_write_on);
void write_on_log(void);
void write_on_roster(void);
void write_shop_struct(int save_file, struct shop_struct
  *this_shop_struct);
void write_skills_struct(int save_file, struct skills_struct
  *this_skills_struct);
void write_small_creature(int save_file, struct small_creature
  *this_creature);
void write_small_item(int save_file, struct small_item *this_small_item);
void write_special_struct(int save_file, struct special_struct
  *this_special_struct);
void write_text_struct(int save_file, struct text_struct *this_text_struct);
