/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2003 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include <string.h>
#include "tms.h"

long text_parse(long list_type, long flags, long other)
    {
    char input[256], curr_string[256];
    long i, j, f1, f2, my_flag, my_continue, continue_printing, abort_parse,
      num_strings, print_this_string, string_id;
    f1=-1;
    f2=-1;
    num_strings = 0;
    abort_parse = FALSE;
    switch(list_type)
        {
        case TEXT_ACTION:
            num_strings = NUM_ACTIONS;
            pmsg("Which action?");
        break;
        case TEXT_ATTRIBUTE:
            num_strings = NUM_ATTRIBUTES;
            pmsg("Which attribute?");
        break;
        case TEXT_CREATURE:
            num_strings = NUM_CREATURES;
            pmsg("Which creature?");
        break;
        case TEXT_GIFT:
            num_strings = NUM_GIFTS;
            pmsg("Which gift?");
        break;
        case TEXT_ITEM:
            num_strings = NUM_ITEMS;
            pmsg("Which item?");
        break;
        case TEXT_LOCATION:
            num_strings = NUM_LOCATION_TYPES;
            pmsg("Which location?");
        break;
        case TEXT_PRAYER:
            num_strings = NUM_PRAYERS;
            pmsg("Which prayer?");
        break;
        case TEXT_SKILL: case TEXT_SKILL_FULLSCREEN:
            num_strings = NUM_SKILLS;
                pmsg("Which skill?");
        break;
        }
    for(my_continue=1;(my_continue);)
        {
        my_continue = tgets(input);
        if (my_continue == 0) /* the player hit escape */
            {
            pmsg("Aborted.");
            return -1;
            }
        if (input[0]=='?')
            {
            continue_printing = TRUE;
            for(i=0;i<num_strings;++i)
                if (continue_printing)
                    {
                    print_this_string = TRUE;
                    switch(list_type)
                        {
                        case TEXT_ACTION:
                            strncpy(curr_string, actions[i].string, 255);
                            curr_string[255] = '\0';
                            if (i == ACTION_DEBUG)
                                print_this_string = FALSE;
                            /* We don't want to advertise the debug mode.  */
                        break;
                        case TEXT_ATTRIBUTE:
                            strncpy(curr_string, attributes[i].string, 255);
                            curr_string[255] = '\0';
                        break;
                        case TEXT_CREATURE:
                            strncpy(curr_string, master_creatures[i].species, 255);
                            curr_string[255] = '\0';
                        break;
                        case TEXT_GIFT:
                            strncpy(curr_string, gifts[i].string, 255);
                            curr_string[255] = '\0';
                        break;
                        case TEXT_ITEM:
                            if (!(flag_check(orig_items[i].flags, flags))) 
                                print_this_string = FALSE;
                            if (flag_check(flags, I_ALL_ITEMS))
                                print_this_string = TRUE;
                            strncpy(curr_string, orig_items[i].identified, 255);
                            curr_string[255] = '\0';
                        break;
                        case TEXT_LOCATION:
                            if (flag_check(current_level->location[i].flags,
                              LOCATION_KNOWN))
                                print_this_string = TRUE;
                            else
                                print_this_string = FALSE;
                            strncpy(curr_string, locations[i].string, 255);
                            curr_string[255] = '\0';
                        break;
                        case TEXT_PRAYER:
                            strncpy(curr_string, prayers[i].name, 255);
                            curr_string[255] = '\0';
                        break;
                        case TEXT_SKILL: case TEXT_SKILL_FULLSCREEN:
                            strncpy(curr_string, skill_info[i].name, 255);
                            curr_string[255] = '\0';
                        break;
                        default:
                            pmsg("Error: text_parse called with inappropriate list type; will probably crash soon.");
                            morewait();
                        break;
                        }
                    if (print_this_string)
                        {
                        if (list_type != TEXT_SKILL_FULLSCREEN)
                            continue_printing = nocap_pmsg(curr_string);
                        else
                            continue_printing = fs_pmsg(curr_string);
                        }
                    }
            switch(list_type)
                {
                case TEXT_ACTION:
                    pmsg("Which action?");
                break;
                case TEXT_ATTRIBUTE:
                    pmsg("Which attribute?");
                break;
                case TEXT_CREATURE:
                    pmsg("Which creature?");
                break;
                case TEXT_GIFT:
                    pmsg("Which gift?");
                break;
                case TEXT_ITEM:
                    pmsg("Which item?");
                break;
                case TEXT_LOCATION:
                    pmsg("Which location?");
                break;
                case TEXT_PRAYER:
                    pmsg("Which prayer?");
                break;
                case TEXT_SKILL:
                    pmsg("Which skill?");
                break;
                case TEXT_SKILL_FULLSCREEN:
                    fs_anykey();
                    pmsg("Which skill?");
                break;
                }
            }
        else
            {
            for(i=0;i<num_strings;++i)
                {
                f2 = -1;
                my_flag=1;
                switch(list_type)
                    {
                    case TEXT_ACTION:
                        strncpy(curr_string, actions[i].string, 255);
                        curr_string[255] = '\0';
                    break;
                    case TEXT_ATTRIBUTE:
                        strncpy(curr_string, attributes[i].string, 255);
                        curr_string[255] = '\0';
                    break;
                    case TEXT_CREATURE:
                        strncpy(curr_string, master_creatures[i].species, 255);
                        curr_string[255] = '\0';
                    break;
                    case TEXT_GIFT:
                        strncpy(curr_string, gifts[i].string, 255);
                        curr_string[255] = '\0';
                    break;
                    case TEXT_ITEM:
                        if (!(flag_check(orig_items[i].flags, flags)))
                            my_flag = FALSE;
                        if (flag_check(flags, I_ALL_ITEMS))
                            my_flag = TRUE;
                        strncpy(curr_string, orig_items[i].identified, 255);
                        curr_string[255] = '\0';
                    break;
                    case TEXT_LOCATION:
                        if (locations[i].identity == EXIT_SETTLEMENT)
                            {
                            my_flag = TRUE;
                            }
                        else
                            {
                            if (flag_check(current_level->location[i].flags,
                              LOCATION_KNOWN))
                                my_flag = TRUE;
                            else
                                my_flag = FALSE;
                            }
                        strncpy(curr_string, locations[i].string, 255);
                        curr_string[255] = '\0';
                    break;
                    case TEXT_PRAYER:
                        strncpy(curr_string, prayers[i].name, 255);
                        curr_string[255] = '\0';
                    break;
                    case TEXT_SKILL: case TEXT_SKILL_FULLSCREEN:
                        strncpy(curr_string, skill_info[i].name, 255);
                        curr_string[255] = '\0';
                    break;
                    default:
                        pmsg("Error: text_parse called with inappropriate list type; will probably crash soon.");
                        morewait();
                    break;
                    }
                for(j=0;j<strlen(input);++j)
                    my_flag=((my_flag) && ((input[j]==curr_string[j])
                      || (input[j]==curr_string[j] + ('A' - 'a')) ||
                      (input[j]==curr_string[j] + ('a' - 'A'))));
                switch(list_type)
                    {
                    case TEXT_GIFT:
                        string_id = gifts[i].identity;
                    break;
                    case TEXT_LOCATION:
                        string_id = locations[i].identity;
                    break;
                    default:
                        string_id = i;
                    break;
                    }
                if (my_flag) 
                    {
                    if (f1 != -1)
                        f2=string_id;
                    else f1=string_id;
                    }
                }
            if ((f1 != -1) && (f2 == -1))
                my_continue=0;
            if ((f1 == -1) && (f2 == -1))
                pmsg("Please enter a valid entry.  (Hit \'?\' to list them)");
            }
        if ((!(f2 == -1)) && (!(abort_parse)))
            pmsg("Please type a long enough abbreviation so that I know what you mean.");
        }
    return f1;
    }

long action_parse(void)
    {
    return text_parse(TEXT_ACTION, 0, 0);
    }

long attribute_parse(void)
    {
    return text_parse(TEXT_ATTRIBUTE, 0, 0);
    }

long creature_parse(void)
    {
    return text_parse(TEXT_CREATURE, 0, 0);
    }

long gift_parse(void)
    {
    return text_parse(TEXT_GIFT, 0, 0);
    }

long item_parse(long flags)
    {
    return text_parse(TEXT_ITEM, flags, 0);
    }

long location_parse(void)
    {
    return text_parse(TEXT_LOCATION, 0, 0);
    }

long prayer_parse(void)
    {
    return text_parse(TEXT_PRAYER, 0, 0);
    }

long skill_parse(void)
    {
    return text_parse(TEXT_SKILL, 0, 0);
    }

long fs_skill_parse(void)
    {
    return text_parse(TEXT_SKILL_FULLSCREEN, 0, 0);
    }

/* Returns nonzero status if there is a problem.  */

long check_file(char *filename)
    {
    char extended_filename[256], message[256];
    FILE *this_file;
    strncpy(extended_filename, LIB_DIR, 255);
    extended_filename[255] = '\0';
    strncat(extended_filename, filename, max(0, 255 -
      strlen(extended_filename)));
    extended_filename[255] = '\0';
    if (!(this_file = fopen(extended_filename, "rb")))
        {
#ifdef HAS_SNPRINTF
        snprintf(message, 255, "Warning: Cannot open file %s!", extended_filename);
#else
        sprintf(message, "Warning: Cannot open file %s!", extended_filename);
#endif
        message[255] = '\0';
        fs_pmsg(message);
        return 1;
        }
    else
        {
        fclose(this_file);
        return 0;
        }
    }

void check_files(void)
    {
    long failure;
    failure = FALSE;
    /* Not using the obvious if-then because I want it to print out all */
    /* filenames if the files are missing.  */
    failure |= check_file(FILE_ABOUT_THE_AUTHOR);
    failure |= check_file(FILE_ABRIDGED_HELP);
    failure |= check_file(FILE_ARCHERY_TOURNAMENT_RULES);
    failure |= check_file(FILE_BENEDICTIONS);
    failure |= check_file(FILE_BOARD_PUZZLE_HELP);
    failure |= check_file(FILE_BOOK_A_DREAM_OF_LIGHT);
    failure |= check_file(FILE_BOOK_A_PICTURE_OF_EVIL);
    failure |= check_file(FILE_BOOK_BIBLE);
    failure |= check_file(FILE_BOOK_CULTURES);
    failure |= check_file(FILE_BOOK_KOANS);
    failure |= check_file(FILE_BOOK_RIDDLES);
    failure |= check_file(FILE_BOOK_THE_NATURE_OF_A_SAINT);
    failure |= check_file(FILE_BOOK_THE_WAY_OF_THE_WAY);
    failure |= check_file(FILE_CATHEDRAL_1);
    failure |= check_file(FILE_CATHEDRAL_2);
    failure |= check_file(FILE_CATHEDRAL_3);
    failure |= check_file(FILE_CATHEDRAL_4);
    failure |= check_file(FILE_CATHEDRAL_5);
    failure |= check_file(FILE_CHANGES);
    failure |= check_file(FILE_CHARIOT_OF_FIRE);
    failure |= check_file(FILE_CHARITY_CONTACTS);
    failure |= check_file(FILE_COMMUNION);
    failure |= check_file(FILE_COPYRIGHT);
    failure |= check_file(FILE_COUNTRYSIDE);
    failure |= check_file(FILE_CRYPT_1);
    failure |= check_file(FILE_CRYPT_2);
    failure |= check_file(FILE_CRYPT_3);
    failure |= check_file(FILE_CULTURES);
    failure |= check_file(FILE_EXTENDED_HELP);
    failure |= check_file(FILE_FAQ_LIST);
    failure |= check_file(FILE_FINAL_QUEST_DUNGEON);
    failure |= check_file(FILE_FINAL_QUEST_LOSE);
    failure |= check_file(FILE_FINAL_QUEST_TEST);
    failure |= check_file(FILE_FINAL_QUEST_WIN);
    failure |= check_file(FILE_GM_INTRO);
    failure |= check_file(FILE_HELP);
    failure |= check_file(FILE_HINTS);
    failure |= check_file(FILE_HOMILIES);
    failure |= check_file(FILE_HYMNS);
    failure |= check_file(FILE_ICE_PEAKS_POOL);
    failure |= check_file(FILE_INVOCATIONS_TO_WORSHIP);
    failure |= check_file(FILE_JANRA_BALL);
    failure |= check_file(FILE_MODEL);
    failure |= check_file(FILE_MOTD);
    failure |= check_file(FILE_NAMES_JANRA);
    failure |= check_file(FILE_NAMES_JEC);
    failure |= check_file(FILE_NAMES_NORKRIN);
    failure |= check_file(FILE_NAMES_SHAL);
    failure |= check_file(FILE_NAMES_TUZ);
    failure |= check_file(FILE_NAMES_URVANOVESTILLI);
    failure |= check_file(FILE_NAMES_YEDIDIA);
    failure |= check_file(FILE_NOTES);
    failure |= check_file(FILE_OCEAN_ISLE);
    failure |= check_file(FILE_PEG_PUZZLE_HELP);
    failure |= check_file(FILE_PLAYER_INTRO);
    failure |= check_file(FILE_QUEST_ANSWERED_RIDDLE);
    failure |= check_file(FILE_QUEST_CHOSEN_QUEST);
    failure |= check_file(FILE_QUEST_CONTRADICTION);
    failure |= check_file(FILE_QUEST_EXPLORED_MISTRELLI);
    failure |= check_file(FILE_QUEST_EXPLORED_OCEAN);
    failure |= check_file(FILE_QUEST_FINAL_QUEST);
    failure |= check_file(FILE_QUEST_GAVE_GIFT);
    failure |= check_file(FILE_QUEST_GUESSED_JANRA);
    failure |= check_file(FILE_QUEST_MAN_WITHOUT_EYES);
    failure |= check_file(FILE_QUEST_MECHANICAL_PUZZLE);
    failure |= check_file(FILE_QUEST_MECHANICAL_PUZZLE_II);
    failure |= check_file(FILE_QUEST_MECHANICAL_PUZZLE_III);
    failure |= check_file(FILE_QUEST_MISSING_LETTERS);
    failure |= check_file(FILE_QUEST_NAMED_CHILD);
    failure |= check_file(FILE_QUEST_PETTED_DOLPHIN);
    failure |= check_file(FILE_QUEST_SERPENT_JEWEL);
    failure |= check_file(FILE_QUEST_SLEW_BEHEMOTH);
    failure |= check_file(FILE_QUEST_SLEW_KRAKEN);
    failure |= check_file(FILE_QUEST_SLEW_LEVIATHAN);
    failure |= check_file(FILE_QUEST_SLEW_ROC);
    failure |= check_file(FILE_QUEST_SLEW_TERRASK);
    failure |= check_file(FILE_QUEST_TAMED_ANIMAL);
    failure |= check_file(FILE_QUEST_DOZEN_GIANT_SCORPIONS);
    failure |= check_file(FILE_QUEST_WAS);
    failure |= check_file(FILE_QUEST_WON_ARCHERY);
    failure |= check_file(FILE_QUEST_WRESTLED_BLACKSMITH);
    failure |= check_file(FILE_QUESTMASTER_INTRO);
    failure |= check_file(FILE_PEG_PUZZLE_HELP);
    failure |= check_file(FILE_PLAYER_INTRO);
    failure |= check_file(FILE_PRAYERS);
    failure |= check_file(FILE_PRINT_ATTRIBUTES_ABBREVIATIONS);
    failure |= check_file(FILE_RIDDLE_CONTRADICTION);
    failure |= check_file(FILE_RIDDLE_DIAMOND_CHALICE);
    failure |= check_file(FILE_RIDDLE_LETTER_H);
    failure |= check_file(FILE_RIDDLE_MISSING_LETTERS);
    failure |= check_file(FILE_SCRIPTURE_PASSAGES);
    failure |= check_file(FILE_SIMPLE_MODEL);
    failure |= check_file(FILE_TAVERN_1);
    failure |= check_file(FILE_TAVERN_2);
    failure |= check_file(FILE_TAVERN_3);
    failure |= check_file(FILE_TAVERN_4);
    failure |= check_file(FILE_THANKS);
    failure |= check_file(FILE_TRANSLATION_FAILED);
    failure |= check_file(FILE_WHYPLAY);
    if (failure)
        {
        fs_pmsg("");
        fs_pmsg("Warning: The Minstrel's Song was unable to open some or all of the files needed");
        fs_pmsg("in its operation.  It is strongly recommended that you exit the game, and check");
        fs_pmsg("make sure that the game is installed properly.  The game may crash at a random");
        fs_pmsg("time, and all progress lost, if you continue playing.  Continue anyway?");
        if (!(confirm_silent()))
            exit(1);
        else
            fs_pmsg("I hope you know what you are doing!");
        }
    }

/* See if the first string contains the second string; case insensitive */

long strcnt(char *master_string, char *poss_substring)
    {
    long i, j, contained;
    if (strlen(poss_substring) > strlen(master_string))
        return FALSE;
    else if (strlen(poss_substring) == 0)
        return TRUE;
    else
        {
        for(i = 0; i <= strlen(master_string) - strlen(poss_substring); ++i)
            {
            contained = TRUE;
            for(j = 0; j < strlen(poss_substring); ++j)
                contained &= ((master_string[i + j] == poss_substring[j]) ||
                  (master_string[i + j] + 'a' - 'A' == poss_substring[j]) ||
                  (master_string[i + j] + 'A' - 'a' == poss_substring[j]));
            if (contained)
                return TRUE;
            }
        return FALSE;
        }
    }

void read_text_struct(struct text_struct *text)
    {
    long my_continue;
    struct text_struct *current;
    clear();
    my_continue = 1;
    current = text;
    while (my_continue)
        {
        my_continue = ((my_continue) && (fs_pmsg(current->text)));
        current = current->next;
        my_continue &= (current != NULL);
        }
    fs_anykey();
    clear();
    if (!(flag_check(game_variables->flags, DURING_INIT)))
        refresh_screen();
    }

void top_text_read_text_struct(struct text_struct *text)
    {
    long my_continue;
    struct text_struct *current;
    my_continue = 1;
    current = text;
    while (my_continue)
        {
        my_continue = ((my_continue) && (pmsg(current->text)));
        current = current->next;
        my_continue &= (current != NULL);
        }
    }

void status_reset(struct small_creature *c, long status)
    {
    if (c->extended != NULL)
        c->extended->stati->time[status] = 0;
    }

long status_check(struct small_creature *c, long status)
    {
    if (c->extended != NULL)
        return (max(0,
          c->extended->stati->time[status] /
          max(1, adjustment_info[status].time_increment) +
          c->extended->stati->permanent[status]));
    else
        return 0;
    }

void increment_skill_one_unit(struct small_creature *c, long which_skill)
    {
    if (c->extended != NULL)
        {
        ++c->extended->skills->bv[which_skill];
        ++c->extended->skills->av[which_skill];
        }
    }

void write_on_item(struct text_struct **to_write_on)
    {
    struct text_struct *current, *next;
    long my_continue, position, end_of_line, x, y, space_loc, i;
    char input, str1[256], str2[256];
    pmsg("You are now writing.  Type what you wish to write; then hold the control key");
    nocap_pmsg("down and hit 'D' when you are done.");
    pmsg("");
    current = *to_write_on;
    if (current != NULL)
        if (current->next != NULL)
            for(;(current->next != NULL); current = current->next);
    y = 4;
    x = 0;
    move(y, x);
    my_continue = TRUE;
    position = -1;
    while (my_continue)
        {
        end_of_line = FALSE;
        input = tgetc();
        switch(input)
            {
            case 4: case EOF:
                my_continue = 0;
                end_of_line = TRUE;
            break;
            case 8: case 127:
                mvaddch(y, x + position, ' ');
                move(y, x + position);
                str1[position] = 0;
                position = max(position - 1, -1);
            break;
            case 10: case 13:
                end_of_line = TRUE;
            break;
            default:
                ++position;
                mvaddch(y, x + position, input);
                str1[position] = input;
                str1[position + 1] = 0;
            break;
            }
        /* Word wrapping */
        if (position >= 78)
            {
            end_of_line = TRUE;
            if (strcnt(str1, " ")) /* If it has a space, then we break the line */
              /* there.  */
                {
                for(space_loc = position + 1; (str1[space_loc] != ' ');
                  --space_loc);
                if (space_loc == position)
                    str2[0] = '\0';
                else
                    {
                    for(i = 0; i <= strlen(str1) - space_loc - 1; ++i)
                        str2[i] = str1[i + space_loc + 1];
                    str2[i] = 0;
                    str1[space_loc] = 0;
                    move(4, space_loc);
                    wclrtoeol(stdscr);
                    refresh();
                    }
                }
            }
        else if (end_of_line)
            str2[0] = '\0';
        if (end_of_line)
            {
            next = (struct text_struct *) calloc(1, sizeof(struct text_struct));
            next->me = next;
            strncpy(next->text, str1, 117);
            next->text[117] = '\0';
            next->next = NULL;
            if (current != NULL)
                current->next = next;
            else
                *to_write_on = next;
            current = next;
            nocap_pmsg(str2);
            strncpy(str1, str2, 255);
            str1[255] = '\0';
            position = strlen(str1) - 1;
            move(4, max(0, position));
            }
        refresh();
        }
    move(y, x);
    }

void pass_days(long days)
    {
    long i;
    for(i=0;i<days;++i)
        {
        ++game_variables->elapsed_days;
        one_day_check();
        update_window();
        }
    }

void discover_secret(long x, long y)
    {
    struct clist *creatures;
    struct ilist *items;
    long au, el, si, cu;
    creatures = current_level->space[x][y].creatures;
    items = current_level->space[x][y].items;
    au = current_level->space[x][y].au;
    el = current_level->space[x][y].el;
    si = current_level->space[x][y].si;
    cu = current_level->space[x][y].cu;
    if (flag_check(current_level->space[x][y].flags, HAS_SECRET))
        {
        change_space(&current_level->space[x][y],
          current_level->space[x][y].other);
        current_level->space[x][y].au = au;
        current_level->space[x][y].el = el;
        current_level->space[x][y].si = si;
        current_level->space[x][y].cu = cu;
        append_ilist(&current_level->space[x][y].items, items);
        append_clist(&current_level->space[x][y].creatures, creatures);
        pmsg("You discover a secret!");
        }
    update_window();
    }

/* Print a random excerpt from a text file with a double pound sign contained
in a line separating excerpts.  There is a double pound sign before the first
excerpt, but no double pound sign after the last excerpt.  */

long read_random_excerpt(char *filename)
    {
    char real_filename[256], this_line[256];
    long my_continue, num_excerpts, chosen_excerpt, i, success;
    FILE *infile;
    success = TRUE;
    strncpy(real_filename, LIB_DIR, 255);
    real_filename[255] = '\0';
    strncat(real_filename, filename, max(0, 255 - strlen(LIB_DIR)));
    real_filename[255] = '\0';
    if (!(infile = fopen(real_filename, "r")))
        {
        perror("Attempt failed to open file:");
        perror(real_filename);
        success = FALSE;
        }
    else
        {
        my_continue = 1;
        num_excerpts = 0;
        while (my_continue)
            {
            my_continue = ((my_continue) && (fgets(this_line, 256, infile)));
            if (strcnt(this_line, "##"))
                ++num_excerpts;
            }
        fclose(infile);
        if (num_excerpts == 0)
            {
            perror("Error: excerpt requested from file with no excerpts");
            success = FALSE;
            }
        else
            {
            chosen_excerpt = (trandom() % num_excerpts) + 1;
            my_continue = TRUE;
            infile = fopen(real_filename, "r");
            this_line[0] = '\0';
            for(i = 0; i < chosen_excerpt; fgets(this_line, 256, infile))
                if (strcnt(this_line, "##"))
                    ++i;
            while (my_continue)
                {
                if (my_continue)
                    {
                    success &= (fs_pmsg(this_line));
                    my_continue &= success;
                    }
                my_continue = ((my_continue) && (fgets(this_line, 256, infile)));
                my_continue &= (!(strcnt(this_line, "##")));
                }
            fclose(infile);
            }
        }
    return success;
    }

void hint(void)
    {
    clear();
    read_random_excerpt(FILE_HINTS);
    fs_anykey();
    if (!(flag_check(game_variables->flags, DURING_INIT)))
        refresh_screen();
    }

void worship_service(void)
    {
    long my_continue;
    struct clist *traverse;
    clear();
    game_variables->fs_messages_printed = 0;
    my_continue = TRUE;
    if (my_continue)
        my_continue &= fs_pmsg("The smell of incense rises as the censer acknowledges all of the saints in the");
    if (my_continue)
        my_continue &= fs_pmsg("community -- the saints who have walked before and the saints who walk now.");
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= fs_pmsg("The celebrant speaks:");
    if (my_continue)
        my_continue &= read_random_excerpt(FILE_INVOCATIONS_TO_WORSHIP);
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= fs_pmsg("Music plays, as the congregation begins to sing:");
    if (my_continue)
        my_continue &= read_random_excerpt(FILE_HYMNS);
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= fs_pmsg("The celebrant speaks:");
    if (my_continue)
        my_continue &= fs_pmsg("\"Let us pray.");
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= read_random_excerpt(FILE_PRAYERS);
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= fs_pmsg("The scriptures are read:");
    if (my_continue)
        my_continue &= read_random_excerpt(FILE_SCRIPTURE_PASSAGES);
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= fs_pmsg("The celebrant speaks:");
    if (my_continue)
        my_continue &= read_random_excerpt(FILE_HOMILIES);
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= fs_pmsg("\"And now,\" the celebrant says, \"let us greet one another with a warm embrace.\"");
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        switch(player->identity)
            {
            case JANRA:
                switch(trandom() % 6)
                    {
                    case 0:
                        my_continue &= fs_pmsg("Those around you each grab your nose in turn.");
                    break;
                    case 1:
                        my_continue &= fs_pmsg("Those around you squeeze your sides.");
                        if (my_continue)
                            if (player->extended->gender == FEMALE)
                                my_continue &= fs_pmsg("You squeak loudly.");
                    break;
                    case 2:
                        my_continue &= fs_pmsg("Those around you give you gentle hugs.");
                    break;
                    case 3:
                        my_continue &= fs_pmsg("Those around you wrestle around with you a bit.");
                    break;
                    case 4:
                        my_continue &= fs_pmsg("Those around you give you butterfly kisses.");
                    break;
                    case 5:
                        my_continue &= fs_pmsg("Those around you give you soft kisses on the mouth.");
                    break;
                    }
            break;
            case JEC:
                my_continue &= fs_pmsg("Those around you stretch out their arms and say, \"I give you my love.\"");
            break;
            case NORKRIN:
                my_continue &= fs_pmsg("Those around you place their hands on your shoulder, and lowers his head");
                if (my_continue)
                    my_continue &= fs_pmsg("slightly in a gesture of respect.");
            break;
            case SHAL:
                my_continue &= fs_pmsg("Those around you give you soft snuggles.");
            break;
            case TUZ:
                my_continue &= fs_pmsg("Those around you give you crushing bear hugs.");
            break;
            case URVANOVESTILLI:
                my_continue &= fs_pmsg("Those around you raise their hands in benediction, and then give you three");
                if (my_continue)
                    my_continue &= fs_pmsg("kisses on alternate cheeks.");
            break;
            case YEDIDIA:
                my_continue &= fs_pmsg("Those around you give you soft, gentle hugs.");
            break;
            }
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= read_random_excerpt(FILE_COMMUNION);
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        {
        my_continue &= fs_pmsg("Go up to receive the body and blood?");
        if (my_continue)
            {
            if (confirm_silent_internal())
                {
                clear();
                switch(trandom() % 4)
                    {
                    case 0:
                        my_continue &= fs_pmsg("You partake of real food and real drink.");
                    break;
                    case 1:
                        my_continue &= fs_pmsg("You are mystically drawn into the presence of the Lord.");
                    break;
                    case 2:
                        my_continue &= fs_pmsg("You are filled with a hushed awe.");
                    break;
                    case 3:
                        my_continue &= fs_pmsg("In the gift, you are envelopped in communion.");
                    break;
                    }
                }
            else
                {
                clear();
                my_continue &= fs_pmsg("You remain where you are.");
                }
            }
        }
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= fs_pmsg("The gathering ends with the singing of a benediction.");
    if (my_continue)
        my_continue &= fs_pmsg("");
    if (my_continue)
        my_continue &= read_random_excerpt(FILE_BENEDICTIONS);
    fs_morewait();
    refresh_screen();
    /* Impart blessing to all characters on the level.  */
    if (current_level->creatures != NULL)
        for (traverse = current_level->creatures; (traverse != NULL); traverse
          = traverse->next)
        if (traverse->current != NULL)
            status_add(traverse->current, STATUS_MIRACLE_PROVIDENCE, 1);
    }

/* For use in cases where there will not be poor quality items.  */

void acquire_item(struct small_creature *c, long item_id)
    {
    struct small_item *this_item;
    this_item = generate_item(current_level, item_id);
    if (flag_check(this_item->flags, POOR_QUALITY))
        small_item_make_normal(this_item);
    wear_wield_internal(c, this_item);
    }

/* Pick a random attack string from those used by the character. */

void attack_str(char *message, struct small_creature *attacker, struct
  small_creature *attackee, long flags)
    {
    char attacker_title[256], attackee_title[256];
    long i, p, r, temp, max_message;
    /*
    long i, j, k, p, r, temp, max_message;
    struct clist *traverse;
    */
    find_title(attacker, attacker_title);
    find_title(attackee, attackee_title);
    i=0;
    strncpy(message, "default attack string", 255);
    message[255] = '\0';
    max_message = 1;
    if (flag_check(flags, ATTACK_IS_HTH))
        {
        if (attacker->extended == NULL)
            temp = master_creatures[attacker->identity].hand_to_hand_attack_messages;
        else
            temp = attacker->extended->hand_to_hand_attack_messages;
        max_message = MAX_HTH;
        }
    else /* missle attack */
        {
        if (attacker->extended == NULL)
            temp = master_creatures[attacker->identity].missle_attack_messages;
        else
            temp = attacker->extended->missle_attack_messages;
        max_message = MAX_MSL;
        }
    if (flag_check(flags, ATTACK_ONE_CRITICAL_SUCCESS))
        {
        if (attacker == player)
#ifdef HAS_SNPRINTF
            snprintf(message, 255, "%s smite %s!", attacker_title, attackee_title);
#else
            sprintf(message, "%s smite %s!", attacker_title, attackee_title);
#endif
        else
#ifdef HAS_SNPRINTF
            snprintf(message, 255, "%s smites %s!", attacker_title, attackee_title);
#else
            sprintf(message, "%s smites %s!", attacker_title, attackee_title);
#endif
        message[255] = '\0';
        }
    else if (flag_check(flags, ATTACK_TWO_CRITICAL_SUCCESSES))
        {
        if (attacker == player)
#ifdef HAS_SNPRINTF
            snprintf(message, 255, "%s smash %s!", attacker_title, attackee_title);
#else
            sprintf(message, "%s smash %s!", attacker_title, attackee_title);
#endif
        else
#ifdef HAS_SNPRINTF
            snprintf(message, 255, "%s smashes %s!", attacker_title, attackee_title);
#else
            sprintf(message, "%s smashes %s!", attacker_title, attackee_title);
#endif
        message[255] = '\0';
        }
    else if (flag_check(flags, ATTACK_THREE_CRITICAL_SUCCESSES))
        {
        if (attacker == player)
#ifdef HAS_SNPRINTF
            snprintf(message, 255, "%s annihilate %s!", attacker_title,
              attackee_title);
#else
            sprintf(message, "%s annihilate %s!", attacker_title,
              attackee_title);
#endif
        else
#ifdef HAS_SNPRINTF
            snprintf(message, 255, "%s annihilates %s!", attacker_title,
              attackee_title);
#else
            sprintf(message, "%s annihilates %s!", attacker_title,
              attackee_title);
#endif
        message[255] = '\0';
        }
    else
        {
        for(p=1;p<=max_message;p*=2)
            if (flag_check(temp, p))
                ++i;
        r=trandom()%i;
        i=0;
        for(p=1;p<=max_message;p*=2)
            if (flag_check(temp, p))
                {
                if (i==r)
                    {
                    if ((flag_check(flags, ATTACK_IS_HTH)) && (flag_check(flags,
                      ATTACK_HIT)) && (attacker == player))
                        switch(p)
                            {
                            case HITS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s hit %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s hit %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case STABS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s stab %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s stab %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case SLASHES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s slash %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s slash %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case CLAWS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s claw %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s claw %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case BITES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s bite %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s bite %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case SHOCKS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s shock %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s shock %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case BEATS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s beat %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s beat %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case GORES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s gore %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s gore %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case RAMS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s ram %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s ram %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case SLICES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s slice %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s slice %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case SQUEEZES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s squeeze %s.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s squeeze %s.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case STINGS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s sting %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s sting %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case TRAMPLES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s trample %s.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s trample %s.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            }
                    else if ((flag_check(flags, ATTACK_IS_HTH)) &&
                      (flag_check(flags, ATTACK_HIT)) &&
                      (attacker != player))
                        switch(p)
                            {
                            case HITS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s hits %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s hits %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case STABS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s stabs %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s stabs %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case SLASHES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s slashes %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s slashes %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case CLAWS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s claws %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s claws %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case BITES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s bites %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s bites %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case SHOCKS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s shocks %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s shocks %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case BEATS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s beats %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s beats %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case GORES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s gores %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s gores %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case RAMS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s rams %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s rams %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case SLICES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s slices %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s slices %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case SQUEEZES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s squeezes %s.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s squeezes %s.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case STINGS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s stings %s.", attacker_title,
                                  attackee_title);
#else
                                sprintf(message, "%s stings %s.", attacker_title,
                                  attackee_title);
#endif
                            break;
                            case TRAMPLES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s tramples %s.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s tramples %s.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            }
                    else if ((flag_check(flags, ATTACK_IS_MSL)) &&
                      (flag_check(flags, ATTACK_HIT)) &&
                      (attacker == player))
                        switch(p)
                            {
                            case MSL_HITS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s hit %s with a missle.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s hit %s with a missle.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case SHOOTS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s shoot %s.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s shoot %s.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case SPITS_ACID_ON:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s spit acid on %s.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s spit acid on %s.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case BREATHES_FIRE_ON:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s breathe fire on %s!",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s breathe fire on %s!",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case ENTANGLES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s entangle %s with a web!",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s entangle %s with a web!",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case ROCKET_HITS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s hit %s with a rocket!",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s hit %s with a rocket!",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case SHOOTS_WITH_ARROW:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s shoot %s with an arrow.", attacker_title, attackee_title);
#else
                                sprintf(message, "%s shoot %s with an arrow.", attacker_title, attackee_title);
#endif
                            break;
                            case SHOOTS_WITH_BOLT:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s shoot %s with a crossbow bolt.", attacker_title, attackee_title);
#else
                                sprintf(message, "%s shoot %s with a crossbow bolt.", attacker_title, attackee_title);
#endif
                            break;
                            case HITS_WITH_DART:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s hit %s with a dart.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s hit %s with a dart.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            }
                    else if ((flag_check(flags, ATTACK_IS_MSL)) &&
                      (flag_check(flags, ATTACK_HIT)) &&
                      (attacker != player))
                        switch(p)
                            {
                            case MSL_HITS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s hits %s with a missle.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s hits %s with a missle.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case SHOOTS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s shoots %s.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s shoots %s.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case SPITS_ACID_ON:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s spits acid on %s.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s spits acid on %s.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case BREATHES_FIRE_ON:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s breathes fire on %s!",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s breathes fire on %s!",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case ENTANGLES:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s entangles %s with a web!",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s entangles %s with a web!",
                                  attacker_title, attackee_title);
#endif
                            break;
                            case ROCKET_HITS:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s hits %s with a rocket!",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s hits %s with a rocket!",
                                  attacker_title, attackee_title);
#endif
                                /*
                                for(j = max(0, attackee->x - 1); j <=
                                  min(MAX_X - 1, attackee->x + 1); ++j)
                                    for(k = max(0, attackee->y - 1); k <=
                                      min(MAX_Y - 1, attackee->y + 1); ++k)
                                        if (j != attackee->x && k !=
                                          attackee->y)
                                            if (current_level->
                                              space[j][k].creatures != NULL)
                                                for (traverse = current_level->
                                                  space[j][k].creatures;
                                                  traverse != NULL; traverse =
                                                  traverse->next)
                                                    {
                                                    attack_msl(attacker,
                                                      attackee);
                                                    }
                                                    */
                            break;
                            case SHOOTS_WITH_ARROW:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s shoots %s with an arrow.", attacker_title, attackee_title);
#else
                                sprintf(message, "%s shoots %s with an arrow.", attacker_title, attackee_title);
#endif
                            break;
                            case SHOOTS_WITH_BOLT:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s shoots %s with a crossbow bolt.", attacker_title, attackee_title);
#else
                                sprintf(message, "%s shoots %s with a crossbow bolt.", attacker_title, attackee_title);
#endif
                            break;
                            case HITS_WITH_DART:
#ifdef HAS_SNPRINTF
                                snprintf(message, 255, "%s hits %s with a dart.",
                                  attacker_title, attackee_title);
#else
                                sprintf(message, "%s hits %s with a dart.",
                                  attacker_title, attackee_title);
#endif
                            break;
                            }
                    else if ((flag_check(flags, ATTACK_IS_HTH)) &&
                      (flag_check(flags, ATTACK_MISS)) && (attacker == player))
#ifdef HAS_SNPRINTF
                        snprintf(message, 255, "%s miss %s.", attacker_title,
                          attackee_title);
#else
                        sprintf(message, "%s miss %s.", attacker_title,
                          attackee_title);
#endif
                    else if ((flag_check(flags, ATTACK_IS_HTH)) &&
                      (flag_check(flags, ATTACK_MISS)) && (attacker != player))
#ifdef HAS_SNPRINTF
                        snprintf(message, 255, "%s misses %s.", attacker_title,
                          attackee_title);
#else
                        sprintf(message, "%s misses %s.", attacker_title,
                          attackee_title);
#endif
                    else if ((flag_check(flags, ATTACK_IS_MSL)) &&
                      (flag_check(flags, ATTACK_MISS)) && (attacker == player))
#ifdef HAS_SNPRINTF
                        snprintf(message, 255, "%s miss %s with a missle.",
                          attacker_title, attackee_title);
#else
                        sprintf(message, "%s miss %s with a missle.",
                          attacker_title, attackee_title);
#endif
                    else if ((flag_check(flags, ATTACK_IS_MSL)) &&
                      (flag_check(flags, ATTACK_MISS)) && (attacker != player))
#ifdef HAS_SNPRINTF
                        snprintf(message, 255, "%s misses %s with a missle.",
                          attacker_title, attackee_title);
#else
                        sprintf(message, "%s misses %s with a missle.",
                          attacker_title, attackee_title);
#endif
                    else
                        pmsg("Error in attack_str!");
                    message[255] = '\0';
                    }
                ++i;
                }
        }
    }
